procedure TgtsMainForm.RegleTimer;
var CodeDeltat : string;

Procedure AffecteCodeDeltat;
const bmax = 65535;
      tmax : array[boolean] of integer =
        (3200,1300);  // 32 765 pour gts2 ; 13 107 pour gti2
//  un facteur 10 prs pour 10 s
var bGTS,tGTS : integer;
begin // deltat = t*b s 
with BaseDeTemps do begin                                  
     deltat := deltat*1E5; // unit 10 s
     bGTS := 1;
     tGTS := trunc(deltat);
     if tGTS<1 then tGTS := 1;
     if tGTS>tmax[isGTI2] then begin
         tGTS := 100; { 1 ms }
         bGTS := round(deltat/tGTS);
         if bGTS<=0 then bGTS := 1;
         if bGTS>bmax then bGTS := bmax;
     end;
     codeDeltat := intToStr(tGTS*10)+' '+intToStr(bGTS);
     deltat := tGTS*bGTS;
     grapheGTS.CoeffInterp := 1/deltat;
     deltat := deltat*1.0E-5;
end end;

var voie : indiceVoie;
label fin;
begin with grapheGts do begin
   AffecteCodeDeltat;
   ordreProgramme := 'WPE '+intToStr(NbreVoie)+' '+
                            intToStr(NbreInter-baseDeTemps.NbrePreAcq)+' '+
                            codeDeltat;
   for voie := voieA to VoieAnaMax do with voieOrphy[voie] do
        if active then ordreProgramme := ordreProgramme+' '+codeVoie;
   case modeSynchro of
       s_front : if baseDeTemps.NbrePreAcq>0
           then ordreLanceR := 'WFPREAC '+intToStr(baseDeTemps.NbrePreAcq)+
                       ' '+frontSynchro
           else begin
              ordreLanceR := 'WGOFR '+frontSynchro;
              ordreLance := 'WGOF '+frontSynchro;
           end;
       s_seuil : setOrdreLance;
       s_sodar : ordreLance := 'WSODAR';
       else begin
           ordreLanceR := 'WGOR';
           ordreLance := 'WGO';
       end;
   end;
   fin :
   BaseDeTemps.DureeBalayage := BaseDeTemps.deltat*NbreInter;
end end; // regleTimer

Procedure TgtsMainForm.LanceAcqTemps;

Procedure LanceTemps;
var voie : indiceVoie;
    OrdreResul : shortString;
begin
    voieDebut := voieA;
    while (voieDebut<voieAnaMax) and not(grapheGts.VoieOrphy[VoieDebut].active)
          do inc(VoieDebut);
    voieCouranteTemps := voieDebut;
    for voie := voieAnaMax downto voieA do begin
        VoieSuivante[voie] := voieCouranteTemps;
        if grapheGts.VoieOrphy[voie].active then
           voieCouranteTemps := voie;
    end;
    OrdreResul := 'WRESUL 0 '+IntToStr(grapheGTS.NbreInter*grapheGTS.NbreVoie);
    if modeDeconnecte
      then begin
          GrapheGts.NbreCourant := 0;
          voieCouranteTemps := voieDebut;
          if isGTI2 then
             gti2.LanceThreadZresul(grapheGts.NbreVoie*grapheGts.NbreInter*2,
                                    grapheGts.NbreVoie); // 1 mot=2 octets
          etatAvail := eaResul;
          ecritOrphy(ordreResul);
      end
      else begin
          if isGTI2 then gti2.stopThreadZresul(false);
          ecritOrphy(ordreProgramme);
          GrapheGts.NbreCourant := 0;
          voieCouranteTemps := voieDebut;
          if isGTI2
             then gti2.LanceThreadZresul(grapheGts.NbreVoie*grapheGts.NbreInter*2,
                                         grapheGts.NbreVoie) // 1 mot=2 octets
             else voieSerie.FlushInBuffer;
          etatAvail := eaResul;
          sleep(10);
          ecritOrphy(ordreLanceR);
          if grapheGTS.modeSynchro=s_nerf then begin
             sleep(10);
             ecritOrphy(ordreResul);
          end;
      end;
      dureeLabel.visible := baseDeTemps.dureeBalayage>10;
      repereBtn.enabled := true;
      sondor.attenteDeltat := true;
end; // LanceTemps

Procedure LanceUnMega;
var i : integer;
begin with grapheGTS do begin
    NbreAff := NbreInter;
    NbreTrame := 10*NbreVoie*FreqMega;
    NbreParVoieParTrame := NbreInter div NbreTrame;
    DecaleMega := 10*FreqMega;
    dureeLabel.visible := false;
    repereBtn.visible := false;
    ordreLanceR := 'WMEGA '+
         intToStr(seuilSynchro)+' '+
         codeMontant[montant]+' '+
         intToStr(NbreVoie)+' '+
         intToStr(NbreParVoieParTrame)+' '+
         intToStr(FreqMega-1);
    NbreUnMega := 0;
    if PremiereAcquisition then for i := 0 to MaxVecteur do begin
          VoieOrphy[voieA].vecteurAff[i] := sansSignif;
          VoieOrphy[succ(voieA)].vecteurAff[i] := sansSignif;
    end;
    etatAvail := eaResulUnMega;
    ecritOrphy(ordreLanceR);
    MegaEnCours := true;
    AttenteMegaEnCours := true;
end end; // LanceUnMega 

begin
    etatAcq := eaAttenteResul;
    etatAvail := eaNone;
    timer.enabled := false;
    indexOctet := 0;
    GrapheGts.NbreCourant := 0;
    Gauge.position := 0;
    if AttenteMegaEnCours then begin
       while dureeEcoulee(debutAcquisition)<DureeAttenteUnMega do
          application.processMessages; // dlai de verif de synchro par GTS 2
       AttenteMegaEnCours := false;
    end
    else Application.ProcessMessages; // pour litPointAttente
    if MegaEnCours and not isGTI2 then begin // GTS2 uniquement
       repeat sleep(20)
       until not VoieSerie.CharReady;
// attends et vide la fin de l'acquisition
       MegaEnCours := false;
    end;
    grapheGTS.listeRepere.Clear;
    VideInBuffer;
    VoieSerie.onTriggerAvail := TriggerAvailBin;
    case grapheGTS.modeAcq of
         acqTemps : lanceTemps;
         acqUnMega : lanceUnMega;
    end;
    if not modeDeconnecte then debutAcquisition := now;
    DureeResulMax := grapheGTS.NbreInter*grapheGTS.NbreVoie*dureeResul[vitesseCom]+
                     BaseDeTemps.dureeBalayage+2;
    SynchroDetecte := false;                 
    Header.Panels[0].text := NomEtatAcq(eaAttenteResul);    
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    timer.enabled := true;
    Header.Panels[1].text := '';
end; // LanceAcqTemps

Procedure TgtsMainForm.DemandeResul;
var voie : indiceVoie;
    OrdreResul : shortString;
begin
    timer.enabled := false;
    etatAvail := eaNone;
    voieDebut := voieA;
    while (voieDebut<voieAnaMax) and not(grapheGts.VoieOrphy[VoieDebut].active)
          do inc(VoieDebut);
    voieCouranteTemps := voieDebut;
    for voie := voieAnaMax downto voieA do begin
        VoieSuivante[voie] := voieCouranteTemps;
        if grapheGts.VoieOrphy[voie].active then
           voieCouranteTemps := voie;
    end;
    OrdreResul := 'WRESUL 0 '+IntToStr(grapheGTS.NbreInter*grapheGTS.NbreVoie);
    if isGTI2 then
       gti2.LanceThreadZresul(grapheGts.NbreVoie*grapheGts.NbreInter*2,
                                    grapheGts.NbreVoie); // 1 mot=2 octets
    GrapheGts.NbreCourant := 0;
    voieCouranteTemps := voieDebut;
    etatAvail := eaResul;
    indexOctet := 0;
    VoieSerie.onTriggerAvail := TriggerAvailBin;
    etatAcq := eaAttenteResul;
    ecritOrphy(ordreResul);
    Gauge.position := 0;
    DureeResulMax := grapheGTS.NbreInter*grapheGTS.NbreVoie*dureeResul[vitesseCom]+
                     BaseDeTemps.dureeBalayage+2;
    SynchroDetecte := false;                 
    Header.Panels[0].text := NomEtatAcq(eaAttenteResul);    
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    timer.enabled := true;
    Header.Panels[1].text := '';
end; // DemandeResul

Procedure TgtsMainForm.LancePoincare;
var voie : indiceVoie;
begin
    timer.enabled := false;
    etatAvail := eaNone;
    effacePointCourant;
    grapheGTS.FrontSynchro := ansichar(ord('0')+FrontUD.position);
    ordreProgramme := 'WPE'+
                      ' '+intToStr(grapheGTS.NbreVoie)+
                      ' 2'+
                      ' 50'+
                      ' '+intToStr(grapheGTS.NbreVoie);
    for voie := voieA to VoieAnaMax do with grapheGTS.voieOrphy[voie] do
       if active then ordreProgramme := ordreProgramme+' '+codeVoie;
    ordreLanceR := 'WGOFR '+grapheGTS.frontSynchro;
    ordreLance := 'WGOF '+grapheGTS.frontSynchro;
    VoieSerie.onTriggerAvail := TriggerAvailBin;
    voieDebut := voieA;
    while (voieDebut<voieAnaMax) and not(grapheGts.VoieOrphy[VoieDebut].active)
          do inc(VoieDebut);
    voieCouranteTemps := voieDebut;
    for voie := voieAnaMax downto voieA do begin
        VoieSuivante[voie] := voieCouranteTemps;
        if grapheGts.VoieOrphy[voie].active then
           voieCouranteTemps := voie;
    end;
    etatAcq := eaAttenteResul;
    etatAvail := eaPoincare;
    indexOctet := 0;
    Gauge.position := 0;
    voieCouranteTemps := voieDebut;
    ecritOrphy(ordreProgramme);
    if isGTI2 then
        gti2.LanceThreadZresul(grapheGts.NbreVoie*2,grapheGts.NbreVoie); // 1 mot=2 octets
    GrapheGts.NbreCourant := 0;
    ecritOrphy(ordreLanceR);
    debutAcquisition := now;
    indexPointPoincare := 0;
    Header.Panels[0].text := hPoincare;
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    Header.Panels[1].text := hPoincare;
end; // LancePoincare 

Procedure TgtsMainForm.LanceAcqMagnum;
begin with grapheGTS do begin
    timer.enabled := false;
    if isGTI2 then gti2.flushInBuffer;
    indexOctet := 0;
    NbreAff := 0;
    Gauge.position := 0;
    Gauge.max := 256;
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    etatAcq := eaAttenteResul;
    Timer.interval := MajTimerMilliSec;
    etatAvail := eaMagnum;
    if magnum.chute then
         ecritOrphy('WCONFEF '+intToStr(magnum.EFi)+' M');
    ecritOrphy(magnum.codeMagnum);
    if isGTI2 then
       gti2.LanceThreadZresul(indexMagnumMax*2048,1);
    ecritOrphy('WCIRESUL');
    timer.enabled := true;
    oldNbreMagnum := 0;
    indexMagnum := 0;
    NbreCourant := 0;
    NbreAff := 0;
    NbreStopMagnum := 0;
    with voieOrphy[voieMagnum] do begin
        maxi := 64*magnum.TraitMagnumE;
        if Magnum.chute then mini := 0 else mini := -maxi;
    end;
    if MagnumAutoCB.checked
       then BaseDeTemps.DureeBalayage := MagnumSE.value
       else BaseDeTemps.DureeBalayage := 2;
    Header.Panels[0].text := trWaitResulMagnum;
    if MagnumStopDlg=nil then
       Application.CreateForm(TMagnumStopDlg, MagnumStopDlg);
    MagnumStopDlg.show;
end end; // LanceAcqMagnum

Procedure TgtsMainForm.LanceAcqSA;
begin
    timer.enabled := false;
    etatAcq := eaAttenteResul;
    GrapheGts.NbreCourant := 0;
    GrapheGts.NbreAff := 0;
    Gauge.position := 0;
    with sortieAnalogique do begin
         ecritOrphy('WDAC '+SAi+' '+intToStr(debutSortie[1]));
         ValeurCourante := valeurReal(debutSortie[1]);
         ValeurAff := valeurCourante;
    end;
    EnregistreBtn.visible := false;
    stopBtn.visible := true;
    ResetBtn.visible := false;
    timer.interval := sortieAnalogique.deltatSA;
    timer.enabled := true;
end; // LanceAcqSA 

Procedure TgtsMainForm.litFrequence;
var Fr : longWord;
begin with frequence do begin
    try
    Fr := getLongWord(commande);
    ErreurFreqBtn.visible := Fr=0;
    if Fr>0 then if FreqEA11
          then begin
             valeurCourante := 1/(Fr*DeltatWauto);
             ErreurFreqBtn.visible := valeurCourante<1;
          end
          else valeurCourante := 1/(Fr*DeltatWper[isGTI2]);
    except
       ErreurFreqBtn.visible := true;
    end;
    if ErreurFreqBtn.visible then if frequence.FreqEA11
           then ErreurFreqBtn.hint := erFrequenceEAD1
           else ErreurFreqBtn.hint := erFrequenceEF;
end end;

procedure TgtsMainForm.LitPointAttente;
var clavierEnCours : boolean;

Procedure litAna;
var voie : indiceVoie;
    mesure : integer;
    somme : double;
    i : integer;
begin
    if etatAcq=eaAttenteResul then exit;
    for voie := voieA to voieAnaMax do
        with grapheGts.voieOrphy[voie] do begin
        if active and
          ((indexCapteurAuto=0) or
            frequence.active or
            modeDeconnecte or
            clavierEnCours) then begin // sinon fait par Wreco
        mesure := getInt('WEA '+codeVoie);
        valeurCourante := valeurReal(mesure);
        if NbreMoyenne>1 then begin
            oldValeurs[indexDernier] := valeurCourante;
            indexDernier := (indexDernier+1) mod NbreMoyenne;
            somme := 0;
            for i := 0 to pred(NbreMoyenne) do
                if oldValeurs[i]<>sansSignif
                   then somme := somme+oldValeurs[i]
                   else somme := somme+valeurCourante;
            valeurCourante := somme/NbreMoyenne;
        end;
        if etatAcq=eaAttenteResul then break;
    end end;
end; // litAna

var voie : indiceVoie;
begin
   timer.enabled := false;
   clavierEnCours := (grapheGTS.modeAcq=AcqClavier) or
                     (grapheGTS.NbreAff=0);
   if not(modeDeconnecte) and
     (not(frequence.active) or not(frequence.FreqEA11)) and
// Wreco capteur perturbe frequence sur EAD1 ?
      avecReconnaissance and
      not(ClavierEnCours) and
      reconnaissance then begin
        afficheReglage;
        exit;
   end;
   if frequence.active
        then litFrequence
        else ErreurFreqBtn.visible := false;
   with magnum do if active and isCodeurInc then
       valeurCourante := valeurReal(getWord('WLPOSITION'));
   litAna;
   with voieCalculee do if active then
       valeurCourante := calcValeur;
   if etatAcq<>eaAttenteResul then begin
      effacePointCourant;
      for voie := succ(voieT) to voieMax do
          with grapheGts.voieOrphy[voie] do
             valeurAff := valeurCourante;
      marquePointCourant;
   end;
   ErreurSondorBtn.visible := false;
   if sondor.active and
      (etatAcq<>eaAttenteResul) then begin
         ecritOrphy(sondor.commande(grapheGTS.modeAcq));
         indexOctet := 0;
         etatAvail := eaSondor;
         timer.interval := majTimerSondor;
   end;
   timer.enabled := etatAcq<>eaAttenteResul;
end; // litPointAttente

Procedure TgtsMainForm.AjusteDeltat(modif : tModifBaseDeTemps);
var deltatMin : double;
    voie : indiceVoie;
begin with grapheGTS,baseDeTemps do begin
    NbreVoie := 0;
    verifSynchro;
    for voie := voieA to voieAnaMax do
       if voieOrphy[voie].active then inc(NbreVoie);
    case modeAcq of
         AcqTemps : if DureeBalayage>3600
           then NbreInter := trunc(DureeBalayage/Deltat)
           else begin
              Deltat := DureeBalayage/NbreInter;
              if Deltat>deltatMax then deltat := DeltatMax;
              DeltatMin := deltatOrphy*NbreVoie;
              if deltat<deltatMin then deltat := deltatMin;
              deltat := 1e-5*round(deltat/1e-5);
              case modif of
                   mDuree,mNbreVoies : NbreInter := trunc(DureeBalayage/deltat);
                   mNombre : DureeBalayage := NbreInter*deltat;
                   mDeltat,mFech : ;
              end;
           end;
       AcqUnMega : begin
       end;
       AcqCardiaque : deltat := 0.5;
   end;
end end;

procedure TgtsMainForm.ForceYbin;
begin
     ecritOrphy('WBIN');
     VoieSerie.OnTriggerAvail := TriggerAvailBin;
end;

procedure TgtsMainForm.SetOrdreLance;
begin with GrapheGTS do begin
     if baseDeTemps.NbrePreAcq>0
           then begin
               ordreLanceR := 'WAPREAC '+
                      intToStr(baseDeTemps.NbrePreAcq);
               if isGTI2 then
                  ordreLanceR := ordreLanceR+' '+
                                 intToStr(numSynchro);
               ordreLanceR := ordreLanceR+' '+
                              intTostr(SeuilSynchro)+' '+
                              codeMontant[montant];
           end
           else begin
                ordreLanceR := '';
                if isGTI2 then ordreLanceR := ' '+
                               intToStr(numSynchro);
                ordreLanceR := ordreLanceR+' '+
                               intToStr(seuilSynchro)+' '+
                               codeMontant[montant];
                if monocoup and
                   synchroMonocoupPermis and
                   not(isGTI2) then
                         ordreLanceR := ordreLanceR+' 1';
                ordreLance := 'WGOA'+ordreLanceR;
                ordreLanceR := 'WGOAR'+ordreLanceR;
           end;
end end;


