 {*********************************************************************************************************************
Valeurs des couleurs pour la reprsentation du spectre de la lumire blanche
380 nm < lambda < 780 nm
 *********************************************************************************************************************}

 unit chromato;

 interface

 uses graphics,winprocs;

 const	lambda_min = 380;	 { nm }
   			lambda_max = 780;

function lambda_color(lambda : double) : Tcolor;

implementation

 const	resolution = 5.0 ;
        gamma = 1.0;

 var cr, cg, cb : array[0..81] of double ;
     maxr, maxg, maxb : double ;


 function lambda_color(lambda : double) : Tcolor;
 var rr, gg, bb : integer;

 function accent(alpha : double) : byte ;
 begin
 	accent := trunc(255.91 * alpha)
 end ;

 FUNCTION accentG(alpha : DOUBLE) : LONGINT ;
 BEGIN
   IF alpha > 0
      THEN accentG := trunc(255.91 * exp(ln(alpha) / gamma))
      ELSE accentG := 0 ;
 END;

 var red, green, blue, coeff : double ;
     num : byte ;
 begin
	red := 0 ;
	green := 0 ;
	blue := 0 ;
	if (lambda >= lambda_min) and (lambda <= lambda_max) then begin
		num := trunc((lambda - lambda_min) / resolution) ;
		coeff := (lambda - lambda_min) / resolution - num ;
		red := cr[num] + (cr[num + 1] - cr[num]) * coeff ;
		green := cg[num] + (cg[num + 1] - cg[num]) * coeff ;
		blue := cb[num] + (cb[num + 1] - cb[num]) * coeff ;
	end ;
	rr := accent(red   / maxb) ;
	gg := accent(green / maxb) ;
	bb := accent(blue  / maxb) ;
  result := RGB(rr,gg,bb);
 end ;

 procedure init ;
 begin
	cr[ 0] := 0.0014 ; cg[ 0] := 0.0000 ; cb[ 0] := 0.0065 ;	cr[ 1] := 0.0022 ; cg[ 1] := 0.0001 ; cb[ 1] := 0.0105 ;
	cr[ 2] := 0.0042 ; cg[ 2] := 0.0001 ; cb[ 2] := 0.0201 ;	cr[ 3] := 0.0076 ; cg[ 3] := 0.0002 ; cb[ 3] := 0.0362 ;
	cr[ 4] := 0.0143 ; cg[ 4] := 0.0004 ; cb[ 4] := 0.0679 ;	cr[ 5] := 0.0232 ; cg[ 5] := 0.0006 ; cb[ 5] := 0.1102 ;
	cr[ 6] := 0.0435 ; cg[ 6] := 0.0012 ; cb[ 6] := 0.2074 ;	cr[ 7] := 0.0776 ; cg[ 7] := 0.0022 ; cb[ 7] := 0.3713 ;
	cr[ 8] := 0.1344 ; cg[ 8] := 0.0040 ; cb[ 8] := 0.6456 ;	cr[ 9] := 0.2148 ; cg[ 9] := 0.0073 ; cb[ 9] := 1.0391 ;

	cr[10] := 0.2839 ; cg[10] := 0.0116 ; cb[10] := 1.3856 ;	cr[11] := 0.3285 ; cg[11] := 0.0168 ; cb[11] := 1.6230 ;
	cr[12] := 0.3483 ; cg[12] := 0.0230 ; cb[12] := 1.7471 ;	cr[13] := 0.3481 ; cg[13] := 0.0298 ; cb[13] := 1.7826 ;
	cr[14] := 0.3362 ; cg[14] := 0.0380 ; cb[14] := 1.7721 ;	cr[15] := 0.3187 ; cg[15] := 0.0480 ; cb[15] := 1.7441 ;
	cr[16] := 0.2908 ; cg[16] := 0.0600 ; cb[16] := 1.6692 ;	cr[17] := 0.2511 ; cg[17] := 0.0739 ; cb[17] := 1.5281 ;
	cr[18] := 0.1954 ; cg[18] := 0.0910 ; cb[18] := 1.2876 ;	cr[19] := 0.1421 ; cg[19] := 0.1126 ; cb[19] := 1.0419 ;

	cr[20] := 0.0956 ; cg[20] := 0.1390 ; cb[20] := 0.8130 ;	cr[21] := 0.0580 ; cg[21] := 0.1693 ; cb[21] := 0.6162 ;
	cr[22] := 0.0320 ; cg[22] := 0.2080 ; cb[22] := 0.4652 ;	cr[23] := 0.0147 ; cg[23] := 0.2586 ; cb[23] := 0.3533 ;
	cr[24] := 0.0049 ; cg[24] := 0.3230 ; cb[24] := 0.2720 ;	cr[25] := 0.0024 ; cg[25] := 0.4073 ; cb[25] := 0.2123 ;
	cr[26] := 0.0093 ; cg[26] := 0.5030 ; cb[26] := 0.1582 ;	cr[27] := 0.0291 ; cg[27] := 0.6082 ; cb[27] := 0.1117 ;
	cr[28] := 0.0633 ; cg[28] := 0.7100 ; cb[28] := 0.0782 ;	cr[29] := 0.1096 ; cg[29] := 0.7932 ; cb[29] := 0.0573 ;

	cr[30] := 0.1655 ; cg[30] := 0.8620 ; cb[30] := 0.0422 ;	cr[31] := 0.2257 ; cg[31] := 0.9149 ; cb[31] := 0.0298 ;
	cr[32] := 0.2904 ; cg[32] := 0.9540 ; cb[32] := 0.0203 ;	cr[33] := 0.3597 ; cg[33] := 0.9803 ; cb[33] := 0.0134 ;
	cr[34] := 0.4334 ; cg[34] := 0.9950 ; cb[34] := 0.0087 ;	cr[35] := 0.5121 ; cg[35] := 1.0000 ; cb[35] := 0.0057 ;
	cr[36] := 0.5945 ; cg[36] := 0.9950 ; cb[36] := 0.0039 ;	cr[37] := 0.6784 ; cg[37] := 0.9786 ; cb[37] := 0.0027 ;
	cr[38] := 0.7621 ; cg[38] := 0.9520 ; cb[38] := 0.0021 ;	cr[39] := 0.8425 ; cg[39] := 0.9154 ; cb[39] := 0.0018 ;

	cr[40] := 0.9163 ; cg[40] := 0.8700 ; cb[40] := 0.0017 ;	cr[41] := 0.9786 ; cg[41] := 0.8163 ; cb[41] := 0.0014 ;
	cr[42] := 1.0263 ; cg[42] := 0.7570 ; cb[42] := 0.0011 ;	cr[43] := 1.0567 ; cg[43] := 0.6949 ; cb[43] := 0.0010 ;
	cr[44] := 1.0622 ; cg[44] := 0.6310 ; cb[44] := 0.0008 ;	cr[45] := 1.0456 ; cg[45] := 0.5668 ; cb[45] := 0.0006 ;
	cr[46] := 1.0026 ; cg[46] := 0.5030 ; cb[46] := 0.0003 ;	cr[47] := 0.9384 ; cg[47] := 0.4412 ; cb[47] := 0.0002 ;
	cr[48] := 0.8544 ; cg[48] := 0.3810 ; cb[48] := 0.0002 ;	cr[49] := 0.7514 ; cg[49] := 0.3210 ; cb[49] := 0.0001 ;

	cr[50] := 0.6424 ; cg[50] := 0.2650 ; cb[50] := 0.0000 ;	cr[51] := 0.5419 ; cg[51] := 0.2170 ; cb[51] := 0.0000 ;
	cr[52] := 0.4479 ; cg[52] := 0.1750 ; cb[52] := 0.0000 ;	cr[53] := 0.3608 ; cg[53] := 0.1382 ; cb[53] := 0.0000 ;
	cr[54] := 0.2835 ; cg[54] := 0.1070 ; cb[54] := 0.0000 ;	cr[55] := 0.2187 ; cg[55] := 0.0816 ; cb[55] := 0.0000 ;
	cr[56] := 0.1649 ; cg[56] := 0.0610 ; cb[56] := 0.0000 ;	cr[57] := 0.1212 ; cg[57] := 0.0446 ; cb[57] := 0.0000 ;
	cr[58] := 0.0874 ; cg[58] := 0.0320 ; cb[58] := 0.0000 ;	cr[59] := 0.0636 ; cg[59] := 0.0232 ; cb[59] := 0.0000 ;

	cr[60] := 0.0468 ; cg[60] := 0.0170 ; cb[60] := 0.0000 ;	cr[61] := 0.0329 ; cg[61] := 0.0119 ; cb[61] := 0.0000 ;
	cr[62] := 0.0227 ; cg[62] := 0.0082 ; cb[62] := 0.0000 ;	cr[63] := 0.0158 ; cg[63] := 0.0057 ; cb[63] := 0.0000 ;
	cr[64] := 0.0114 ; cg[64] := 0.0041 ; cb[64] := 0.0000 ;	cr[65] := 0.0081 ; cg[65] := 0.0029 ; cb[65] := 0.0000 ;
	cr[66] := 0.0058 ; cg[66] := 0.0021 ; cb[66] := 0.0000 ;	cr[67] := 0.0041 ; cg[67] := 0.0015 ; cb[67] := 0.0000 ;
	cr[68] := 0.0029 ; cg[68] := 0.0010 ; cb[68] := 0.0000 ;	cr[69] := 0.0020 ; cg[69] := 0.0007 ; cb[69] := 0.0000 ;

	cr[70] := 0.0014 ; cg[70] := 0.0005 ; cb[70] := 0.0000 ;	cr[71] := 0.0010 ; cg[71] := 0.0004 ; cb[71] := 0.0000 ;
	cr[72] := 0.0007 ; cg[72] := 0.0002 ; cb[72] := 0.0000 ;	cr[73] := 0.0005 ; cg[73] := 0.0002 ; cb[73] := 0.0000 ;
	cr[74] := 0.0003 ; cg[74] := 0.0001 ; cb[74] := 0.0000 ;	cr[75] := 0.0002 ; cg[75] := 0.0001 ; cb[75] := 0.0000 ;
	cr[76] := 0.0002 ; cg[76] := 0.0001 ; cb[76] := 0.0000 ;	cr[77] := 0.0001 ; cg[77] := 0.0000 ; cb[77] := 0.0000 ;
	cr[78] := 0.0001 ; cg[78] := 0.0000 ; cb[78] := 0.0000 ;	cr[79] := 0.0001 ; cg[79] := 0.0000 ; cb[79] := 0.0000 ;

	cr[80] := 0.0000 ; cg[80] := 0.0000 ; cb[80] := 0.0000 ;	cr[81] := 0.0000 ; cg[81] := 0.0000 ; cb[81] := 0.0000 ;

	maxr := 1.0622 ;
	maxg := 1.0000 ;
	maxb := 1.7826 ;
 end ;


 initialization
 	init
 end.


