unit CodeurDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Spin, ImgList, ComCtrls,
  gtsUtil, aideGTS2;

type
  TCodeurCfg = class(TForm)
    OKBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Timer: TTimer;
    Compteur: TLabel;
    LabelCompteur: TLabel;
    RazBtn: TBitBtn;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    EditMini: TEdit;
    EditMaxi: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    NomMagnumEdit: TEdit;
    Label2: TLabel;
    PasMagnumEdit: TEdit;
    Label3: TLabel;
    UniteEdit: TEdit;
    Label6: TLabel;
    EditSignif: TEdit;
    DesactiveBtn: TBitBtn;
    Memo: TMemo;
    Label7: TLabel;
    CouleurCombo: TColorBox;
    PointCombo: TComboBoxEx;
    ImagePoint: TImageList;
    EfrontCB: TComboBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure EfrontCBChange(Sender: TObject);
  private
  public
    modif : boolean;
  end;

var
  CodeurCfg: TCodeurCfg;

implementation

uses gtsdef, graphe, GtsMain;

{$R *.DFM}

procedure TCodeurCfg.OKBtnClick(Sender: TObject);
begin with magnum do begin
    Increment := GetFloat(PasMagnumEdit.text);
    nom := NomMagnumEdit.text;
    NomUnite := UniteEdit.text;
    Signif := EditSignif.text;
    couleur := CouleurCombo.selected;
    EFi := EFrontCB.itemIndex;
    motif := Tmotif(PointCombo.itemIndex);
    isCodeurInc := true;
    try
    mini := GetFloat(EditMini.text);
    except
    end;
    try
    maxi := GetFloat(EditMaxi.text);
    except
    end;
    modif := not active;
    active := true;
end end;

procedure TCodeurCfg.FormActivate(Sender: TObject);
begin with magnum do begin
    UniteEdit.text := nomUnite;
    NomMagnumEdit.text := Nom;
    EditSignif.text := Signif;
    CouleurCombo.selected := couleur;
    PointCombo.itemIndex := ord(motif);
    EditMini.text := FormatGTS(mini);
    EditMaxi.text := FormatGTS(maxi);
    PasMagnumEdit.text := FloatToStr(Increment);
    GtsMainForm.EcritOrphy('WRPOSITION');
    GtsMainForm.EcritOrphy(codeCodeurInc);
    timer.enabled := true;
    isCodeurInc := true;
    EFrontCB.itemIndex := EFi;
    modif := false;
end end;

procedure TCodeurCfg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_AcquisitionFou)
end;

procedure TCodeurCfg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     GtsMainForm.getWord('WPOSITION'); { dsactive }
     magnum.codeurActif := false;
     timer.enabled := false;
end;

procedure TCodeurCfg.TimerTimer(Sender: TObject);
var front : word;
begin
     front := GtsMainForm.getWord('WLPOSITION');
     labelCompteur.caption := magnum.NomValeurUnite(magnum.valeurReal(front));
end;

procedure TCodeurCfg.RazBtnClick(Sender: TObject);
begin
     GtsMainForm.ecritOrphy('WRPOSITION')
end;

procedure TCodeurCfg.DesactiveBtnClick(Sender: TObject);
begin
     modif := magnum.active;
     magnum.active := false;
end;

procedure TCodeurCfg.EfrontCBChange(Sender: TObject);
begin
    magnum.EFi := EFrontCB.itemIndex;
    GtsMainForm.EcritOrphy('WRPOSITION');
    GtsMainForm.EcritOrphy(magnum.codeCodeurInc);
end;

end.

