unit Efront;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, ComCtrls,
  constgts, maths, AdPort,
  graphe, gtsmain, gtsutil, gtsdef, FloatEdit, aidegts2;

type
  TEfrontDlg = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ActiveBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    HelpBtn: TBitBtn;
    FrontRG: TRadioGroup;
    GroupBox2: TGroupBox;
    LabelFront: TLabel;
    Fcourante: TEdit;
    LogCB: TCheckBox;
    Label3: TLabel;
    SeuilUD: TUpDown;
    LabelSeuil: TLabel;
    FrontUD: TUpDown;
    FreqAnaLabel: TLabel;
    MiniEdit: TFloatEdit;
    MaxiEdit: TFloatEdit;
    RazSeuilBtn: TSpeedButton;
    LabelFreq: TLabel;
    TestBtn: TBitBtn;
    procedure ActiveBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure MaxiEditChange(Sender: TObject);
    procedure MiniEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure FrontRGClick(Sender: TObject);
    procedure SeuilUDChanging(Sender: TObject; var AllowChange: Boolean);
    procedure FrontUDClick(Sender: TObject; Button: TUDBtnType);
    procedure RazSeuilBtnClick(Sender: TObject);
    procedure TestBtnClick(Sender: TObject);
  private
    index : integer;
    ValeurMot : pseudoWord;
    SauveTriggerAvail : TTriggerAvailEvent; 
    Procedure TriggerAvail(CP: TObject; Count: Word);
  public
    modif : boolean;
  end;

var
  EfrontDlg: TEfrontDlg;

implementation

{$R *.DFM}

procedure TEfrontDlg.ActiveBtnClick(Sender: TObject);
begin with frequence do begin
    modif := modif or not active;
    if not active then grapheGTS.voieAbscisse := voieF;
    active := true;
    miniF :=  miniEdit.value;
    maxiF :=  maxiEdit.value;
    frequence.AxeLog := LogCB.checked;
    seuil := seuilUD.position;
    if isGTI2 then FrontUD.Max := 3 else FrontUD.Max := 2 
end end;

procedure TEfrontDlg.DesactiveBtnClick(Sender: TObject);
begin
       if frequence.active then begin // arrt
          modif := true;
          GtsMainForm.ecritOrphy(frequence.stop);
       end;
       frequence.active := false;
end;

procedure TEfrontDlg.FormActivate(Sender: TObject);
begin with frequence do begin
       Timer.enabled := not isGTI2;
       TestBtn.Visible := isGTI2;
       Fcourante.text := '';

       MiniEdit.value := MiniF;
       MiniEdit.minValue := 0.1;
       MiniEdit.maxValue := MaxiF/10;

       MaxiEdit.value := MaxiF;
       MaxiEdit.minValue := MiniF*10;
       MaxiEdit.maxValue := 100000;

       if isGTI2 then begin
          seuilUD.max := 4000;
          seuilUD.min := 96;
          end
          else begin
             seuilUD.max := 240;
             seuilUD.min := 16;
          end;
       LogCB.checked := AxeLog;
       frontRG.itemIndex := ord(frequence.FreqEA11);
       frontUD.position := numVoie;
       seuilUD.position := seuil;
       if isGTI2 and freqEA11
          then begin
             LabelFront.caption  := 'EA'+intToStr(numVoie);
             frontUD.max := 11;
          end
          else begin
             if isGTI2
                then LabelFront.caption  := 'EF'+intToStr(numVoie)+' prise '+char(ord('G')+numVoie)
                else LabelFront.caption  := 'EF'+intToStr(numVoie);
             frontUD.max := 2;
          end;
       labelSeuil.Caption := trSeuil+' = '+FormatGTS(SeuilSynchroVolt(frequence.seuil))+' V';
       modif := false;
       SauveTriggerAvail := GtsMainForm.VoieSerie.onTriggerAvail;
       GtsMainForm.VoieSerie.onTriggerAvail := TriggerAvail;
       if isGTI2
          then frontRG.items[1] := 'Entre EA'
          else frontRG.items[1] := 'Entre EAD1'
end end;

procedure TEfrontDlg.FormDeactivate(Sender: TObject);
begin
     timer.enabled := false;
     GtsMainForm.VoieSerie.onTriggerAvail := SauveTriggerAvail;
end;

procedure TEfrontDlg.TestBtnClick(Sender: TObject);
var Fr : longWord;
	Erreur : boolean;
begin with frequence do begin
    try
    Fr := GtsMainForm.getLongWord(commande);
    Erreur := Fr=0;
    if Fr>0 then if FreqEA11
          then begin
             valeurCourante := 1/(Fr*DeltatWauto);
             Erreur := valeurCourante<1;
          end
          else valeurCourante := 1/(Fr*DeltatWper[isGTI2]);
    except
       Erreur := true;
    end;
    if Erreur then if frequence.FreqEA11
           then LabelFreq.caption := erFrequenceEAD1
           else LabelFreq.caption := erFrequenceEF
           else begin
               fcourante.text := frequence.AffVoltMetre;
               LabelFreq.caption := ''; 
           end;
end end;

procedure TEfrontDlg.TimerTimer(Sender: TObject);
begin
     if index<4
        then if frequence.FreqEA11
             then LabelFreq.caption := erFrequenceEAD1
             else LabelFreq.caption := erFrequenceEF
        else LabelFreq.caption := '';
     index := 0;
     GtsMainForm.EcritOrphy(frequence.commande);
end;

procedure TEfrontDlg.MaxiEditChange(Sender: TObject);
begin
     MiniEdit.maxValue := MaxiEdit.value/10;
     modif := true;
end;

procedure TEfrontDlg.MiniEditChange(Sender: TObject);
begin
     MaxiEdit.minValue := MiniEdit.value*10;
     modif := true;       
end;

procedure TEfrontDlg.RazSeuilBtnClick(Sender: TObject);
begin
    seuilUD.position := (seuilUD.Max+seuilUD.Min) div 2;
    labelSeuil.Caption := trSeuil+' = 0 V';
end;

procedure TEfrontDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Timer.enabled := false;
     GtsMainForm.VoieSerie.onTriggerAvail := SauveTriggerAvail;
end;

procedure TEfrontDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_MesureFrequence)
end;

procedure TEfrontDlg.FrontRGClick(Sender: TObject);
begin with frequence do begin
     GTSMainForm.ecritOrphy(stop);
     FreqEA11 := boolean(frontRG.itemIndex);
     frontUD.visible := not FreqEA11 or isGTI2;
     LabelFront.visible := not FreqEA11 or isGTI2;
     if isGTI2 and freqEA11
        then begin
           frontUD.Max := 11;
           LabelFront.caption := TitreVoieGTI2[connectiqueGTI2,FrontUD.Position]
        end
        else if isGTI2
              then begin
                 frontUD.Max := 3;
                 LabelFront.caption  := 'EF'+intToStr(numVoie)+' prise '+char(ord('G')+numVoie)
              end
              else begin
                 frontUD.Max := 2;
                 LabelFront.caption := 'EF'+intToStr(FrontUD.position);
              end;
     LabelSeuil.visible := FreqEA11;
     FreqAnaLabel.visible := FreqEA11;
     SeuilUD.visible := FreqEA11;
     modif := true;
end end;

procedure TEfrontDlg.SeuilUDChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  frequence.Seuil := SeuilUD.position;
  labelSeuil.Caption := trSeuil+' = '+FormatGTS(SeuilSynchroVolt(frequence.seuil))+' V';
end;

procedure TEfrontDlg.FrontUDClick(Sender: TObject; Button: TUDBtnType);
begin
   if isGTI2 and frequence.freqEA11
      then LabelFront.caption := TitreVoieGTI2[connectiqueGTI2,FrontUD.Position]
      else if isGTI2
           then LabelFront.caption  := 'EF'+intToStr(FrontUD.position)+' prise '+char(ord('G')+FrontUD.position)
           else LabelFront.caption := 'EF'+intToStr(FrontUD.position);
   Frequence.numVoie := FrontUD.position;
end;

Procedure TEfrontDlg.TriggerAvail(CP: TObject; Count: Word);
var Fr : longWord;
    i : integer;
begin with frequence do begin
    for i := 1 to count do
        if GTSMainForm.VoieSerie.CharReady then begin
            valeurMot.octets[index] := GTSMainForm.voieSerie.getChar;
            inc(index);
        end;
    if index=4 then begin
       LabelFreq.caption := '';
       Fr := ValeurMot.LongMot;
       if Fr=0
          then if frequence.FreqEA11
              then LabelFreq.caption := erFrequenceEAD1
              else LabelFreq.caption := erFrequenceEF
          else if FreqEA11
              then valeurAff := 1/(Fr*DeltatWauto)
              else valeurAff := 1/(Fr*DeltatWper[isGTI2]);
       fcourante.text := frequence.AffVoltMetre;
    end;
end end;

end.
