unit ETALONAuto;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, ooMisc, ComCtrls,
  maths, gtsutil, gtsdef, gtsmain, constgts, aidegts2;

type
  TEtalonneAutoDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    PotarTab: TTabControl;
    Memo: TMemo;
    EtalonBtn: TSpeedButton;
    EtalonLabel: TLabel;
    OKbtn: TBitBtn;
    Gauge: TProgressBar;
    PotarPB: TProgressBar;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PotarTabChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKbtnClick(Sender: TObject);
  private
    Pcourant : integer;
    indexCapteur : integer;
    codePotar : AnsiChar;
    sauveCodeUnite : indiceUniteAuto;
  public
    voieCourante : Tvoie;
  end;

var
  EtalonneAutoDlg: TEtalonneAutoDlg;

implementation

{$R *.DFM}


procedure TEtalonneAutoDlg.FormActivate(Sender: TObject);
var i : integer;
begin
     caption := 'Etalonnage capteur prise '+priseVoie[voieCourante.numOrphy];
     indexCapteur := voieCourante.indexCapteurAuto;
with listeCapteursAuto[indexCapteur] do begin
     sauveCodeUnite := codeUniteC;
     CodeUniteC := 0; // Etalonnage selon Doc Mecacel
     PotarTab.tabs.clear;
     for i := 0 to maxPotarAuto do
         if potarActif[i] then PotarTab.tabs.add(nomPotar[i]);
     PotarTab.TabIndex := 0;
     codePotar := numToCodePotar(voieCourante.numOrphy);
     PotarTabChange(nil);
     gauge.position := 0;
end end;

procedure TEtalonneAutoDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Etalonnage)
end;

procedure TEtalonneAutoDlg.PotarTabChange(Sender: TObject);
var N,i : integer;
begin
    N := 0;
    for i := 0 to maxPotarAuto do
        if ListeCapteursAuto[indexCapteur].potarActif[i] then begin
           if PotarTab.tabIndex=N then Pcourant := i;
           inc(N);
        end;
    memo.text := ListeCapteursAuto[indexCapteur].aidePotar[Pcourant];
    EtalonLabel.Visible := false;
    EtalonBtn.Enabled := true;
    EtalonBtn.visible := true;
    PotarPB.position := ListeCapteursAuto[indexCapteur].valeurPotar[Pcourant];
    gauge.position := 0;
end;

procedure TEtalonneAutoDlg.EtalonBtnClick(Sender: TObject);

function IsGreater(P : integer) : boolean;
const
    attenteMin = 5; { 0,5 seconde }
    attenteMax = 20; { 2 secondes }
var oldzi,i,zi : integer;
    zr : double;
begin with listeCapteursAuto[indexCapteur] do begin
     PotarPB.position := P; 
     GtsMainForm.EcritOrphy('WEPOTAR '+codePotar+' '+intToStr(Pcourant)+' '+intToStr(P));
     zi := 40000;
     i := 0;
     repeat
        oldzi := zi;
        delayTicks(2,false); // 2 pour tre sr d'en avoir 1 ! 
        zi := GtsMainForm.getInt('WEA '+intToStr(voieCourante.numOrphy));
        inc(i);
     until ((abs(zi-oldzi)<8) and (i>attenteMin)) or (i>attenteMax);
     zr := valeurReal(zi);
     result := zr>valeurAttendue[Pcourant];
end end;

var mini,maxi,testP,testV,i : integer;
    valeurCAN : double;
begin with ListeCapteursAuto[indexCapteur] do begin
      cursor := crHourGlass;
      EtalonBtn.Enabled := false;
      testP := valeurPotar[Pcourant];
      if isGreater(testP)
         then begin
            maxi := testP;
            mini := 0;
         end
         else begin
            mini := testP;
            maxi := 1024; // 2^10
         end;
      i := 0;
      repeat
           gauge.position := i;
           testP := (mini+maxi) div 2;
           if isGreater(testP)
              then maxi := testP
              else mini := testP;
           inc(i);
      until (maxi-mini)<2;
      if (testP>1020) or (testP<4)
          then GtsMainForm.EcritOrphy('WEPOTAR '+codePotar+
                            ' '+intToStr(Pcourant)+
                            ' '+intToStr(valeurPotar[Pcourant]))
          else valeurPotar[Pcourant] := testP; // on sauve
      GtsMainForm.EcritOrphy('WMPOTAR '+codePotar+' '+intToStr(Pcourant));
      if PCourant in [2,3] then begin
           delayTicks(2,false);
           testV := GtsMainForm.getInt('WEA '+intToStr(voieCourante.numOrphy));
           valeurCAN := voieCourante.ValeurVolt(testV);
           if PCourant=3 then
              voieCourante.UnVolt := (valeurAttendue[3]-offsetC[codeUniteC])/valeurCan;
           if PCourant=2 then // rsidu d'offset  corriger
              voieCourante.offset := valeurAttendue[2]-UnVoltC[codeUniteC]*valeurCan;
      end;
      EtalonBtn.visible := false;
      EtalonLabel.Visible := true;
      if (testP>1020) or (testP<4)
         then if PCourant in [2,3]
             then EtalonLabel.caption := 'Etalonnage logiciel'
             else EtalonLabel.caption := 'Etalonnage impossible'
         else EtalonLabel.caption := 'Etalonnage effectu';
      gauge.position := gauge.max;
      cursor := crDefault;
end end;

procedure TEtalonneAutoDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    ListeCapteursAuto[indexCapteur].codeUniteC := sauveCodeUnite
end;

procedure TEtalonneAutoDlg.OKbtnClick(Sender: TObject);
var rapport : double;
begin
     if sauveCodeUnite>0 then with ListeCapteursAuto[indexCapteur] do begin
        rapport := UnVoltC[codeUniteC]/UnVoltC[0];
        voieCourante.UnVolt := voieCourante.UnVolt*rapport;
        voieCourante.Offset := (OffsetC[codeUniteC]-OffsetC[0])+voieCourante.Offset*rapport;
     end;
end;

end.
