unit ETALONAutofige;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, ooMisc, ComCtrls,
  maths, gtsutil, gtsdef, gtsmain, constgts, aideGTS2;

type
  TEtalonneInterAutoDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LabelInteractif: TLabel;
    PotarTab: TTabControl;
    Memo: TMemo;
    EtalonBtn: TSpeedButton;
    EtalonLabel: TLabel;
    OKbtn: TBitBtn;
    Gauge: TProgressBar;
    Timer: TTimer;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure PotarTabChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
  private
    Pcourant : integer;
    indexCapteur : integer;
    valeurCan : array[indexPotar] of integer;
  public
    voieCourante : Tvoie;
  end;

var
  EtalonneInterAutoDlg: TEtalonneInterAutoDlg;

implementation

// cas du phmetre, on ne touche pas au potar du capteur
// mais au coefficient de conversion

{$R *.DFM}


procedure TEtalonneInterAutoDlg.FormActivate(Sender: TObject);
var i : integer;
begin
     indexCapteur := voieCourante.indexCapteurAuto;
with listeCapteursAuto[indexCapteur] do begin
     PotarTab.tabs.clear;
     for i := 0 to maxPotarAuto do begin
         if potarActif[i] then PotarTab.tabs.add(nomPotar[i]);
         valeurCan[i] := 0;
     end;
     PotarTab.TabIndex := 0;
     PotarTabChange(nil);
     timer.enabled := true;
end end;

procedure TEtalonneInterAutoDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Etalonnage)
end;

procedure TEtalonneInterAutoDlg.PotarTabChange(Sender: TObject);
var N,i : integer;
begin
    N := 0;
    for i := 0 to maxPotarAuto do
        if ListeCapteursAuto[indexCapteur].potarActif[i] then begin
           if PotarTab.tabIndex=N then Pcourant := i;
           inc(N);
        end;
    memo.text := ListeCapteursAuto[indexCapteur].aidePotar[Pcourant];
    EtalonLabel.Visible := valeurCan[Pcourant]<>0;
    EtalonBtn.visible := not EtalonLabel.Visible;
end;

procedure TEtalonneInterAutoDlg.EtalonBtnClick(Sender: TObject);
begin with ListeCapteursAuto[indexCapteur] do begin
      valeurCan[Pcourant] := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
      EtalonBtn.visible := valeurCan[Pcourant]=0;
      EtalonLabel.Visible := not EtalonBtn.visible;
end end;

procedure TEtalonneInterAutoDlg.TimerTimer(Sender: TObject);
begin
     Gauge.position := GtsMainForm.getInt('WEA '+voieCourante.codeVoie)
end;

procedure TEtalonneInterAutoDlg.OKbtnClick(Sender: TObject);
var valeurTension : array[indexPotar] of double;
begin with ListeCapteursAuto[indexCapteur] do begin
    if valeurCan[2]*valeurCan[3]<>0 then begin
        try
        valeurTension[2] := voieCourante.valeurVolt(valeurCan[2]);
        valeurTension[3] := voieCourante.valeurVolt(valeurCan[3]);
        voieCourante.UnVolt := (valeurAttendue[2]-valeurAttendue[3])/(valeurTension[2]-valeurTension[3]);
        voieCourante.Offset := valeurAttendue[2]-voieCourante.UnVolt*valeurTension[2];
        EtalonnageFait := true;
        except
        end;
    end;
end end;

procedure TEtalonneInterAutoDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TEtalonneInterAutoDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

end.
