unit FreqFiltreU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, ComCtrls,
  constgts, maths, AdPort,
  graphe, gtsmain, gtsutil, gtsdef, aidegts2;

type
  TFreqFiltreDlg = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    ActiveBtn: TBitBtn;
    HelpBtn: TBitBtn;
    LogCB: TCheckBox;
    FreqAnaLabel: TLabel;
    MiniEdit: TSpinEdit;
    MaxiEdit: TSpinEdit;
    EntreeRG: TRadioGroup;
    SortieRG: TRadioGroup;
    PhaseRG: TRadioGroup;
    DesactiveBtn: TBitBtn;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MaxiEditChange(Sender: TObject);
    procedure MiniEditChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
  private
    NumVoieAbs : array[0..voieMax] of indiceVoie;
  public
  end;

var
  FreqFiltreDlg: TFreqFiltreDlg;

implementation

{$R *.DFM}

procedure TFreqFiltreDlg.ActiveBtnClick(Sender: TObject);
begin
with frequence do begin
    miniF :=  miniEdit.value;
    maxiF :=  maxiEdit.value;
    AxeLog := LogCB.checked;
end;
    grapheGTS.VoieFiltreEntree := NumVoieAbs[EntreeRG.itemIndex];
    grapheGTS.VoieFiltreSortie := NumVoieAbs[SortieRG.itemIndex];
    grapheGTS.VoieFiltrePhase := NumVoieAbs[PhaseRG.itemIndex];
    grapheGTS.modeAcq := AcqFiltre;
end;

procedure TFreqFiltreDlg.FormActivate(Sender: TObject);

Procedure setNum;
var voie : integer;
    texte : string;
begin
     EntreeRG.items.clear;
     SortieRG.items.clear;
     PhaseRG.items.clear;
     for voie := voieA to voieAnaMax do with grapheGTS.voieOrphy[voie] do
     if active then begin
         if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<15
                   then texte := nom+' : '+signif
                   else texte := nom+' : '+copy(signif,1,12-length(nom))+'...';
        EntreeRG.items.Add(texte);
        SortieRG.items.Add(texte);
        PhaseRG.items.Add(texte);        
        numVoieAbs[pred(entreeRG.items.count)] := voie;
        if (voie=grapheGTS.voieFiltreEntree) then
            EntreeRG.itemIndex := pred(entreeRG.items.count);
        if (voie=grapheGTS.voieFiltreSortie) then
            SortieRG.itemIndex := pred(sortieRG.items.count);
        if (voie=grapheGTS.voieFiltrePhase) then
            PhaseRG.itemIndex := pred(phaseRG.items.count);
     end;
end;

begin
    with frequence do begin
       MiniEdit.value := round(MiniF);
       MiniEdit.maxValue := round(MaxiF/10);
       MaxiEdit.value := round(MaxiF);
       MaxiEdit.minValue := round(MiniF*10);
       LogCB.checked := AxeLog;
    end;
    setNum;
end;

procedure TFreqFiltreDlg.MaxiEditChange(Sender: TObject);
begin
    MiniEdit.maxValue := round(MaxiEdit.value/10)
end;

procedure TFreqFiltreDlg.MiniEditChange(Sender: TObject);
begin
    MaxiEdit.minValue := MiniEdit.value*10
end;

procedure TFreqFiltreDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_MesureFrequence)
end;

procedure TFreqFiltreDlg.DesactiveBtnClick(Sender: TObject);
begin
   grapheGTS.modeAcq := acqtemps
end;

end.
