unit GBF_GTI2_dlg;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons,
  maths, gtsdef, gtsUtil, gti2comp, gbf_gti2_comp,
  graphe, uniteker, ExtCtrls, constgts;

type
  TGBF_GTI2Form = class(TForm)
    SignalGB: TGroupBox;
    TriangleBtn: TSpeedButton;
    CarreBtn: TSpeedButton;
    SinusBtn: TSpeedButton;
    OffsetGB: TGroupBox;
    OffsetEdit: TEdit;
    OffsetScroll: TScrollBar;
    AmplitudeGB: TGroupBox;
    AmplitudeEdit: TEdit;
    AmplitudeScroll: TScrollBar;
    DutyGB: TGroupBox;
    DutyEdit: TEdit;
    DutyScroll: TScrollBar;
    FrequenceGB: TGroupBox;
    FrequenceSpin: TSpinButton;
    FrequenceEdit: TEdit;
    PanelCourbe: TPanel;
    Oscillo: TPaintBox;
    MajTimer: TTimer;
    MajBtn: TSpeedButton;
    procedure ParamChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SignalBtnClick(Sender: TObject);
    procedure FrequenceEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure FrequenceSpinDownClick(Sender: TObject);
    procedure FrequenceSpinUpClick(Sender: TObject);
    procedure FrequenceEditExit(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure MajTimerTimer(Sender: TObject);
    procedure MajBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    UniteVolt : Tunite;
    compteurGBF : integer;
    procedure ModifFrequence(down : boolean);
    Procedure MajSA;
  public
  end;

var
  GBF_GTI2Form: TGBF_GTI2Form;

implementation

uses GtsMain, modeDlg;

{$R *.DFM}

procedure TGBF_GTI2Form.ParamChange(Sender: TObject);
begin
    majSA;
end;

procedure TGBF_GTI2Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     MajTimer.enabled := false;
     caption := 'Gnrateur basse frquence sur G0';
     gbf_gti2.arret;
     GtsMainForm.GTBFItem.checked := false;
end;

procedure TGBF_GTI2Form.FormCreate(Sender: TObject);
begin
     UniteVolt := Tunite.create;
     UniteVolt.NomUnite := 'V';
     compteurGBF := 0;
end;

procedure TGBF_GTI2Form.SignalBtnClick(Sender: TObject);
begin
    MajSA
end;

procedure TGBF_GTI2Form.FrequenceEditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then FrequenceEditExit(sender)
end;

procedure TGBF_GTI2Form.FormActivate(Sender: TObject);
begin
     MajSA
end;

procedure TGBF_GTI2Form.FrequenceSpinDownClick(Sender: TObject);
begin
     ModifFrequence(true)
end;

procedure TGBF_GTI2Form.ModifFrequence(down : boolean);
var fr : integer;
begin
     fr := strToInt(frequenceEdit.text);
     if fr<100
        then if down
           then dec(fr)
           else inc(fr)
        else if down
           then fr := round(fr*0.95)
           else fr := round(fr*1.05);
     if fr<10 then fr := 10;
     frequenceEdit.text := intToStr(fr);
     MajSA;
end;

procedure TGBF_GTI2Form.FrequenceSpinUpClick(Sender: TObject);
begin
     ModifFrequence(false)
end;

procedure TGBF_GTI2Form.FrequenceEditExit(Sender: TObject);
begin
    MajSA
end;

procedure TGBF_GTI2Form.OscilloPaint(Sender: TObject);
begin
     gbf_gti2.Frequence := StrToInt(FrequenceEdit.text);
     if TriangleBtn.down then gbf_gti2.signal := sTriangle;
     if SinusBtn.down then gbf_gti2.signal := sSinus;
     if CarreBtn.down then gbf_gti2.signal := sCarre;
     gbf_gti2.amplitude := AmplitudeScroll.position*10/(AmplitudeScroll.max+2); // +- 10 V
     gbf_gti2.offset := OffsetScroll.position*5/OffsetScroll.max;
     gbf_gti2.Duty := DutyScroll.position/100;
     gbf_gti2.calculValeur;
     gbf_gti2.Paint(Oscillo.canvas,Oscillo.width,Oscillo.height);
     FrequenceEdit.text := intToStr(gbf_gti2.frequence); // valeur exacte
end;

procedure TGBF_GTI2Form.MajTimerTimer(Sender: TObject);
begin
    inc(compteurGBF);
    if (compteurGBF*MajTimer.Interval>3000) and
        majBtn.enabled then majBtnClick(sender);
    if MajBtn.enabled
       then if MajBtn.layout=blGlyphRight
            then MajBtn.layout := blGlyphLeft
            else MajBtn.layout := blGlyphRight
       else begin
          MajTimer.enabled := false;
          caption := 'Gnrateur basse frquence sur G0';
       end;
end;

procedure TGBF_GTI2Form.MajSA;
begin
   MajBtn.enabled := true;
   MajTimer.enabled := true;
   compteurGBF := 0;
   caption := 'Cliquer sur Mj pour lancer le GBF sur G0';
   OffsetGB.caption := trOffset;
   OffsetEdit.text := uniteVolt.formatUnite(OffsetScroll.position*10/OffsetScroll.Max);
   DutyEdit.text := IntToStr(DutyScroll.position)+'%';
   AmplitudeEdit.text := uniteVolt.formatUnite(AmplitudeScroll.position*10/(AmplitudeScroll.max-2));
   oscillo.refresh;
end;

procedure TGBF_GTI2Form.MajBtnClick(Sender: TObject);
begin
     enabled := false;
     MajSA;
     GtsMainForm.DebutLectureParametres;
     gbf_gti2.marche;
     GtsMainForm.FinLectureParametres;
     MajBtn.enabled := false;
     enabled := true;
end;

procedure TGBF_GTI2Form.FormDestroy(Sender: TObject);
begin
   GBF_GTI2form := nil
end;

end.
