unit GBF_gti2_comp;

interface                                        

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, spin, StdCtrls, Buttons, inifiles, gti2comp,
  maths, gtsUtil, uniteker, ExtCtrls, gtsConst;
                                                              
const
        MaxiGBF = 16384; // 14 bits
        ZeroGBF = 8192; // la moiti
        GammeGBF = 20; // +-10 V
        NbreMaxGBF = 16000;

type
  Tsignal = (sCarre,sTriangle,sSinus);
  indiceVecteurGBF = 0..NbreMaxGBF;
  TGBF_GTI2 = class
     private
     data : vecteurGBF;
     public
     Frequence : integer;
     Amplitude,Offset,Duty : double;
     signal  : Tsignal;
     Procedure CalculValeur;
     Procedure Marche;
     Procedure Arret;
     procedure Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
  end;

var GBF_gti2 : Tgbf_gti2;

implementation

Procedure TGBF_GTI2.CalculValeur;

// 3FFF donc 16384 correspond  -10V
// 2000 donc 8192 correspond a 0V
// 0 correspond  +10V

function valeurI(valeurR : double) : integer;
begin
     result := round(-valeurR*MaxiGBF/gammeGBF)+zeroGBF;
     if result<0 then result := 0;
     if result>MaxiGBF then result := maxiGBF;
end;

var valeurR,deltat,pente,Atriangle : double;
    posDuty,i : integer;
begin
     gti2.freqGBF := frequence;
     deltat := 1/gti2.NbreGBF;
     frequence := gti2.freqGBF; // valeur exacte
     case signal of
        sSinus : for i := 0 to pred(gti2.NbreGBF) do begin
              valeurR := Amplitude*sin(2*pi*i*deltat);
              data[i] := valeurI(valeurR+Offset);
        end;
        else begin
          PosDuty := round(gti2.NbreGBF*Duty);
          if posDuty<2 then posDuty := 2;
          if posDuty>(gti2.NbreGBF-2) then posDuty := gti2.NbreGBF-2;
          pente := Amplitude*2.0/posDuty;
          for i := 0 to posDuty do begin
              if signal=sCarre
                 then valeurR := -Amplitude
                 else valeurR := -Amplitude+i*pente;
              data[i] := valeurI(valeurR+Offset);
          end;
          pente := Amplitude*2.0/(gti2.nbreGBF-posDuty);
          Atriangle  := Amplitude+posDuty*pente;
          for i := succ(posDuty) to pred(gti2.nbreGBF) do begin
              if signal=sCarre
                 then valeurR := +Amplitude
                 else valeurR := +Atriangle-i*pente;
              data[i] := valeurI(valeurR+Offset);
          end;
        end;
     end;
     for i := gti2.nbreGBF to NbreMaxGBF do data[i] := 0
end;

procedure TGBF_GTI2.Marche;
begin
     gti2.lanceGenerateur(data)
end;

procedure TGBF_GTI2.Arret;
begin
     gti2.stopGenerateur
end;

procedure TGBF_GTI2.Paint(Acanvas : Tcanvas;largeur,hauteur : integer);
var i : indiceVecteur;
    xi,yi : integer;
    AX,AY : double;
begin with Acanvas do begin
     brush.Style := bsSolid;
     brush.color := clWindow;
     pen.width := 1;
     pen.style := psSolid;
     pen.color := clBlack;
     rectangle(0,0,largeur,hauteur);
     pen.color := clBlue;
     AX := largeur/gti2.NbreGBF/2;
     AY := hauteur/maxiGBF;
     yi := round(AY*data[0]);
     MoveTo(0,yi);
     for i := 0 to pred(gti2.NbreGBF) do begin
        yi := round(AY*data[i]);
        xi := round(AX*i);
        LineTo(xi,yi);
     end;{for i}
     for i := 0 to pred(gti2.NbreGBF) do begin
        yi := round(AY*data[i]);
        xi := round(AX*(i+gti2.NbreGBF));
        LineTo(xi,yi);
     end;{for i}
// zro
     MoveTo(0,hauteur div 2);
     pen.style := psDot;
     pen.color := clBlack;
     LineTo(largeur,hauteur div 2);
// prvenir deux priodes
     xi := round(AX*gti2.NbreGBF/2);
     font.color := clRed;
     TextOut(xi,4,'Deux priodes');
end end;

initialization
  gbf_GTI2 := tgbf_GTI2.create;

finalization
  gbf_GTI2.Free;

end.


