unit GTSCFG;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs, ImgList, ComCtrls,
  gtsUtil, gtsDef, graphe, gtsmain, maths,
  listecap, etalon, constgts, aidegts2;

type
  TOrphyGtsDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    Bevel1: TBevel;
    EntreeCB: TComboBox;
    CapteursBtn: TBitBtn;
    DesactiveBtn: TBitBtn;
    Timer: TTimer;
    EtalonnageGB: TGroupBox;
    EtalonneInterBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditSignif: TEdit;
    Label3: TLabel;
    AffichageGB: TGroupBox;
    EditValeur: TEdit;
    Label6: TLabel;
    Bevel2: TBevel;
    Label0V: TLabel;
    val0Edit: TEdit;
    PenteEdit: TEdit;
    PenteLabel: TLabel;
    PanelCalibre: TPanel;
    PanelMaxi: TPanel;
    PanelMini: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    SplitterMaxi: TSplitter;
    SplitterMini: TSplitter;
    AvecPotarLabel: TLabel;
    Panel1: TPanel;
    EtalonCB: TCheckBox;
    CouleurCombo: TColorBox;
    ExpressionLabel: TLabel;
    NonLineaireCB: TCheckBox;
    EADLabel: TLabel;
    EADbtn: TSpeedButton;
    LabelAide: TLabel;
    BoitierRaccordLabel: TLabel;
    ExempleLabel: TLabel;
    ExpressionEdit: TLabeledEdit;
    ZeroBtn: TBitBtn;
    PointCombo: TComboBoxEx;
    CalibreCB: TComboBox;
    SigneCB: TCheckBox;
    MoyennePanel: TPanel;
    Label4: TLabel;
    MoyenneSE: TSpinEdit;
    Label5: TLabel;
    Gauge: TProgressBar;
    EtalonBtn: TBitBtn;
    EtalonAutoLabel: TLabel;
    EditMini: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    UniteBisLB: TComboBox;
    AideBtn: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure EtalonBtnClick(Sender: TObject);
    procedure EtalonneInterBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure ManuelGridClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EditMiniKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMaxiKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EntreeCBChange(Sender: TObject);
    procedure setSplitter;
    procedure EditMiniExit(Sender: TObject);
    procedure EditMaxiKeyPress(Sender: TObject; var Key: Char);
    procedure SplitterMaxiCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure SplitterMiniCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
    procedure SplitterMiniMoved(Sender: TObject);
    procedure SplitterMaxiMoved(Sender: TObject);
    procedure EtalonRGClick(Sender: TObject);
    procedure val0EditExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PanelMaxiClick(Sender: TObject);
    procedure val0EditKeyPress(Sender: TObject; var Key: Char);
    procedure EditMiniKeyPress(Sender: TObject; var Key: Char);
    procedure ExpressionEditExit(Sender: TObject);
    procedure NonLineaireCBClick(Sender: TObject);
    procedure EADbtnClick(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure CalibreCBChange(Sender: TObject);
    procedure SigneCBClick(Sender: TObject);
    procedure ExpressionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CapteursBtnClick(Sender: TObject);
    procedure UniteBisLBChange(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
  private
    oldNum : integer;
    oldActive : boolean;
    voieVolt,voieCapteur : Tvoie;
    function CalculEtalonManuel : boolean;
    procedure SetEtalonnage;
  public
    voieCourante : Tvoie;
    modif : boolean;
  end;

var
  OrphyGtsDlg: TOrphyGtsDlg;

implementation

uses ETALONAuto, photocolorU, lumicolorU, ETALONAutofige, gbf_syntaxe,
  OxymetreU;

{$R *.DFM}

const maxCalibre = 6;
      Calibre : array[0..maxCalibre] of double = (10,5,2,1,0.5,0.2,0.1);

procedure TOrphyGtsDlg.FormActivate(Sender: TObject);
var i : integer;
begin
          if isGTI2 then begin
             entreeCB.Items.Clear;
             for i := 0 to 11 do
                 entreeCB.Items.Add(TitreVoieGTI2[connectiqueGTI2,i]);
          end;
with voieCourante do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          LabelAide.caption := Aide;
          EntreeCB.ItemIndex := numOrphy;
          EntreeCB.enabled := grapheGTS.modeAcq<>AcqUnMega;
          DesactiveBtn.enabled := (grapheGTS.modeAcq<>AcqUnMega) or (numOrphy=10);
          oldNum := numOrphy;
          oldActive := active;
          uniteBisLB.Visible := (indexCapteurAuto>0) and
                                (ListeCapteursAuto[indexCapteurAuto].nbreUniteBis>0);
          if indexCapteurAuto=0
             then caption := 'Entre analogique'
             else with ListeCapteursAuto[indexCapteurAuto] do
                       caption := 'Capteur : '+signifC[codeUniteC];
          if uniteBisLB.Visible then with ListeCapteursAuto[indexCapteurAuto] do begin
             uniteBisLB.clear;
             for i := 0 to NbreUniteBis do
                 uniteBisLB.items.add(nomC[i]+' '+nomUniteC[i]);
             uniteBisLB.itemIndex := codeUniteC;
             uniteBisLB.text := uniteBisLB.items[codeUniteC];
          end;
          EtalonCB.visible := indexCapteurAuto=0;
          EntreeCB.enabled := indexCapteurAuto=0;
          EditUnite.enabled := indexCapteurAuto=0;
          DesactiveBtn.visible := indexCapteurAuto=0;
          if indexCapteurAuto=0
             then OKBtn.Caption := trActiver
             else OKBtn.Caption := '&OK';
          EtalonCB.checked := avecCapteur;
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          MoyenneSE.value := NbreMoyenne;
          EditMini.text := FormatGTS(mini);
          EditMaxi.text := FormatGTS(maxi);
          val0Edit.text := FormatGts(offset);
          penteEdit.text := FormatGts(unVolt);
          penteLabel.caption := deltaMaj+nom+'/'+DeltaMaj+'V ('+
              nomUnite+'/V)';
          if avecCapteur
             then begin
                  voieCapteur.mini := mini;
                  voieCapteur.maxi := maxi;
                  voieCapteur.nomUnite := nomUnite;
                  voieCapteur.signif := signif;
                  voieCapteur.aide := aide;
             end
             else begin
                  voieVolt.mini := mini;
                  voieVolt.maxi := maxi;
                  voieVolt.signif := signif;
             end;
          EtalonBtn.Visible := (indexCapteurAuto>0) or
                               isPhotocolor or isLumicolor or isLumicolorDB15;
          CapteursBtn.Visible := indexCapteurAuto=0;
          NonLineaireCB.checked := capteurNonLin;
          ExpressionEdit.text := expression;
          eadlabel.Visible := ((numOrphy=10) or (numOrphy=11))
               and (indexCapteurAuto=0);
          boitierRaccordLabel.Visible := (numOrphy<4);
          eadBtn.Visible := eadLabel.Visible;
          signeCB.Checked := mini>=0;
          EtalonAutoLabel.Visible := (indexCapteurAuto>0) and
            not listeCapteursAuto[indexCapteurAuto].EtalonnageFait;
          MoyennePanel.visible := grapheGTS.modeAcq in [AcqClavier,AcqPoint];
          SetEtalonnage;
          setSplitter;
          editValeur.Text := '';
          Timer.enabled := gtsMainForm.orphyPresent;
          modif := false;
end end;

procedure TOrphyGtsDlg.SetEtalonnage;
const
   strCalibre : array[boolean,0..maxCalibre] of string =
     (('10 V','5 V','2 V','1 V','500 mV','200 mV','100 mV'),
      ('0-10 V','0-5 V','0-2 V','0-1 V','0-500 mV','0-200 mV','0-100 mV'));

var oldCapteur : boolean;
    capteurLin : boolean;
    i : integer;
    hauteur : integer;
begin with voieCourante do begin
     PanelCalibre.Visible := (EtalonCB.checked and not CapteurNonLin) or
                             (indexCapteurAuto>0);
     EtalonnageGB.visible := EtalonCB.checked;
     EditMini.Visible := PanelCalibre.Visible or capteurNonLin;
     EditMaxi.Visible := EditMini.Visible;
     CalibreCB.Visible := not EtalonCB.checked and (indexCapteurAuto=0);
     SigneCB.Visible := CalibreCB.Visible;
     hauteur := 490+(height-clientHeight);
     if not MoyennePanel.Visible then
        hauteur := hauteur-MoyennePanel.height;
     if not EtalonnageGB.visible
        then hauteur := hauteur-EtalonnageGB.height;
     height := hauteur;
     capteurLin := EtalonCB.checked and not NonLineaireCB.checked;
     label0V.visible := capteurLin;
     val0edit.visible := capteurLin;
     penteLabel.visible := capteurLin;
     penteEdit.visible := capteurLin;
     oldCapteur := avecCapteur;
     avecCapteur := EtalonCB.checked;
     if not avecCapteur then begin
        calibreCB.Items.clear;
        isPhotocolor := false;
        isLumicolor := false;
        isLumicolorDB15 := false;  
        for i := 0 to maxCalibre do
            calibreCB.Items.add(strCalibre[signeCB.checked,i]);
        calibreCB.ItemIndex := 0;
        for i := 0 to maxCalibre do
            if abs((maxi-calibre[i])/calibre[i])<0.2 then begin
               calibreCB.ItemIndex := i;
               break
            end;
     end;
     if oldCapteur<>avecCapteur then
        if avecCapteur
           then begin
              voieVolt.mini := mini;
              voieVolt.maxi := maxi;
              voieVolt.signif := EditSignif.text;
              EditUnite.text := voieCapteur.nomUnite;
              EditMini.text := formatGTS(voieCapteur.mini);
              mini := voieCapteur.mini;
              EditMaxi.text := formatGTS(voieCapteur.maxi);
              maxi := voieCapteur.maxi;
              EditSignif.text := voieCapteur.signif;
              CalculEtalonManuel;
              setSplitter;
           end
           else begin
              voieCapteur.mini := mini;
              voieCapteur.maxi := maxi;
              voieCapteur.nomUnite := EditUnite.text;
              voieCapteur.signif := EditSignif.text;
              EditUnite.text := 'V';
              isPhotocolor := false;
              isLumicolor := false;
              isLumicolorDB15 := false;
              EditMini.text := formatGTS(voieVolt.mini);
              mini := voieVolt.mini;
              EditMaxi.text := formatGTS(voieVolt.maxi);
              maxi := voieVolt.maxi;
              EditSignif.text := voieVolt.signif;
              setSplitter;
           end;
     ExpressionEdit.Visible := EtalonCB.checked and NonLineaireCB.checked;
     AideBtn.Visible := ExpressionEdit.Visible; 
     ExpressionLabel.Visible := ExpressionEdit.Visible;
     ExempleLabel.Visible := ExpressionEdit.Visible;
     ExpressionEdit.EditLabel.caption := EditNom.Text+'=';
     EtalonneInterBtn.Visible := EtalonCB.checked and not NonLineaireCB.checked;
     ZeroBtn.Visible := EtalonCB.checked and
        not NonLineaireCB.checked and
        avecCapteur;
     AvecPotarLabel.visible := avecPotar and avecCapteur;
end end;

procedure TOrphyGtsDlg.OKBtnClick(Sender: TObject);
var i : integer;
begin with voieCourante do begin
     timer.enabled := false;
     modif := modif or
          not oldActive or
          (oldNum<>EntreeCB.ItemIndex);
          AvecCapteur := EtalonCB.checked;
          Nom := EditNom.text;
          if avecCapteur or (indexCapteurAuto>0)
             then NomUnite := EditUnite.text
             else NomUnite := 'V';
          numOrphy := EntreeCB.ItemIndex;
          if avecCapteur and (nomUnite='T')
             then if numOrphy<10
                then offset := -0.2  // direct 
                else offset := 0;  // avec adaptateur GTI
          Signif := EditSignif.text;
          active := true;
          if avecCapteur or (indexCapteurAuto>0)
              then maxi := GetFloat(EditMaxi.text);
          if (maxi=sansSignif) then maxi := 10;
          if avecCapteur or (indexCapteurAuto>0)
              then mini := GetFloat(EditMini.text);
          if (mini=sansSignif) then mini := 10;
          if not(avecCapteur) and (indexCApteurAuto=0) then begin
             if maxi>+10 then maxi := +10;
             if mini<-10 then mini := -10;
          end;
          setMinMax;
          couleur := CouleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
          if (not avecCapteur) and
             (indexCapteurAuto=0) then expression := '';
          if (indexCapteurAuto>0) and
             (ListeCapteursAuto[indexCapteurAuto].codeUniteC=0) then expression := '';
          if nonLineaireCB.checked and
             etalonnageGB.visible then expression := expressionEdit.text;
          if modif then
              for i := 0 to maxMoyenne do
                  oldValeurs[i] := sansSignif;
          NbreMoyenne := MoyenneSE.value;       
     end;
end;

procedure TOrphyGtsDlg.DesactiveBtnClick(Sender: TObject);
begin
      modif := oldActive;
      voieCourante.active := false;
      modalResult := mrOK;
      close;
end;

procedure TOrphyGtsDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TOrphyGtsDlg.TimerTimer(Sender: TObject);
var valeur : integer;
begin
     try
     valeur := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
     Gauge.position := valeur;
     with voieCourante do
          EditValeur.text := formatGTS(valeurReal(valeur))+' '+nomUnite;
     if panelCalibre.visible then begin
        if splitterMaxi.top<valeur then splitterMaxi.top := valeur;
        if splitterMini.top>valeur then splitterMini.top := valeur;
     end;   
     except
         Gauge.position := 0
     end;
end;

procedure TOrphyGtsDlg.EditNomChange(Sender: TObject);
begin
     penteLabel.caption := deltaMaj+EditNom.text+'/'+DeltaMaj+'V ('+
        EditUnite.text+'/V)';
     AffichageGB.caption := trAffichage+EditUnite.text;
     ExpressionEdit.EditLabel.caption := EditNom.Text+'=';
end;

function TOrphyGtsDlg.CalculEtalonManuel : boolean;
begin with voieCourante do begin
      try
          Offset := GetFloat(val0Edit.text);
          UnVolt := GetFloat(penteEdit.text);
          result := true;
      except
          afficheErreur(erNombre);
          result := false;
      end;
end end;

procedure TOrphyGtsDlg.EtalonBtnClick(Sender: TObject);
var j : integer;
    codePotar : AnsiChar;
begin
     timer.enabled := false;
     EditValeur.text := '';
     if voieCourante.indexCapteurAuto=indexCapteurOxygene then begin
           OxymetreEtalon := TOxymetreEtalon.create(self);
           OxymetreEtalon.voieCourante := voieCourante;
           OxymetreEtalon.showModal;
           OxymetreEtalon.free;
           exit;
     end;
     if voieCourante.isPhotocolor then begin
        if PhotocolorDlg=nil then
           Application.CreateForm(TPhotocolorDlg, PhotocolorDlg);
        PhotocolorDlg.voieCourante := voieCourante;
        PhotocolorDlg.showModal;
        exit;
     end;
     if (voieCourante.isLumicolor) or (voieCourante.isLumicolorDB15) then begin
        if LumicolorDlg=nil then
           Application.CreateForm(TLumicolorDlg, LumicolorDlg);
        LumicolorDlg.voieCourante := voieCourante;
        LumicolorDlg.showModal;
        exit;
     end;
     if ListeCapteursAuto[voieCourante.indexCapteurAuto].avecEtalonnage
     then if ListeCapteursAuto[voieCourante.indexCapteurAuto].PotarFige
        then begin
           EtalonneInterAutoDlg := TEtalonneInterAutoDlg.create(self);
           EtalonneInterAutoDlg.voieCourante := voieCourante;
           EtalonneInterAutoDlg.showModal;
           EtalonneInterAutoDlg.free;
        end
        else begin
           EtalonneAutoDlg := TEtalonneAutoDlg.create(self);
           EtalonneAutoDlg.voieCourante := voieCourante;
           EtalonneAutoDlg.showModal;
           EtalonneAutoDlg.free;
           for j := 0 to maxPotarAuto do
               with ListeCapteursAuto[voieCourante.indexCapteurAuto] do begin
                   EtalonnageFait := true;
                   if potarActif[j] and (valeurPotar[j]=0) then EtalonnageFait := false;
               end;
        end
     else begin
        codePotar := numToCodePotar(voieCourante.numOrphy);
        GtsMainForm.EcritOrphy('WRPOTAR '+codePotar);
     end;
     timer.enabled := true;
     EtalonAutoLabel.Visible := not listeCapteursAuto[voieCourante.indexCapteurAuto].EtalonnageFait;
end;

procedure TOrphyGtsDlg.EtalonneInterBtnClick(Sender: TObject);
begin with voieCourante do begin
     timer.enabled := false;
     Nom := EditNom.text;
     NomUnite := EditUnite.text;
     EtalonneInterDlg := TEtalonneInterDlg.create(self);
     EtalonneInterDlg.voieCourante := voieCourante;
     if EtalonneInterDlg.showModal=mrOK then begin
         val0Edit.text := FormatGts(offset);
         penteEdit.text := FormatGts(UnVolt);
         etalonCB.checked := true;
         setEtalonnage;
     end;
     modif := true;
     timer.enabled := true;
     EtalonneInterDlg.free;
end end;

procedure TOrphyGtsDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     timer.enabled := false
end;

procedure TOrphyGtsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_VoiesAnalogiques)
end;

procedure TOrphyGtsDlg.ManuelGridClick(Sender: TObject);
begin
     Modif := true
end;

procedure TOrphyGtsDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not charinset(key,(majuscule+minuscule+toucheEdition+chiffre)) then key := #0
end;

procedure TOrphyGtsDlg.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
     if voieCourante.active and
        EtalonCB.checked and
        not CalculEtalonManuel then begin
          afficheErreur(erEtalon);
          canClose := false;
          timer.enabled := true;
     end
     else canClose := true;
end;

procedure TOrphyGtsDlg.EditMiniKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_down then editMaxi.setFocus;
end;

procedure TOrphyGtsDlg.EditMaxiKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_up then editMini.setFocus;
end;

procedure TOrphyGtsDlg.EntreeCBChange(Sender: TObject);
begin
     voieCourante.numOrphy := EntreeCB.ItemIndex;
     eadLabel.Visible := (VoieCourante.numOrphy=10) or
                         (VoieCourante.numOrphy=11);
     boitierRaccordLabel.Visible := (VoieCourante.numOrphy<4);
     eadbtn.Visible := eadlabel.Visible;
end;

procedure TOrphyGtsDlg.setSplitter;
var coeff : double;
    h0,h1,h2 : integer;
begin with voieCourante do begin
     PanelCalibre.Visible := (EtalonCB.checked and not CapteurNonLin) or
                             (indexCapteurAuto>0);
     if (mini>maxi) or not(PanelCalibre.visible) then exit;
     coeff := panelCalibre.height/(calibreMaxi-calibreMini);
     h1 := round((Mini-calibreMini)*coeff);
     h2 := round((Maxi-calibreMini)*coeff);
     if (h2-h1)<10 then begin
        h0 := (h2+h1) div 2;
        if h0<10 then h0 := 10;
        if h0>(panelCalibre.height-10) then
           h0 := panelCalibre.height-10;
        h2 := h0+5;
        h1 := h0-5;
        maxi := calibreMini+h2/coeff;
        mini := calibreMini+h1/coeff;
     end;
     h2 := panelCalibre.height-h2-2;
     if h2>=panelCalibre.height then begin
        h2 := panelCalibre.height-1;
        maxi := calibreMaxi;
     end;
     h1 := h1-2;
     if h1<=0 then begin
        h1 := 1;
        mini := calibreMini;        
     end;
     PanelMaxi.height := h2;
     PanelMini.height := h1;
end end;

procedure TOrphyGtsDlg.EditMiniExit(Sender: TObject);
begin with voieCourante do begin
     try
     mini := GetFloat(EditMini.text);
     maxi := GetFloat(EditMaxi.text);
     setSplitter
     except
     end;
end end;

procedure TOrphyGtsDlg.EditMaxiKeyPress(Sender: TObject; var Key: Char);
begin
   if key=crCR then EditMiniExit(sender)
end;

procedure TOrphyGtsDlg.SplitterMaxiCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
   accept := EtalonCB.checked and
            (NewSize < (SplitterMini.top-8))
end;

procedure TOrphyGtsDlg.SplitterMiniCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
   accept := EtalonCB.checked and
            (NewSize < (PanelCalibre.height-SplitterMaxi.top-8))
end;

procedure TOrphyGtsDlg.SplitterMiniMoved(Sender: TObject);
begin with voieCourante do begin
     mini := calibreMini+
           (calibreMaxi-calibreMini)*
           (panelCalibre.height-SplitterMini.top)/panelCalibre.height;
     EditMini.text := FormatGTS(mini);
end end;

procedure TOrphyGtsDlg.SplitterMaxiMoved(Sender: TObject);
begin with voieCourante do begin
     maxi := calibreMaxi-
        (calibreMaxi-calibreMini)*SplitterMaxi.top/panelCalibre.height;
     EditMaxi.text := FormatGTS(maxi);
end end;

procedure TOrphyGtsDlg.EtalonRGClick(Sender: TObject);
begin
     modif := true;
     setEtalonnage;
end;

procedure TOrphyGtsDlg.val0EditExit(Sender: TObject);
begin
     CalculEtalonManuel;
     setSplitter;
end;

procedure TOrphyGtsDlg.FormCreate(Sender: TObject);
begin
     voieVolt := Tvoie.create(1);
     voieCapteur := Tvoie.create(1);
end;

procedure TOrphyGtsDlg.PanelMaxiClick(Sender: TObject);
begin
     with (Sender as Tpanel) do height := height-16;
     if sender=PanelMaxi then SplitterMaxiMoved(Sender);
     if sender=PanelMini then SplitterMiniMoved(Sender);
end;

procedure TOrphyGtsDlg.val0EditKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then val0EditExit(sender)
end;

procedure TOrphyGtsDlg.EditMiniKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then editMiniExit(sender)
end;

procedure TOrphyGtsDlg.ExpressionEditExit(Sender: TObject);
begin
    voieCourante.expression := expressionEdit.text
end;

procedure TOrphyGtsDlg.NonLineaireCBClick(Sender: TObject);
begin
  setEtalonnage
end;

procedure TOrphyGtsDlg.EADbtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_EntreesDifferentiell)
end;

procedure TOrphyGtsDlg.ZeroBtnClick(Sender: TObject);
var valeurI : integer;
    valeurV : double;
begin
     try
     with voieCourante do begin
          valeurI := GtsMainForm.getInt('WEA '+codeVoie);
          valeurV := valeurVolt(valeurI);
          offset := -unVolt*valeurV;
          val0Edit.text := FormatGts(offset);
     end;
     except
     end;
end;

procedure TOrphyGtsDlg.CalibreCBChange(Sender: TObject);
begin with voieCourante do begin
    maxi := calibre[calibreCB.itemIndex];
    if signeCB.Checked then mini := 0 else mini := -maxi;
end end;

procedure TOrphyGtsDlg.SigneCBClick(Sender: TObject);
begin with voieCourante do
   if signeCB.Checked then mini := 0 else mini := -maxi;
   setEtalonnage;
end;

procedure TOrphyGtsDlg.ExpressionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
    if key=vk_return then expressionEditExit(sender)
end;

procedure TOrphyGtsDlg.CapteursBtnClick(Sender: TObject);
begin
     timer.enabled := false;
     if ListeCapteursDlg=nil then
        Application.CreateForm(TListeCapteursDlg, ListeCapteursDlg);
     ListeCapteursDlg.voieCourante := voieCourante;
     if ListeCapteursDlg.showModal=mrOK then begin
        etalonCB.Checked := voieCourante.avecCapteur;
        FormActivate(nil);
        modif := true;
     end;
     timer.enabled := true;
end;

procedure TOrphyGtsDlg.UniteBisLBChange(Sender: TObject);
begin with ListeCapteursAuto[voieCourante.indexCapteurAuto] do begin
     codeUniteC := UniteBisLB.ItemIndex;
     EditNom.text := NomC[codeUniteC];
     EditUnite.text := NomUniteC[codeUniteC];
     EditSignif.text := SignifC[codeUniteC];
     voieCourante.nomUnite := NomUniteC[codeUniteC];
     voieCourante.UnVolt := UnVoltC[codeUniteC];
     voieCourante.Offset := OffsetC[codeUniteC];
     voieCourante.Mini := MiniAff[codeUniteC];
     voieCourante.Maxi := MaxiAff[codeUniteC];
     EditMini.text := FormatGTS(MiniAff[codeUniteC]);
     EditMaxi.text := FormatGTS(MaxiAff[codeUniteC]);
     if (expressionC[codeUniteC]<>'') and (codeUniteC>0)
         then voieCourante.expression := expressionC[codeUniteC]
         else voieCourante.expression := '';
     voieCourante.setMinMax;
end end;

procedure TOrphyGtsDlg.AideBtnClick(Sender: TObject);
begin
  syntaxeDlg := TsyntaxeDlg.create(self);
  syntaxeDlg.showModal;
  syntaxeDlg.free;
end;

end.

