unit GTSDDE;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, registry, clipbrd, shellApi,
  ComCtrls, oomisc, math, gtsDef, NativeXml,
  Maths, Graphe, uniteker, constGTS, gtsutil, DdeMan;

type
  Tenvoi = (eAdd,eLoad,ePlus,eAddCol);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    DdeClientConv1: TDdeClientConv;
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
      isJunior : boolean;
      procedure AjouteConst(var donnees : TstringList);
      Procedure AjouteOptionsGr(var donnees : TstringList);
      procedure Execute(Ordre : Tenvoi);
  public
      procedure MajRegressi;
      procedure EnvoieDonnees(DDE : boolean;nomFichier : String);
      procedure SauveDonneesXML(nomFichier : String);
      function SauveDonnees : boolean;
      procedure AjouteDonnees(debut,fin : integer);
      procedure AjouteColonnes;
  end;

var
  FormDDE: TFormDDE;

implementation

uses gtsMain, gtsconst;

const crTab=#9;

{$R *.DFM}

Procedure TFormDDE.AjouteOptionsGr(var donnees : TstringList);
var i,N : integer;
    v : indiceVoie;
begin with grapheGTS do begin
     N := 0;
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then inc(N);
     donnees.Add(symbReg2+intToStr(N)+' NOMX');
     for i := 1 to N do
         donnees.Add(voieOrphy[voieAbscisse].nom);
     donnees.Add(symbReg2+intToStr(N)+' NOMY');
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then donnees.Add(nom);
     donnees.Add(symbReg2+'1 LOGX');
     donnees.Add(IntToStr(ord(voieOrphy[voieAbscisse].axeLog)));
     donnees.Add(symbReg2+'1 AnalLogique');
     donnees.Add(IntToStr(ord(analyseurLogique)));
     donnees.Add(symbReg2+'1 DIMPOINT');
     donnees.Add(IntToStr(dimPoint));
     donnees.Add(symbReg2+'1 GRILLE');
     donnees.Add(IntToStr(ord(Quadrillage)));
     donnees.Add(symbReg2+intToStr(N)+' LOGY');
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then
            donnees.Add(IntToStr(ord(voieOrphy[v].axeLog)));
     donnees.Add(symbReg2+intToStr(N)+' COULEUR');
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then donnees.Add(IntToStr(couleur));
     donnees.Add(symbReg2+intToStr(N)+' MOTIF');
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then
            donnees.Add(IntToStr(ord(motif)));
     donnees.Add(symbReg2+intToStr(N)+' LIGNE');
     for v := succ(voieT) to voieMax do with voieOrphy[v] do
         if active and (v<>voieAbscisse) then
         // 1 point 2 ligne 4 spiro
            if TrSpiro in trace
            then donnees.Add('4')
            else if TrLigne in trace
               then if TrPoint in trace
                  then donnees.Add('3') // ligne et point
                  else donnees.Add('2') // ligne
               else donnees.Add('1'); // point
end end;

procedure TFormDDE.AjouteConst(var Donnees : TstringList);
var i,NbreConst : integer;
    Ligne,strValeur : string;
    ConstanteOK : array[1..3] of boolean;
    valeurConstante : array[1..3] of double;
begin with gtsMainForm do begin
     NbreConst := 0;
     for i := 1 to 3 do begin
         StrValeur := ConstanteDlg.ConstGrid.cells[2,i];
         TrimComplet(strValeur);
         if StrValeur=''
            then valeurConstante[i] := sansSignif
            else valeurConstante[i] := StrToFloatWin(strValeur);
         ConstanteOK[i] := (nomConstante[i]<>'') and
                           (valeurConstante[i]<>sansSignif);
         if ConstanteOK[i] then inc(NbreConst);
     end;
     if NbreConst=0 then exit;
     donnees.Add('');
     Ligne := '';
     for i := 1 to 3 do if ConstanteOK[i] then
           ligne := ligne+nomConstante[i]+crTab;
     donnees.Add(Ligne);
     Ligne := '';
     for i := 1 to 3 do if ConstanteOK[i] then
           ligne := ligne+uniteConstante[i]+crTab;
     donnees.Add(Ligne);
     Ligne := '';
     for i := 1 to 3 do if ConstanteOK[i] then
           ligne := ligne+FloatToStrPoint(valeurConstante[i])+crTab;
     donnees.Add(Ligne);
end end;

procedure TFormDDE.Execute(Ordre : Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eAddCol : if not ClientDDE.ExecuteMacro('CLIP|ADDCOL', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then Lance
        else begin
             sleep(1000);
        // OpenLink false efface 
             ClientDDE.SetLink('Regressi','ServeurDDE');
             ClientItem.DDEItem := 'ServeurItem';
             if ClientDDE.OpenLink
                then Lance
                else ShowMessage('Impossible de lancer Regressi');
        end;
end;

procedure TFormDDE.FormActivate(Sender: TObject);
begin
      MajRegressi
end;

procedure TFormDDE.FormCreate(Sender: TObject);
begin
    MajRegressi
end;

procedure TFormDDE.MajRegressi;
var Ini : TRegIniFile;
    i : integer;
    taille : int64;
    nomFichier : string;
begin
    if RepertoireRegressi<>'' then begin
       ClientDDE.ServiceApplication := RepertoireRegressi+'\regressi.exe';
       exit;
    end;
    Ini := TRegIniFile.create('Software');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    if ClientDDE.ServiceApplication='' then begin
       Ini := TRegIniFile.create('Software\Regressi');
       ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path',ClientDDE.ServiceApplication);
       isJunior := Ini.ReadBool('Regressi','Junior',false);
       Ini.Free;
    end;
    if ClientDDE.ServiceApplication='' then begin
    { disquette A 1 B 2 disque dur C 3 D 4 CDROM D 4 E 5}
        for i := 4 to 5 do begin
            taille := DiskSize(i);
            if (taille>5e6) and (taille<800e6) then begin { CDROM }
                nomFichier := char(ord('A')+i-1)+':\Regressi.exe';
                if fileExists(nomFichier) then
                   ClientDDE.ServiceApplication := NomFichier;
            end;
        end; {for i}
    end;
    if ClientDDE.ServiceApplication='' then
       ClientDDE.ServiceApplication := 'regressi.exe';
end;

procedure TFormDDE.EnvoieDonnees(DDE : boolean;nomFichier : String);
var Donnees : TstringList;
    repere : Trepere;

procedure EnvoiePageCourante;
var i : integer;
    v,v1 : indiceVoie;
    ligne : string;
    ligneOK : boolean;
begin with grapheGts do begin
     if ConstanteDlg=nil then
        Application.CreateForm(TConstanteDlg, ConstanteDlg);
     Tri;
     case modeAcq of
          AcqPoint : if frequence.active
             then v1 := voieF
             else begin
                v1 := voieT;
                if not GtsMainForm.poincareCB.checked  then
                   for i := 0 to maxVecteur do
                       voieOrphy[voieT].vecteurAff[i] := i;
             end;
          AcqClavier : v1 := voieClavier;
          else v1 := voieT;
     end;
     if nomFichier='' then begin
        donnees.Add(Application.exeName);
        if ConstanteDlg.NewPageCB.itemIndex = 1
            then donnees.Add('')
            else donnees.Add('Acquisition par Orphy GTS-2');
        donnees.Add(GtsMainForm.Commentaire);
     end;
     if (modeAcq=AcqPoint) and
        not frequence.active and
        not GtsMainForm.poincareCB.checked
         then Ligne := 'num' + crTab
         else Ligne := voieOrphy[v1].nom + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + nom + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint) and not frequence.active
         then Ligne := '' + crTab
         else Ligne := voieOrphy[v1].nomUnite + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + nomUnite + crTab;
     donnees.Add(ligne);
     if (modeAcq=AcqPoint) and not frequence.active
         then Ligne := '' + crTab
         else Ligne := voieOrphy[v1].signif + crTab;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active and (v<>v1) then
            ligne := ligne + signif + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         for v := voieT to voieMax do with voieOrphy[v] do
             if active and  (vecteurAff[i]=sansSignif) then
                ligneOK := false;
         if not LigneOK then continue;
         ligne := FloatToStrPoint(voieOrphy[v1].vecteurAff[i]) + crTab;
         for v := voieT to voieMax do
             if voieOrphy[v].active and (v<>v1) then
                ligne := ligne + FloatToStrPoint(voieOrphy[v].vecteurAff[i]) + crTab;
         donnees.Add(ligne);
     end;
     if DDE then begin
        AjouteConst(donnees);
        AjouteOptionsGr(donnees);
        if ListeRepere.count>0 then begin
           donnees.Add(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
           for i := 0 to pred(ListeRepere.count) do begin
               repere := listeRepere[i];
               donnees.Add(FloatToStrPoint(repere.valeur)+crTab+repere.edit.text);
           end;
        end;
     end;
     if nomFichier<>''
        then donnees.saveToFile(NomFichier)
        else begin
           ClipBoard.AsText := Donnees.text;
           if DDE then if ConstanteDlg.NewPageCB.itemIndex = 1
              then Execute(eADD)
              else Execute(eLOAD);
        end;
     ConstanteDlg.NewPageCB.itemIndex := 1;
end end; // EnvoiePageCourante

procedure EnvoiePageNonNum;
var i : integer;
    v : indiceVoie;
    ligne : string;
    ligneOK : boolean;
begin with grapheGts do begin
     if ConstanteDlg=nil then
        Application.CreateForm(TConstanteDlg, ConstanteDlg);
     if nomFichier='' then begin
        donnees.Add(Application.exeName);
        if ConstanteDlg.NewPageCB.itemIndex = 1
            then donnees.Add('')
            else donnees.Add('Acquisition par Orphy GTS-2');
        donnees.Add(GtsMainForm.Commentaire);
     end;
     ligne := '';
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then ligne := ligne + nom + crTab;
     donnees.Add(ligne);
     ligne := '';
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then ligne := ligne + nomUnite + crTab;
     donnees.Add(ligne);
     Ligne := '';
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then ligne := ligne + signif + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligneOK := true;
         for v := voieT to voieMax do with voieOrphy[v] do
             if active and  (vecteurAff[i]=sansSignif) then
                ligneOK := false;
         if not LigneOK then continue;
         ligne := '';
         for v := voieT to voieMax do
             if voieOrphy[v].active then
                ligne := ligne + FloatToStrPoint(voieOrphy[v].vecteurAff[i]) + crTab;
         donnees.Add(ligne);
     end;
     if DDE then begin
        AjouteConst(donnees);
        AjouteOptionsGr(donnees);
        if ListeRepere.count>0 then begin
           donnees.Add(symbReg2+IntToStr(ListeRepere.count)+' REPERE');
           for i := 0 to pred(ListeRepere.count) do begin
              repere := listeRepere[i];
              donnees.Add(FloatToStrPoint(repere.valeur)+crTab+repere.edit.text);
           end;
        end;
     end;
     if nomFichier<>''
        then donnees.saveToFile(NomFichier)
        else begin
           ClipBoard.AsText := Donnees.text;
           if DDE then if ConstanteDlg.NewPageCB.itemIndex = 1
              then Execute(eADD)
              else Execute(eLOAD);
        end;
     ConstanteDlg.NewPageCB.itemIndex := 1;
end end; // EnvoiePageNonNum

begin with grapheGts do begin // EnvoieDonnees
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     if (modeAcq=AcqPoint) and
         not gtsmainForm.sauveNum and
         not frequence.active and
         not GtsMainForm.poincareCB.checked
       then envoiePageNonNum
       else envoiePageCourante;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; { EnvoieDonnees }

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Fonction,NomFichier : string;
    ArgStart,ArgEnd : integer;
begin
     if (Msg.Count = 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then nomFichier := ''
          else nomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
       ArgStart := Pos('(',Msg[0]);
       if ArgStart>0
          then Fonction := Copy(Msg[0], 1, Pred(ArgStart))
          else Fonction := Msg[0];
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
           nomFichier := changeFileExt(nomFichier,'.GT2');
           if FileExists(nomFichier) and
              (nomFichier<>GtsMainForm.nomFichierConfig) then begin
              GtsMainForm.LitConfig(NomFichier,true);
              GtsMainForm.afficheReglage;
           end;
           exit
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
           GtsMainForm.EcritConfig(NomFichier);
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           GtsMainForm.setFocus;
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           GtsMainForm.setFocus;
           exit;
       end;
       except
       end;
     end;
end;

procedure TFormDDE.AjouteColonnes;
var donnees : TstringList;
    i : indiceVecteur;
    v : indiceVoie;
    ligne : string;
begin  with grapheGTS do begin
     Screen.Cursor := crHourGlass;
     donnees := TstringList.create;
     donnees.Add('');
     Ligne := '';
     for v := voieA to voieMax do with voieOrphy[v] do if active then
         ligne := ligne + nom + crTab;
     donnees.Add(ligne);
     Ligne := '';
     for v := voieA to voieMax do with voieOrphy[v] do if active then
         ligne := ligne + nomUnite + crTab;
     donnees.Add(ligne);
     Ligne := '';
     for v := voieA to voieMax do with voieOrphy[v] do if active then
         ligne := ligne + signif + crTab;
     donnees.Add(ligne);
     for i := 0 to pred(NbreAff) do begin
         ligne := '';
         for v := voieA to voieMax do with voieOrphy[v] do if active then
             ligne := ligne + FloatToStrPoint(vecteurAff[i]) + crTab;
         donnees.Add(ligne);
     end;
     ClipBoard.asText := Donnees.text;
     Execute(eADDCOL);
     Donnees.free;
     Screen.Cursor := crDefault;
end end;

procedure TFormDDE.AjouteDonnees(debut,fin : integer);
var i : indiceVecteur;
    v : indiceVoie;
    ligne : string;
    ligneOK : boolean;
    donnees : TstringList;
begin with grapheGTS do begin
     if debut=0 then begin
        envoieDonnees(true,'');
        exit;
     end;
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     ligne := '';
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then ligne := ligne + nom + crTab;
     donnees.Add(ligne);
     ligne := '';
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then ligne := ligne + nomUnite + crTab;
     donnees.Add(ligne);
     ligne := '';
     for v := voieT to voieMax do
         if voieOrphy[v].active then
            ligne := ligne + voieOrphy[v].signif + crTab;
     donnees.Add(ligne);
     for i := debut to fin do begin
         ligneOK := true;
         ligne := '';
         for v := voieT to voieMax do with voieOrphy[v] do
             if active then if vecteurAff[i]=sansSignif
                then ligneOK := false
                else ligne := ligne+FloatToStrPoint(vecteurAff[i]) + crTab;
         if ligneOK then donnees.Add(ligne);
     end; { for i }
     ClipBoard.astext := Donnees.text;
     Execute(ePLUS);
     donnees.free;
     Screen.Cursor := crDefault;
end end; { AjouteDonnees }

function TFormDDE.SauveDonnees : boolean;
var i : integer;
    v,vv : indiceVoie;
    nomFichier : String;
    ligne : string;
    donnees : TstringList;
var AcqLongueDuree : boolean;
    DateDebut : TdateTime;
    NbreVariab : integer;
    dateStr : string;
begin with grapheGTS do begin // sauveDonnees
     result := true;
     if NbreAff<minPointsTemps then exit;
     Screen.Cursor := crHourGlass;
     AcqLongueDuree := (ModeAcq=AcqTemps) and
                       (baseDeTemps.dureeBalayage>UneHeure);
     DateDebut := GTSmainForm.debutAcquisition;
     DateTimeToString(DateStr,'ddd d mmm h"h"n',now);
     NomFichier := 'GTS2_'+DateStr+'.rw3';
     NomFichier := mesDocsDir + NomFichier;
     Tri;
     Donnees := TstringList.create;
     donnees.add('EVARISTE REGRESSI WINDOWS 1.0');
     if AcqLongueDuree
        then NbreVariab := 1
        else NbreVariab := 0;
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then inc(NbreVariab);
     for v := voieT to voieMax do
         if voieOrphy[v].active then
            for vv := succ(v) to voieAnaMax do
                if voieOrphy[vv].active and
                   (voieOrphy[vv].nom=voieOrphy[v].nom) then begin
                      voieOrphy[v].nom := voieOrphy[v].nom+intToStr(v);
                      voieOrphy[vv].nom := voieOrphy[vv].nom+intToStr(vv);
                end;
     donnees.add(symbReg+intTostr(NbreVariab)+' NOM VAR');
     if AcqLongueDuree then donnees.Add('Date');
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then donnees.Add(UnicodeVersRW3(nom));
     donnees.add(symbReg+intToStr(NbreVariab)+' GENRE VAR');
     for i := 0 to pred(NbreVariab) do
         donnees.add('0');
     donnees.add(symbReg+intToStr(NbreVariab)+' UNITE VAR');
     if AcqLongueDuree then donnees.add('');
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then donnees.add(UnicodeVersRW3(nomUnite));
     donnees.Add(symbReg+intToStr(NbreVariab)+' SIGNIF VAR');
     if AcqLongueDuree then donnees.Add('');
     for v := voieT to voieMax do with voieOrphy[v] do
         if active then donnees.Add(UnicodeVersRW3(signif));
     donnees.Add(symbReg+'2 ACQUISITION');
     donnees.Add('EXTERNE');
     donnees.Add(application.ExeName);
     donnees.Add(symbReg+'1 PAGE COMMENT');
     donnees.Add(UnicodeVersRW3(GTSmainForm.Commentaire));
     donnees.Add(symbReg2+IntToStr(NbreAff)+' VALEUR VAR');
     for i := 0 to pred(NbreAff) do begin
         if AcqLongueDuree
            then Ligne :=
                DateTimeToStr(DateDebut+voieOrphy[voieT].vecteurAff[i]/UnJour)+' '
            else Ligne := '';
         for v := voieT to voieMax do with voieOrphy[v] do
             if active then ligne := ligne + FloatToStrPoint(vecteurAff[i])+' ';
         donnees.Add(ligne);
     end;
     try
     donnees.saveToFile(NomFichier);
     except
    	result := false; // Pb de protection en criture ?
     end;
     Donnees.free;
     Screen.Cursor := crDefault;
end end; // SauveDonnees

procedure TFormDDE.SauveDonneesXML(nomFichier : String);
var nroVal : integer;
    v : indiceVoie;

var AcqLongueDuree : boolean;
    DateDebut : TdateTime;
    dateStr : string;
    XmlDoc: TNativeXml;    // Xml document
    Source, VariableXML, NomVar, ValeurXML, nroValXML: TXMLNode;
    CommentaireXML,AttCommentaire : TXMLNode;
begin with grapheGTS do begin // sauveDonneesXML
     if NbreAff<minPointsTemps then exit;

     Screen.Cursor := crHourGlass;
     AcqLongueDuree := (ModeAcq=AcqTemps) and
                       (baseDeTemps.dureeBalayage>UneHeure);
     DateDebut := GTSmainForm.debutAcquisition;
     DateTimeToString(DateStr,'ddd d mmm h"h"n',now);
     Tri;

     XMLDoc := TnativeXML.CreateName('racine');
     Source := XMLDoc.Root.NodeNew('SOURCE');
     Source.WriteString('logiciel','GTS 2','');
     Source.WriteString('version',GTSmainForm.versionOrphy,'');
     if AcqLongueDuree then begin
            VariableXML := XMLDoc.Root.NodeNew('VARIABLE');
            NomVar := VariableXML.NodeNew('nom');
            NomVar.valueDirect := 'Date';
            NomVar.WriteString('unite','','');
            NomVar.WriteAttributeInteger('genre',0,0);
            NomVar.WriteAttributeInteger('precision',5,5);
            VariableXML.NodeNew('Description').valueDirect := '';
            VariableXML.NodeNew('VarControle').valueDirect := 'false';
            ValeurXML := VariableXML.NodeNew('Page');
            ValeurXML.WriteAttributeInteger('NroPage',0,0);
            for nroVal := 0 to pred(NbreAff) do begin
              nroValXML := ValeurXML.NodeNew('Valeur');
              nroValXML.WriteAttributeInteger('id',nroVal,0);
              nroValXML.valueDirect := DateTimeToStr(DateDebut+voieOrphy[voieT].vecteurAff[nroVal]/UnJour)+' '
            end;
          end
          else begin
          for v := voieT to voieMax do with voieOrphy[v] do
              if active then begin
                VariableXML := XMLDoc.Root.NodeNew('VARIABLE');
                NomVar := VariableXML.NodeNew('nom');
                NomVar.valueDirect := nom;
                NomVar.WriteString('unite',nomUnite,'');
                NomVar.WriteAttributeInteger('genre',0,0);
                NomVar.WriteAttributeInteger('precision',5,5);
                VariableXML.NodeNew('Description').valueDirect := signif;
                VariableXML.NodeNew('VarControle').valueDirect := 'false';
                ValeurXML := VariableXML.NodeNew('Page');
                ValeurXML.WriteAttributeInteger('NroPage',0,0);
                for nroVal := 0 to pred(NbreAff) do begin
                  nroValXML:= ValeurXML.NodeNew('Valeur');
                  nroValXML.WriteAttributeInteger('id',nroVal,0);
                  nroValXML.valueDirect := FloatToStrPoint(vecteurAff[nroVal]);
                end;
              end;
              CommentaireXML := XMLDoc.Root.NodeNew('COMMENTAIRE');
              AttCommentaire := CommentaireXML.NodeNew('Texte');
              AttCommentaire.WriteAttributeInteger('nroPage',0,0);
              for v := voieT to voieMax do with voieOrphy[v] do
              if active then
                CommentaireXML.NodeNew('VarSelect').valueDirect := nom+'('+nomUnite+')'
        end;
     XMLDoc.saveToFile(NomFichier);
     Screen.Cursor := crDefault;
    end;
end; // SauveDonneesXML

end.
