unit GTSDEF;

interface

uses classes, sysutils, oomisc, inifiles, graphics,
     uniteker, maths, gtsutil, adport, constgts, registry,
     dialogs, math, parser10, initio, forms;

Const
    resetWRpotar = 15; // 3 secondes avec MajTimerms
    DureeAttenteUnMega = 1;
    AbsorbanceMax = 3;
    DureeIncrementiel = 10*60;
// 10 minutes dure minimale de sauvegarde en cours de route
    indexCapteurMarteau = 1;
    indexCapteurMagnum = 15;
    indexCapteurStimul = 13;
    indexCapteurSondor = 11;
    indexCapteurOxygene = 20;               
    TraitMagnum = 0.0018;  { demi pas }
    ZeroMagnum = 128;

    premiereFois : boolean = true;
    MajTimerMilliSec = 220;
    MajTimerFiltre = 1000;
    MajTimerCardiaque = 500;
    MajTimerFreq = 1000;    
    MajTimerSondor = 5000;
    MaxMoyCardiaque = 200; // coups soit environ 3 minutes
    MaxCardiaque = 32000*65536; // 4 octets    
    MajTimerSec = MajTimerMilliSec/1000;
    MaxMoyenne = 17;
    voieT = 1;
    voieSA = 2; // sortie analogique
    voieClavier = 3;
    voieMagnum = 4; // magnum ou codeur incrmental
    voieF = 5;  // frquence 
    voieA = 6;
    voieAnaMax = voieA+4; // 10
    voieCalc = voieAnaMax+1; // 11
    voieSondor = voieAnaMax+2; // 12
    numSynchroGTS2 = 11; // EAD1
    voieMin = voieT;
    VoieMax = voieSondor;
    MaxiHardSA = 255;
    MaxiHardEA = 65536;
    HardMaxi = +32767;
    MaxiFrequence = 1E5;
    MiniFrequence = 10;
    MinPointsTemps = 8;
    MinPointsFichier = 1;
    MinSeuil = 8;
    DeltatMinCard = 0.5;
    DeltatMaxCard = 2;
    DeltatSondor = 500e-9; // 500 ns
    DeltatWper : array[boolean] of double = (125e-9,200e-9);
    DeltatWauto = 500e-9; // idem GTS2 GTI2
    DureeMaxMagnum = 536.8709104;
    DeltatWgene : array[boolean] of double = (512e-6,32e-6);  // 512 ou 32 s
    IndexMagnumMax = 5;
    indexPressionRelative = 4;
    IndexChuteMax = 3;
    MaxResulGTS = 60000;
    MaxPreAcq = 1000;

type
    TvoieUtile = (vCalculee,vCodeur,vRelais,vSortiePWM,vGP305,vGBF);
    TConnectiqueGTI2 = (coNone,coDIN,coExtension);
    TvolumeMaxi = (v20,v50);
    Tmotif = (mCroix,mCroixDiag,mCercle,mCarre,mLosange);
    TModeAcq = (AcqClavier,AcqTemps,AcqPoint,AcqMagnum,
                AcqSortieAna,AcqUnMega,AcqCardiaque,AcqFiltre);
    TetatAcq= (eaAttenteSynchro,eaAttenteResul,eaMajResul,eaTerminee);
    TetatAvail = (eaNone,eaResul,eaMagnum,eaResulUnMega,eaSondor,eaPoincare,eaCardiaque);
    indiceVoie = VoieT..VoieMax;
    indiceVoieHard = 0..11;
    TModeSynchro = (S_front,S_seuil,S_relaxe,S_clavier,S_nerf,s_bouge,s_sondor,s_sodar);
    EserieError = class(Exception);
    EgtsError = class(Exception);
    TvoiesUtiles = set of TvoieUtile;

Const
    codeMontant : array[boolean] of AnsiChar = ('D','M');
    DeltatMagnum : array[boolean] of double = (125e-9,200e-9);  // test = isGTI2
    DeltatMax = 3600.0; { s = 1 heure }
    DureeMaxMax = deltatMax*MaxVecteur;
      { 8192 heures = 341 jours = 11 mois }
      { 1024 heures = 43 jours = 1,5 mois }
    DeltatOrphy = 1.0e-5;
    DeltatDos = 1/18;
    VitesseMax = 3;
    VitesseInt : array[0..VitesseMax] of LongInt = (9600,19200,38400,57600);
    PriseVoie : array[0..11] of AnsiChar = 'AAFFBBCCGHGH';
    PriseVoieGTI2 : array[0..11] of AnsiChar = 'AAFFGHIJGHIJ';

{ GTI2
CONNECTEUR G
EB6 EB7
SB8 SB6 (PWM0)
EF0
SA0 (0 V   5 V)
EA4  (au lieu de EA8)
EA8=EAD0+ et EAD0-

conversion GTS2 -> GTI2
EA8 prise G -> EA4
EA9 prise H -> EA5
EA10=EAD0 -> EA8=EAD0 prise G
EA11=EAD1 -> EA9=EAD1 prise H

conversion GTI2 -> GTS2
EA4 prise G -> EA8 prise G
EA5 prise H -> EA9 prise H
EA8 -> EA10=EAD0
EA9 -> EA11=EAD1
EA10=EAD2 prise I -> ??
EA11=EAD3 prise J -> ??

CONNECTEUR H
EB8 EB9
SB9 SB7 (PWM 1)
EF1
SA1 -5V  +5V
EA5 (au lieu de EA9)
EA9=EAD1+ et EAD1-

CONNECTEUR I
EB10 et EB11
SB8 SB9
EF2
SA0 0 et 5V
EA6
EA10=EAD2+ et EAD2-

CONNECTEUR J
EB12 et EB13
SB9 SB10
EF3
SA1 -5V  +5V
EA7
EA11=EAD3+ et EAD3-
}

    LongueurUnite = 15;
    MaxPotarAuto = 4;
    MaxCapteurAuto = 22;
    MaxUniteAuto = 2; // 0 de base 1 et 2 en options

type
   indiceCapteurAuto = 1..MaxCapteurAuto;
   TsetCapteurAuto = set of indiceCapteurAuto;
   Tconstructeur = (cDin,cDB15,cDavisual,cMesura,cInitio,cAutre);
   chaineUniteCapteur = string;
   indexPotar = 0..MaxPotarAuto;
   indiceUniteAuto = 0..MaxUniteAuto;
   TGenreCapteur = (gNone,gEntree,gSortie,gPhase,gPhotocolor,gLumicolor,gLumiColorDB15);
   TCapteur = class
        AvecPotarC : boolean;
        AvecAmpliC : boolean;
        OffsetC : double;
        UnVoltC : double;
        constructeur : Tconstructeur;
        nomC : string;
        nomUniteC : string;
        signifC,aideC,titreC : String;
        MiniAff,MaxiAff : double;
        numeroC : integer;
        LinearC : boolean;
        ExpressionC : string;
        Genre : TGenreCapteur;
        constructor create;
        procedure Assign(Acapteur : Tcapteur);
   end;

   TOxymetre = class
        voie : integer;
        code : AnsiChar;
        Temp,cRef : double; // temprature, concentration mg/L
        function valeurAttendue : integer;
        function temperature(V : integer) : double;
        function concentration(V : integer) : double;
        function MesureT : string;
        function MesureC : string;
   end;

   TCapteurAuto = class
        protected
             Parser : Tparser;
             function getExpression : string;
             procedure setExpression(Avalue : string);virtual;
        public
        PotarActif : array[indexPotar] of boolean;
        ValeurPotar : array[indexPotar] of word;
        ValeurAttendue : array[indexPotar] of double;
        AidePotar : array[indexPotar] of string;
        modeAcq : TmodeAcq;
        OffsetC : array[indiceUniteAuto] of double;
        UnVoltC : array[indiceUniteAuto] of double;
        CodeAuto : integer;
        nomC : array[indiceUniteAuto] of string;
        nomUniteC : array[indiceUniteAuto] of string;
        signifC : array[indiceUniteAuto] of String;
        titreC : array[indiceUniteAuto] of String;
        MiniAff,MaxiAff : array[indiceUniteAuto] of double;
        EtalonnageFait : boolean;
        capteurSynchro : boolean;
        PotarFige : boolean;
        nbreUniteBis : indiceUniteAuto;
        expressionC : array[indiceUniteAuto] of string;
        codeUniteC : indiceUniteAuto;
        compteurWRpotar : integer;
        constructor create(Acode : integer);
        function ValeurReal(V : integer) : double;
        function AvecEtalonnage : boolean;
        procedure load(fichier : TmemIniFile);
        procedure store(fichier : TmemIniFile);
   end;

   Tvoie = class(tunite)
          private
              FnumOrphy : integer;
              Fmini,Fmaxi : double;
              procedure setMaxi(value : double);
              procedure setMini(value : double);
              procedure setNumOrphy(value : integer);
          protected
              Parser : Tparser;
              VoltRefParser : PParserFloat;
              function getExpression : string;
              function getCapteurNonLin : boolean;
              procedure setExpression(Avalue : string);virtual;
              Function GetNomVoieOrphy : string;virtual;
          public
          TensionRef : double;
          oldValeurs : array[0..maxMoyenne] of double;
          NbreMoyenne : integer;
          Offset,UnVolt : double;
          ValeurCourante,valeurAff : double;
          AvecPotar,AvecAmpli : boolean;
          signif,aide : string;
          vecteurAff : vecteur;
          vecteurCourant : vecteurInt;
          active : boolean;
          couleur : Tcolor;
          Motif : Tmotif;
          AvecCapteur : boolean;
          indexCapteurAuto : integer;
          isPhotocolor,isLumicolor,isLumicolorDB15 : boolean;
          property NumOrphy : integer read FnumOrphy write setNumOrphy;
          property Maxi : double read Fmaxi write setMaxi;
          property Mini : double read Fmini write setMini;
          property NomVoieOrphy : string read GetNomVoieOrphy;
          property CapteurNonLin : boolean read GetCapteurNonLin;
          constructor create(num : integer);
          Function CodeVoie : string;
          Procedure ChercheCapteur(genre : TgenreCapteur);
          Procedure AffecteCapteur(capteurCourant : Tcapteur);
          Function AffVoltmetre : string;virtual;
          Function AffValeur(i : integer) : string;virtual;
          Function ValeurReal(V : integer) : double;virtual;
          Function ValeurVolt(V : integer) : double;virtual;
          Function VoltToReal(V : double) : double;
          Function CalibreMaxi : double;
          Function CalibreMini : double;
          procedure RazVecteur;
          procedure setMinMax;virtual;
          procedure load(Avoie : string;Fichier : tMemIniFile);virtual;
          procedure store(Avoie : string;Fichier : tMemIniFile);virtual;
          Function calibreVoie : string;virtual;
          property expression : String read getExpression write setExpression;
          destructor Destroy;override;
    end;

const
   crLF = #10;
   crCR = #13;
   nomPotar : array[indexPotar] of string =
    ('offset zoom','gain zoom','offset','gain','seuil');

type
  TlisteCapteur = class(TList)
  protected
    function Get(Index : Integer) : Tcapteur;
    procedure Put(Index : Integer;Item : Tcapteur);
  public
    function Add(Item : Tcapteur) : Integer;
    function IndexOf(Item : Tcapteur) : Integer;
    function Remove(Item : Tcapteur) : Integer;
    property Items[Index : Integer] : Tcapteur read Get write Put;
    Procedure Clear;override;
  end;

var
    NomFichierCapteurs : string;
    ListeCapteur : TlisteCapteur;
    ListeCapteursAuto : array[indiceCapteurAuto] of TCapteurAuto;
    RepertoireRegressi : string;
    FichierCapteurAuto : boolean;
    isGTI2 : boolean = false;
    isFichierGTI2 : boolean = false;
    connectiqueGTI2 : TconnectiqueGTI2 = coNone;
    oxymetre : Toxymetre;

Procedure ChargeListeCapteurs;
Procedure SauveListeCapteurs;
function SeuilSynchroVolt(valeur : integer) : double;
Function ValeurWDAC(SAi : byte;V : double) : word;
function NumToCodePotar(numOrphy : integer) : AnsiChar;

function nomEtatAcq(etat : TetatAcq) : string;
function nomModeAcq(mode : TModeAcq) : string;
function nomSynchro(mode : TModeSynchro) : string;

const

TitreModeAcq : array[TmodeAcq] of string =
             ('&Clavier','&Temporel','&Point par point','&Fourche optique',
              '&Sortie analogique','&Rapide','&Filtre','&Cardiaque');

TitreVoieGTI2 : array[TconnectiqueGTI2,0..11] of string = (
(
'EA0',
'EA1',
'EA2',
'EA3',
'EA4 prise G',
'EA5 prise H',
'EA6 prise I',
'EA7 prise J',
'EAD0 diff. prise G',
'EAD1 diff. prise H',
'EAD2 diff. prise I',
'EAD3 diff. prise J'),
(
'EA0 prise A',
'EA1 prise A',
'EA2 prise F',
'EA3 prise F',
'EA4 prise B ou G',
'EA5 prise B ou H',
'EA6 prise C ou I',
'EA7 prise C ou J',
'EAD0 diff. prise G',
'EAD1 diff. prise H',
'EAD2 diff. prise I',
'EAD3 diff. prise J'),
(
'EA0',
'EA1',
'EA2',
'EA3',
'EA4 BNC ou prise G',
'EA5 BNC ou prise H',
'EA6 BNC ou prise I',
'EA7 BNC ou prise J',
'EAD0 diff. prise G',
'EAD1 diff. prise H',
'EAD2 diff. prise I',
'EAD3 diff. prise J')
);


implementation

const
    CouleurDefaut : array[indiceVoie] of Tcolor =
       (clBlack,clBlack,clRed,clBlack,clBlack,clRed,
        clGreen,clPurple,clBlue,clFuchsia,clRed,clBlue);

Procedure SauveListeCapteurs;
{  sauvegarde de la liste  }
var fichier : tMemIniFile;

Procedure EcritAuto;
Var i : integer;
begin
    for i := 1 to MaxCapteurAuto do
        ListeCapteursAuto[i].store(fichier);
end;

Procedure Ecrit;
Var i : integer;
    ligne : string;
begin
    fichier.writeInteger('Capteurs','Nombre',ListeCapteur.count);
    for i := 0 to pred(ListeCapteur.count) do
       with ListeCapteur.items[i] do begin
        ligne := IntToStr(i+1);
        fichier.writeBool(ligne,'Etalonnage',AvecPotarC);
        if linearC
           then fichier.writeString(ligne,'Expression','')
           else fichier.writeString(ligne,'Expression',ExpressionC);
        fichier.writeBool(ligne,'Ampli',AvecAmpliC);
        fichier.writeFloat(ligne,'0V',Offsetc);
        fichier.writeFloat(ligne,'1V',UnVoltc);
        fichier.writeFloat(ligne,'Mini',MiniAff);
        fichier.writeFloat(ligne,'Maxi',MaxiAff);
        fichier.writeString(ligne,'Nom',nomC);
        fichier.writeString(ligne,'Unite',nomUniteC);
        fichier.writeString(ligne,'Signif',signifC);
        fichier.writeString(ligne,'Titre',titreC);        
        fichier.writeString(ligne,'Aide',aideC);
        fichier.writeInteger(ligne,'Numero',numeroC);
        fichier.writeInteger(ligne,'Constructeur',ord(constructeur));
        fichier.writeInteger(ligne,'Genre',ord(genre));
    end;
end;

var regIni : TregIniFile;
begin
    fichier := tMemIniFile.create(nomFichierCapteurs);
    try
    Ecrit;
    EcritAuto;
    fichier.UpdateFile;
    fichier.free;
    except
    end;
    try
    RegIni := TRegIniFile.create(RegistreGTS);
    RegIni.writeString('Capteurs','Fichier',NomFichierCapteurs);
    RegIni.free;
    except
    end;
end;

Procedure ChargeListeCapteurs;
var fichier : tMemIniFile;

Procedure TrierCapteurs;
{ Tri Shell Meyer-Baudoin p 456 }
{ origine vecteur en 0 }
var cle : string;
    i,j : integer;
    SauveAppareil : Tcapteur;        
Begin
    i := 1;  // lment 0 tri
    while (i<ListeCapteur.count) do begin
        sauveAppareil := ListeCapteur[i];
        cle := sauveAppareil.titreC;
        j := pred(i);
        while (j>=0) and (ListeCapteur.items[j].titreC>cle) do begin
             ListeCapteur[succ(j)] := ListeCapteur[j];
             dec(j);
        end;
        ListeCapteur[succ(j)] := sauveAppareil;
        inc(i);
    end;
end;

Procedure CapteursAuto;
var i : integer;
begin
    for i := 1 to MaxCapteurAuto do begin
        ListeCapteursAuto[i].load(fichier);
        FichierCapteurAuto := FichierCapteurAuto or
              (ListeCapteursAuto[i].signifC[0]<>'');
    end;
end; { CapteursAuto }

Procedure Capteurs;
{  chargement de la liste si vide cration  l'aide de defaut }
var i : integer;
    NbreCapteurs : integer;
    CapteurCourant : Tcapteur;
    ligne : string;
begin
    listeCapteur.clear;
    NbreCapteurs := fichier.readInteger('Capteurs','Nombre',0);
    for i := 1 to NbreCapteurs do begin
      CapteurCourant := Tcapteur.create;
      ListeCapteur.add(CapteurCourant);
      with CapteurCourant do begin
        ligne := IntToStr(i);
        AvecPotarC := fichier.readBool(ligne,'Etalonnage',false);
        AvecAmpliC := fichier.readBool(ligne,'Ampli',false);
        Offsetc := fichier.ReadFloat(ligne,'0V',0);
        UnVoltc := fichier.ReadFloat(ligne,'1V',1);
        MiniAff := fichier.ReadFloat(ligne,'Mini',0);
        MaxiAff := fichier.ReadFloat(ligne,'Maxi',5);
        nomC := fichier.readString(ligne,'Nom',nomC);
        nomUniteC := fichier.readString(ligne,'Unite','');
        signifC := fichier.readString(ligne,'Signif','');
        titreC := fichier.readString(ligne,'Titre','');        
        aideC := fichier.readString(ligne,'Aide','');
        if aideC='' then aideC := signifC;
        if titreC='' then titreC := signifC;                       
        numeroC := fichier.readInteger(ligne,'Numero',0);
        expressionC := fichier.readString(ligne,'Expression','');
        constructeur := Tconstructeur(fichier.readInteger(ligne,'Constructeur',0));
        genre := TgenreCapteur(fichier.ReadInteger(ligne,'Genre',0));
        linearC := expressionC='';
    end end;
    if NbreCapteurs=0 then begin
       CapteurCourant := TCapteur.create;
       ListeCapteur.add(CapteurCourant);
    end;
    TrierCapteurs;
end; // Capteurs 

var i : integer;
begin
    fichier := tMemIniFile.create(nomFichierCapteurs);
    FichierCapteurAuto := false;
    Capteurs;
    for i := 1 to MaxCapteurAuto do
        ListeCapteursAuto[i] := TcapteurAuto.create(i);
    CapteursAuto;
    if not FichierCapteurAuto then exit;
    with listeCapteursAuto[indexCapteurOxygene] do
       if nomUniteC[0]='C' then begin
         ValeurPotar[3]:=512;
         PotarActif[3]:=true;
         offsetC[0] := 0;
         unVoltC[0] :=1.5;
         MiniAff[0]:=0;
         MaxiAff[0]:=15;
         NomC[0]:='cO2';
         nomUniteC[0]:='mg/L';
         SignifC[0]:='concentration O2';
         TitreC[0]:='Oxymtre 15 mg/L';
       end;
    fichier.free;
end; // ChargeListeCapteurs 

procedure Tvoie.setNumOrphy(value : integer);
begin
    FnumOrphy := value
end;

procedure Tvoie.setMaxi(value : double);
begin
    Fmaxi := value
end;

function Tvoie.getCapteurNonLin : boolean;
begin
    result := (avecCapteur or (indexCapteurAuto>0)) and
              (parser<>nil) and
              (parser.expression<>'')
end;

procedure Tvoie.setMini(value : double);
begin
    Fmini := value
end;

Procedure Tvoie.Store(Avoie : string;Fichier : tMemIniFile);
begin with fichier do begin
      WriteString(Avoie,'Nom',nom);
      WriteString(Avoie,'Unite',nomUnite);
      WriteString(Avoie,'Signif',signif);
      WriteFloat(Avoie,'Mini',mini);
      WriteFloat(Avoie,'Maxi',maxi);
      if not avecCapteur and
         (numOrphy>=0) and
         (indexCapteurAuto=0) then begin
         offset := 0;
         UnVolt := 1;
         expression := '';
      end;
      WriteFloat(Avoie,'Offset',Offset);
      WriteFloat(Avoie,'UnVolt',UnVolt);
      WriteInteger(Avoie,'NumeroOrphy',FnumOrphy);
      WriteInteger(Avoie,'Moyenne',NbreMoyenne);
      if indexCapteurAuto=0
         then WriteBool(Avoie,'Active',active)
         else WriteBool(Avoie,'Active',false);
      WriteInteger(Avoie,'Couleur',couleur);
      WriteInteger(Avoie,'CapteurAuto',indexCapteurAuto);
      if (indexCapteurAuto>0) and
         (ListeCapteursAuto[indexCapteurAuto].NbreUniteBis>0)
            then WriteInteger(Avoie,'UniteCapteurAuto',ListeCapteursAuto[indexCapteurAuto].codeUniteC)
            else WriteInteger(Avoie,'UniteCapteurAuto',0);
      WriteInteger(Avoie,'Motif',ord(motif));
      WriteString(Avoie,'Expression',Expression);
      WriteBool(Avoie,'Capteur',avecCapteur);
      WriteBool(Avoie,'Etalonnage',AvecPotar);
      WriteBool(Avoie,'Photocolor',IsPhotocolor);
      WriteBool(Avoie,'Lumicolor',IsLumicolor);
      WriteBool(Avoie,'LumicolorDB15',IsLumicolorDB15);
end end; // Tvoie.store

Destructor Tvoie.destroy;
begin
     parser.free
end;

Constructor Tvoie.create(num : integer);
var i : integer;
begin
     inherited create;
     parser := nil;
     tensionRef := 0.1;
     nom := 'V'+intToStr(num);
     nomUnite := 'V';
     signif := '';
     Mini := -5;
     Maxi := 5;
     Offset := 0;
     UnVolt := 1;
     ValeurCourante := 0;
     numOrphy := num-voieA;
     avecAmpli := false;
     avecPotar := false;
     Motif := mCroix;
     couleur := CouleurDefaut[num];
     indexCapteurAuto := 0;
     for i := 0 to maxMoyenne do
         oldValeurs[i] := sansSignif;
end;

Procedure Tvoie.setMinMax;
var maxmax,marge : double;
    exponent : integer;
begin
   if nomUnite='hPa' then setExposant(100,0);
   if not AvecCapteur and (indexCapteurAuto=0) then begin
      if Fmini<-10 then Fmini := -10;
      if Fmaxi>+10 then Fmaxi := +10;
   end;
   VerifMinMaxDouble(Fmini,Fmaxi);
   if not capteurNonLin then begin
       Marge := abs(ValeurReal(64)-ValeurReal(0));
       if (Fmaxi-Fmini)<marge then Fmaxi := Fmini+Marge;
   end;
   MaxMax := abs(Fmaxi);
   if MaxMax<abs(Fmini) then MaxMax := abs(Fmini);
   Exponent := floor(Log10(MaxMax));
   if (Exponent mod 3) < 0
      then Exponent := (Exponent div 3)-1
      else Exponent := Exponent div 3;
// la division euclidienne des informaticiens <> div des maths ! 
   setExposant(maxmax,Exponent);
end; // setMinMax

function Tvoie.CodeVoie : string;
begin
     codeVoie := IntToStr(FnumOrphy)
end;

Function Tvoie.GetNomVoieOrphy : string;
begin
     if isGTI2
        then case connectiqueGTI2 of
           coNone : case FnumOrphy of
           0..3 : result := 'EA'+intToStr(FnumOrphy); // inaccessible
           4..7 : result := 'EA-'+Ansichar(FnumOrphy+ord('G')-4); // DB15
           8..11 : result := 'EAD-'+Ansichar(FnumOrphy+ord('G')-8); // DB15
           end;
           coDIN : case FnumOrphy of
           0..1 : result := 'EA'+intToStr(FnumOrphy)+'-A'; // module
           2..3 : result := 'EA'+intToStr(FnumOrphy)+'-F'; // module
           4..5 : result := 'EA'+intToStr(FnumOrphy)+'-B'; // module
           6..7 : result := 'EA'+intToStr(FnumOrphy)+'-C'; // module
           8..11 : result := 'EAD-'+Ansichar(FnumOrphy+ord('G')-8); // DB15
           end;
           coExtension : case FnumOrphy of
           0..3 : result := 'EA'+intToStr(FnumOrphy); // module banane
           4..7 : result := 'EA'+intToStr(FnumOrphy); // module BNC
           8..11 : result := 'EAD-'+Ansichar(FnumOrphy+ord('G')-8); // DB15
           end;
        end // case connectique
        else case FnumOrphy of
           0..9 : result := 'EA'+intToStr(FnumOrphy);
           10..11 : result := 'EAD'+intToStr(FnumOrphy-10);
           else result := ''
        end;
end;

Function Tvoie.ValeurReal(V : integer) : double;
begin
     result := valeurVolt(V);
     if capteurNonLin
        then begin
           if parser<>nil
             then begin
                 try
                 Parser.V := result;
                 VoltRefParser^ := tensionRef;
                 result := Parser.Value;
                 except
                   result := sansSignif;
                 end;
             end
             else result := sansSignif;
       end
       else if avecCapteur or (indexCapteurAuto>0)
          then begin
             result := Offset+unVolt*result;
             if indexCapteurAuto>0 then begin
                if result<Fmini then result := Fmini;
                if result>Fmaxi then result := Fmaxi;
             end;
          end;
end;

Function Tvoie.VoltToReal(V : double) : double;
begin
     result := V;
     if avecCapteur or (indexCapteurAuto>0) then result := Offset+unVolt*result;
end;

Function Tvoie.CalibreMaxi : double;
begin
     if CapteurNonLin
        then result := Fmaxi
        else result := valeurReal(HardMaxi)
end;

Function Tvoie.CalibreMini : double;
begin
     if CapteurNonLin
        then result := Fmini
        else result := valeurReal(-HardMaxi)
end;

Function Tvoie.ValeurVolt(V : integer) : double;
begin
    result := 20.0*V/MaxiHardEA
end;

procedure Tvoie.RazVecteur;
var i : integer;
begin
    for i := 0 to MaxVecteur do begin
       vecteurAff[i] := 0;
       vecteurCourant[i] := 0;
    end;
end;

Procedure Tvoie.Load(Avoie : string;fichier : tMemIniFile);

procedure GTS2versGTI2;
begin
   if FnumOrphy=8 then FnumOrphy := 4; // prise G EA
   if FnumOrphy=9 then FnumOrphy := 5; // prise H EA
   if FnumOrphy=10 then FnumOrphy := 8; // prise G EAD0
   if FnumOrphy=11 then FnumOrphy := 9; // prise H EAD1
end;

procedure GTI2versGTS2;
begin
   if FnumOrphy=4 then FnumOrphy := 8; // prise G EA
   if FnumOrphy=5 then FnumOrphy := 9; // prise H EA
   if FnumOrphy=8 then FnumOrphy := 10; // prise G EAD0
   if FnumOrphy=9 then FnumOrphy := 11; // prise H EAD1
end;

begin with fichier do begin
      AvecPotar := ReadBool(Avoie,'Etalonnage',false);
      AvecCapteur := ReadBool(Avoie,'Capteur',false);
      Nom := ReadString(Avoie,'Nom',Nom);
      NomUnite := ReadString(Avoie,'Unite',NomUnite);
      Signif := ReadString(Avoie,'Signif','');
      Mini := ReadFloat(Avoie,'Mini',-5);
      Maxi := ReadFloat(Avoie,'Maxi',5);
      offset := ReadFloat(Avoie,'Offset',0);
      unVolt := ReadFloat(Avoie,'UnVolt',1);
      active := ReadBool(Avoie,'Active',false);
      isPhotocolor := ReadBool(Avoie,'Photocolor',false);
      isLumicolor := ReadBool(Avoie,'Lumicolor',false);
      isLumicolorDB15 := ReadBool(Avoie,'LumicolorDB15',false);
      NbreMoyenne := readInteger(Avoie,'Moyenne',1);
      numOrphy := ReadInteger(Avoie,'NumeroOrphy',0);
      Couleur := readInteger(Avoie,'Couleur',couleur);
      Motif := Tmotif(readInteger(Avoie,'Motif',0));
      indexCapteurAuto := ReadInteger(Avoie,'CapteurAuto',0);
      if (indexCapteurAuto>0) and
         (ListeCapteursAuto[indexCapteurAuto].NbreUniteBis>0)
            then ListeCapteursAuto[indexCapteurAuto].codeUniteC := readInteger(Avoie,'UniteCapteurAuto',0);
      Expression := ReadString(Avoie,'Expression','');
      if not AvecCapteur and
         (indexCapteurAuto=0) and
         ((offset<>0) or (UnVolt<>1)) then
            avecCapteur := true; 
      isPhotocolor := isPhotocolor and avecCapteur;
      isLumicolor := isLumicolor and avecCapteur;
      isLumicolorDB15 := isLumicolorDB15 and avecCapteur;            
      if isGTI2<>isFichierGTI2 then
          if isGTI2 then GTS2versGTI2 else GTS2versGTI2;
      setMinMax;
end end;                                               

Function Tvoie.CalibreVoie : string;
begin
   if maxi*mini<0
      then if (maxi+mini)<(maxi-mini)/10
            then result := ''+formatUnite(maxi)
            else result := formatUniteDouble(mini,maxi)
      else if maxi>0
           then result := formatUnite(maxi)
           else result := formatUnite(mini)
end;

Function Tvoie.AffVoltmetre : string;
begin
    result := FormatUniteExp(valeurAff,true)
end;

Function Tvoie.AffValeur(i : integer) : string;
begin
    result := FormatUniteExp(vecteurAff[i],false)
end;

function TlisteCapteur.Add(Item : Tcapteur) : Integer;
begin
     result := inherited Add(Item)
end;

function TlisteCapteur.Get(Index : Integer) : Tcapteur;
begin
  Result := Tcapteur(inherited Get(Index))
end;

function TlisteCapteur.IndexOf(Item : Tcapteur) : Integer;
begin
  Result := inherited IndexOf(Item)
end;

procedure TlisteCapteur.Put(Index : Integer;Item : Tcapteur);
begin
  inherited Put(Index,Item)
end;

function TlisteCapteur.Remove(Item : Tcapteur) : Integer;
begin
  Result := inherited Remove(Item);
  Item.free;
end;

Procedure TListeCapteur.clear;
var i : Integer;
begin
  for i := 0 to pred(Count) do Items[i].Free;
  inherited Clear;
end;

function SeuilSynchroVolt(valeur : integer) : double;
begin
     if isGTI2
        then result := 20*valeur/4096-10
        else result := 20*valeur/256-10
end;

  Function ValeurWDAC(SAi : byte;V : double) : word;
  begin
    if SAi=0
       then begin
          if V>5 then V := 5;
          if V<0 then V := 0;
          Result := round(maxiHardSA*V/5.0);
       end
       else begin
          if V>5 then V := 5;
          if V<-5 then V := -5;
          Result := round(maxiHardSA*(V+5.0)/10.0);
       end;
end;

constructor Tcapteur.create;
begin
        AvecPotarC := false;
        AvecAmpliC := false;
        LinearC := true;
        Offsetc := 0;
        unVoltc := 10;
        constructeur := cDin;
        nomC := 'T';
        NomUniteC := 'C';
        signifC := '';
        aideC := '';
        titreC := '';
end;

constructor TcapteurAuto.create(acode : integer);
var i : integer;
begin
        CodeAuto := Acode;
        Offsetc[0] := 0;
        unVoltc[0] := 10;
        expressionC[0] := '';
        nomC[0] := 'T';
        NomUniteC[0] := 'C';
        signifC[0] := '';
        titreC[0] := '';
        modeAcq := AcqTemps;
        for i := 1 to MaxUniteAuto do begin
            nomC[i] := '';
            signifC[i] := '';
            titreC[i] := '';
            nomUniteC[i] := '';
            Offsetc[i] := 0;
            unVoltc[i] := 0;
            MiniAff[i] := 0;
            MaxiAff[i] := 0;
            expressionC[i] := '';
        end;
        nbreUniteBis := 0;
        for i := 0 to MaxPotarAuto do begin
            valeurPotar[i] := 0;
            PotarActif[i] := false;
            valeurAttendue[i] := 0;
        end;
        MiniAff[0] := -50;
        MaxiAff[0] := 110;
        EtalonnageFait := false;
end;

function TcapteurAuto.avecEtalonnage;
var i : integer;
begin
     result := false;
     for i := 0 to maxPotarAuto do
         result := result or potarActif[i]
end;

procedure Tcapteur.assign(Acapteur : Tcapteur);
begin
      AvecPotarC := Acapteur.avecPotarC;
      LinearC := Acapteur.LinearC;
      AvecAmpliC := Acapteur.avecAmpliC;
      OffsetC := Acapteur.offsetc;
      UnVoltC := Acapteur.unVoltc;
      nomC := Acapteur.nomC;
      NomUniteC := Acapteur.NomUniteC;
      signifC := Acapteur.signifC;
      titreC := Acapteur.titreC;
      aideC := Acapteur.aideC;
      MiniAff := Acapteur.miniAff;
      MaxiAff := Acapteur.maxiAff;
end;

Function nomEtatAcq(etat : TetatAcq) : string;
begin
     case etat of
          eaAttenteSynchro : result := trWaitSynchro;
          eaTerminee : result := trAcqFinie;
          eaAttenteResul : result := trAttenteResul;
          eaMajResul : result := '';
     end;
end;

function nomModeAcq(mode : TModeAcq) : string;
begin
    case mode of
        AcqClavier : result := trClavier;
        AcqTemps : result := trTemporel;
        AcqPoint : result := trPointparpoint;
        AcqMagnum : result := trMagnum;
        AcqSortieAna : result := trSortieAna;
        AcqUnMega : result := trUnMega;
    end;
end;

Function nomSynchro(mode : TModeSynchro) : string;
begin
     case mode of
         S_front : result := trFront;
         S_seuil : result := trSeuil;
         S_relaxe : result := trRelaxe;
         S_clavier : result := trBarreEspace;
         S_nerf : result := trNerf;
         s_bouge : result := trBouge;
         s_sondor : result := trSondor;
         s_sodar : result := trSodar;         
    end;
end;

function Tvoie.getExpression : string;
begin
    if (parser=nil)
       then result := ''
       else result := parser.expression
end;

procedure Tvoie.setExpression(Avalue : string);
begin
    if Avalue<>'' then begin
        if parser=nil then begin
           Parser := Tparser.create(nil);
           VoltRefParser := Parser.SetVariable('V0',0.1);
        end;
        try
        TrimComplet(Avalue);
        Parser.expression := Avalue;
        except
           showMessage('Erreur de syntaxe'+crCR+
                       'Utiliser le point dcimal'+crCR+
                       'Tension mesure : V');
        end;
    end
    else if parser<>nil then parser.expression := '';
end;

function TcapteurAuto.getExpression : string;
begin
    if (parser=nil)
       then result := ''
       else result := expressionC[codeUniteC]
end;

procedure TcapteurAuto.setExpression(Avalue : string);
begin
    expressionC[1] := Avalue;
    if Avalue<>'' then begin
        if parser=nil then begin
           Parser := Tparser.create(nil);
        end;
        try
        trimComplet(Avalue);
        Parser.expression := Avalue;
        except
           Parser.expression := '';
           showMessage('Erreur de syntaxe'+crCR+
                       'Utiliser le point dcimal'+crCR+
                       'log dcimal de x = log10(x)');
        end;
    end
    else if parser<>nil then Parser.expression := '';
end;

Function TcapteurAuto.ValeurReal(V : integer) : double;
begin
     result := 20.0*V/MaxiHardEA;
     if (parser<>nil) and (codeUniteC>0)
        then begin
             try
                Parser.V := result;
                result := Parser.Value;
             except
                result := sansSignif;
             end;
       end
       else result := OffsetC[codeUniteC]+unVoltC[codeUniteC]*result;
end;

Procedure TcapteurAuto.Store(fichier : TmemIniFile);
var ligne : string;
    j : integer;
    i : indiceUniteAuto;
begin
            ligne := 'Auto'+IntToStr(codeAuto);
            for j := 0 to MaxPotarAuto do begin
                fichier.writeInteger(ligne,'ValeurPotar'+intToStr(j),valeurPotar[j]);
                fichier.writeBool(ligne,'PotarActif'+intToStr(j),PotarActif[j]);
                fichier.writeString(ligne,'AidePotar'+intToStr(j),aidePotar[j]);
                fichier.writeFloat(ligne,'Valeur'+intToStr(j),valeurAttendue[j]);
            end;
            fichier.writeString(ligne,'Expression',ExpressionC[0]);
            fichier.writeFloat(ligne,'0V',Offsetc[0]);
            fichier.writeFloat(ligne,'1V',UnVoltc[0]);
            fichier.writeFloat(ligne,'Mini',MiniAff[0]);
            fichier.writeFloat(ligne,'Maxi',MaxiAff[0]);
            fichier.writeString(ligne,'Nom',nomC[0]);
            fichier.writeString(ligne,'Unite',nomUniteC[0]);
            fichier.writeString(ligne,'Signif',signifC[0]);
            fichier.writeString(ligne,'Titre',titreC[0]);
            for i := 1 to maxUniteAuto do if nomC[i]<>'' then begin
                 fichier.writeString(ligne,'Nom'+intTostr(i),nomC[i]);
                 fichier.writeString(ligne,'Unite'+intTostr(i),nomUniteC[i]);
                 fichier.writeString(ligne,'Signif'+intTostr(i),signifC[i]);
                 fichier.writeString(ligne,'Titre'+intTostr(i),titreC[i]);
                 fichier.writeFloat(ligne,'0V'+intTostr(i),Offsetc[i]);
                 fichier.writeFloat(ligne,'1V'+intTostr(i),UnVoltc[i]);
                 fichier.writeFloat(ligne,'Mini'+intTostr(i),MiniAff[i]);
                 fichier.writeFloat(ligne,'Maxi'+intTostr(i),MaxiAff[i]);
                 fichier.writeString(ligne,'Expression'+intTostr(i),ExpressionC[i]);
            end;
            fichier.writeInteger(ligne,'Code',codeUniteC);
            fichier.writeInteger(ligne,'modeAcq',ord(modeAcq));
            fichier.writeBool(ligne,'Synchro',capteurSynchro);
            fichier.writeBool(ligne,'PotarFige',potarFige);
end;

Procedure TcapteurAuto.Load(fichier : TmemIniFile);
var ligne : string;
    j : integer;
    i : indiceUniteAuto;
begin
            ligne := 'Auto'+IntToStr(codeAuto);
            EtalonnageFait := true;
            for j := 0 to MaxPotarAuto do begin
                valeurPotar[j] := fichier.readInteger(ligne,'ValeurPotar'+intToStr(j),valeurPotar[j]);
                PotarActif[j] := fichier.readBool(ligne,'PotarActif'+intToStr(j),PotarActif[j]);
                if PotarActif[j] then EtalonnageFait := false;                
                aidePotar[j] := fichier.readString(ligne,'AidePotar'+intToStr(j),aidePotar[j]);
                valeurAttendue[j] := fichier.readFloat(ligne,'Valeur'+intToStr(j),valeurAttendue[j]);
            end;
            ExpressionC[0] := fichier.readString(ligne,'Expression','');
            Offsetc[0] := fichier.readFloat(ligne,'0V',Offsetc[0]);
            UnVoltc[0] := fichier.readFloat(ligne,'1V',UnVoltc[0]);
            MiniAff[0] := fichier.readFloat(ligne,'Mini',MiniAff[0]);
            MaxiAff[0] := fichier.readFloat(ligne,'Maxi',MaxiAff[0]);
            modeAcq := TmodeAcq(fichier.readInteger(ligne,'modeAcq',1));
            nomC[0] := fichier.readString(ligne,'Nom',nomC[0]);
            nomUniteC[0] := fichier.readString(ligne,'Unite',nomUniteC[0]);
            signifC[0] := fichier.readString(ligne,'Signif',signifC[0]);
            titreC[0] := fichier.readString(ligne,'Titre',titreC[0]);
            nbreUniteBis := 0;
            for i := 1 to maxUniteAuto do begin
                ExpressionC[i] := fichier.readString(ligne,'Expression'+intTostr(i),'');
                nomC[i] := fichier.readString(ligne,'Nom'+intTostr(i),'');
                nomUniteC[i] := fichier.readString(ligne,'Unite'+intTostr(i),'');
                signifC[i] := fichier.readString(ligne,'Signif'+intTostr(i),'');
                titreC[i] := fichier.readString(ligne,'Titre'+intTostr(i),'');
                Offsetc[i] := fichier.readFloat(ligne,'0V'+intTostr(i),0);
                UnVoltc[i] := fichier.readFloat(ligne,'1V'+intTostr(i),0);
                MiniAff[i] := fichier.readFloat(ligne,'Mini'+intTostr(i),0);
                MaxiAff[i] := fichier.readFloat(ligne,'Maxi'+intTostr(i),UnVoltC[i]);
                if (nomC[i]<>'') and
                   ((UnVoltc[i]<>0) or (expressionC[i]<>'')) then inc(NbreUniteBis);
            end;
            codeUniteC := fichier.readInteger(ligne,'Code',0);
            if nbreUniteBis=0 then codeUniteC := 0;
            capteurSynchro := fichier.readBool(ligne,'Synchro',false);
            potarFige := fichier.readBool(ligne,'PotarFige',false);            
end;

procedure Tvoie.affecteCapteur(capteurCourant : TCapteur);
begin with CapteurCourant do begin
            nom := nomC;
            nomUnite := nomUniteC;
            signif := signifC;
            aide := aideC;
            numOrphy := numeroC;
            if isGTI2 then begin // changement numro prise DB15
               if numeroC in [8,9] then numOrphy := numeroC-4;
               if numeroC in [10,11] then numOrphy := numeroC-2;
            end;
            Mini := MiniAff;
            Maxi := MaxiAff;
            AvecAmpli := AvecAmpliC;
            if avecAmpli then begin
                numOrphy := 2;
                afficheErreur(erAmpli);
            end;
            avecPotar := avecPotarC;
            avecCapteur := true;
            Offset := OffsetC;
            UnVolt := UnVoltC;
            setMinMax;
            if linearC
               then expression := ''
               else expression := expressionC;
            isPhotocolor := genre=gPhotocolor;
            isLumicolor := genre=gLumicolor;
            isLumicolorDB15 := genre=gLumicolorDB15;
            if isPhotocolor then tensionRef := 1;
            if isLumicolor then tensionRef := 4.3;
            if isLumicolorDB15 then tensionRef := 1.9;
    end;
    indexCapteurAuto := 0;
end;

Procedure Tvoie.ChercheCapteur(genre : TgenreCapteur);
var i : integer;
    capteurCourant : TCapteur;
    trouve : boolean;
begin
    trouve := false;
    capteurCourant := nil;
    i := 0;
    while (i<listeCapteur.count) and not trouve do begin
         CapteurCourant := listeCapteur.items[i];
         trouve := capteurCourant.genre=genre;
         inc(i);
    end;
    if not trouve then begin
       capteurCourant := Tcapteur.create;
       ListeCapteur.add(CapteurCourant);
       case genre of
            gPhase : begin
                  capteurCourant.OffsetC:=0;
                  capteurCourant.UnvoltC:=36;
                  capteurCourant.NomC:='';
                  capteurCourant.NomUniteC:='';
                  capteurCourant.SignifC:='Phase';
                  capteurCourant.MaxiAff:=180;
                  capteurCourant.MiniAff:=-180;
                  capteurCourant.NumeroC:=9;
                  capteurCourant.AideC:='Phase de "jaune" / "vert"';
            end;
            gEntree : begin
                  capteurCourant.OffsetC:=0;
                  capteurCourant.UnvoltC:=1;
                  capteurCourant.NomC:='Ve';
                  capteurCourant.NomUniteC:='V';
                  capteurCourant.SignifC:='Tension efficace d''entre';
                  capteurCourant.MaxiAff:=10;
                  capteurCourant.MiniAff:=0;
                  capteurCourant.NumeroC:=8;
                  capteurCourant.AideC:='fil vert prise H';
            end;
            gSortie : begin
                  capteurCourant.OffsetC:=0;
                  capteurCourant.UnvoltC:=1;
                  capteurCourant.NomC:='Vs';
                  capteurCourant.NomUniteC:='V';
                  capteurCourant.SignifC:='Tension efficace de sortie';
                  capteurCourant.MaxiAff:=10;
                  capteurCourant.MiniAff:=0;
                  capteurCourant.NumeroC:=11;
                  capteurCourant.AideC:='fil jaune prise H';
            end;
       end;
    end;
    AffecteCapteur(CapteurCourant);
end;

function NumToCodePotar(numOrphy : integer) : Ansichar;
begin
   if isGTI2
      then if numOrphy<8
          then result := ' '
          else result := Ansichar(ord('0')+numOrphy-8)
      else if numOrphy<10
         then result := ' '
         else result := Ansichar(ord('0')+numOrphy-10)
end;

function TOxymetre.temperature(V : integer) : double;
var volt : double;
begin
     volt := 20.0*V/MaxiHardEA;
     if volt<1.47
        then Temp := 0
        else if volt<2.106
             then Temp := (3.5758-volt)/0.04199
             else if volt<3.8287
                  then Temp := (3.8287-volt)/0.049216
                  else Temp := 100;
     result := Temp;
end;

function TOxymetre.valeurAttendue : integer;
var X,Y,Tp : double;
begin
    X := ((((-2.7825548e-9*Temp
            +8.2611937e-7)*Temp
            -1.1381568e-4)*Temp
            +8.5384937e-3)*Temp
            -0.41022722)*Temp
            +14.6460;
    Tp := Temp-20;
    Y := ((((+3.042e-8*Tp
            +5.3782e-6)*Tp
            +5.9652e-4)*Tp
            +3.9262e-2)*Tp
            +1.4478)*Tp
            +23.373;
    cRef := X*(1013-Y)/1013;
    try
    result := round(cRef*32767/15);
    except
       result := -1;
    end;
end;

function TOxymetre.concentration(V : integer) : double;
begin
     result := 15*V/32767;
end;

function TOxymetre.MesureT : string;
begin
    case code of
        '0' : result := 'WDAC '+code+' 255';
        '1' : result := 'WDAC '+code+' 255';
        '2' : result := 'WRBIT 6';
        '3' : result := 'WRBIT 7';
    end;
end;

function TOxymetre.MesureC : string;
begin
    case code of
        '0' : result := 'WDAC '+code+' 0';
        '1' : result := 'WDAC '+code+' 0';
        '2' : result := 'WSBIT 6';
        '3' : result := 'WSBIT 7';
    end;
end;

initialization
    NomFichierCapteurs := changeFileExt(paramstr(0),'.CPT');
    ListeCapteur := TlisteCapteur.create;
    oxymetre := Toxymetre.create;
    ChargeListeCapteurs;
Finalization
    ListeCapteur.clear;
    ListeCapteur.free;
    oxymetre.free;
end.
