unit GTSUTIL;

interface

uses
   SysUtils, Windows, Messages, Classes, Dialogs,
   Graphics, Forms, Printers, Controls, Consts, oomisc, awUser, lnsWin32,
   Math, Maths, StdCtrls, registry, constgts, inifiles, ShlObj;

const
   WM_Acq_PointAttente = WM_USER + 4;
   WM_Acq_LanceCardiaque = WM_USER + 6;
   DureeMinDeconnect = 10 * 60;   // dix minutes
   crCR           = #13;
   RegistreGTS    = 'Software\GTS2';
   PrecisionGTS   = 5;
   PrecisionTime  = 7;
   LongNom        = 8;
   LongUnite      = 20;
   SymbReg: char  = '';
   SymbReg2: char = '&';
   UnJour: double = 24 * 3600.0;
   UneHeure: double = 3600.0;
   QuartdHeure: double = 15 * 60.0;
   UneMinute: double = 60.0;
   DureeResul: array[0..3] of single = (0.005, 0.0025, 0.001, 0.0005);

        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gamma=WideChar($03B3);gammaMaj=WideChar($0393);
        delta=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phi=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambda=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigma=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omega=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);
        vide=WideChar(2205);videMaj=WideChar(2205);
        supegal=WideChar(2265);
        infegal=WideChar(2264);
        MoinsExp = WideChar($207B); // pas Tahoma
        PlusExp = WideChar($207A);

        Grecque = alpha+beta+gamma+gammaMaj+delta+deltaMaj+epsilon+
              chi+zeta+eta+theta+thetaMaj+kappa+
              lambda+lambdaMaj+mu+nu+xi+xiMaj+
              piMin+piMaj+rho+sigma+sigmaMaj+tau+
              phi+phiMaj+phi+psi+psiMaj+omega+omegaMaj;
        ChiffrePuiss = WideChar($2070)+WideChar($00B9)+WideChar($00B2)+
               WideChar($00B3)+WideChar($2074)+WideChar($2075)+WideChar($2076)+
               WideChar($2077)+WideChar($2078)+WideChar($2079)+MoinsExp+PlusExp;

        ChiffreExp : array[0..9] of wideChar =
  (WideChar($2070),WideChar($00B9),WideChar($00B2),WideChar($00B3),
   WideChar($2074),WideChar($2075),WideChar($2076),WideChar($2077),
   WideChar($2078),WideChar($2079)); // Tahoma 1 2 3 uniquement

        ChiffreExpR : array[0..9] of ansiChar =
  (AnsiChar(186),AnsiChar(185),AnsiChar(178),AnsiChar(179),
   AnsiChar(165),AnsiChar(169),AnsiChar(172),AnsiChar(173),
   AnsiChar(174),AnsiChar(188));

       MoinsExpR = AnsiChar(170); // idem pour Regressi fontes
       PlusExpR = AnsiChar(184);
       infEgalR = AnsiChar(250);
       supEgalR = AnsiChar(249);

type
   EGetFloatError = class(Exception);
   ChaineAzt = array[0..255] of char;
   CoefUnite  = (zero, yocto, zepto, atto, femto, pico, nano, micro, milli,
      nulle, kilo, mega, giga, tera, peta, exa, zetta, yotta, infini);
   pseudoWord = record
      case byte of
         0: (octets: array[0..11] of AnsiChar);
         1: (mot: word);
         2: (entier: smallInt);
         3: (longMot: longWord);
         4: (octet: byte);
         5: (indexG, indexH: byte;
            valeurG, valeurH: smallInt);
         6: (Entre, Sortie, phase, Freq, Nombre: word);
         7: (index: array[1..4] of byte;
             valeur: array[1..4] of smallInt);
   end;

const
   crSupprArr = char(vk_back);
   crSuppr    = char(vk_clear);
   crHaut     = char(vk_up);
   crBas      = char(vk_down);
   crGauche   = char(vk_left);
   crDroite   = char(vk_right);
   crHome     = char(vk_home);
   crEnd      = char(vk_end);
   crLF       = #10;
   crESC      = #27;
   crTab      = char(vk_tab);
   Separateur= [' ', crTab, ','];
   Majuscule= ['A'..'Z'];
   Minuscule= ['a'..'z'];
   CharGetFloat=
      ['0'..'9', '+', '-', 'e', 'E', '.', ',', 'm', '', 'n', 'f', 'k', 'M', 'G', 'T',
      '(', ')', crSupprArr, crTab, crCR];
   Chiffre= ['0'..'9'];
   ChiffreEtc= ['0'..'9', '+', '-', 'e', 'E', '.'];
   ChiffreWin= ['0'..'9', '+', '-', 'e', 'E', '.', ','];
   ToucheEdition= [crSupprArr, crGauche, crDroite, crHome, crEnd, crSuppr];

   caracPrefixe=
      ['y', 'z', 'a', 'f', 'p', 'n', '', 'm', 'k', 'M', 'G', 'T', 'P', 'E'];
   caracUnite=
      ['A'..'Z', 'a'..'z', OmegaMaj, '1'..'3', '-', '.', '/', ''];

   prefixeUnite: array[coefUnite] of char =
      ('0', 'y', 'z', 'a', 'f', 'p', 'n', '', 'm',
      ' ', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', '');
   valUnite: array[coefUnite] of double =
      (1E-27, 1E-24, 1E-21, 1E-18, 1E-15, 1E-12, 1E-9, 1E-6, 1E-3,
      1, 1E+3, 1E+6, 1E+9, 1E+12, 1E+15, 1E+18, 1E+21, 1E+24, 1E+27);
   puissanceUnite: array[coefUnite] of shortInt =
      (-27, -24, -21, -18, -15, -12, -9, -6, -3,
      0, +3, +6, +9, +12, +15, +18, +21, +24, +27);
   expUnite: array[coefUnite] of string =
      ('E-27', 'E-24', 'E-21', 'E-18', 'E-15', 'E-12', 'E-9', 'E-6', 'E-3',
      '', 'E+3', 'E+6', 'E+9', 'E+12', 'E+15', 'E+18', 'E+21', 'E+24', 'E+27');

procedure afficheErreurStr(texte: string);
function ToucheValidation(key: word): boolean;
procedure TrimComplet(var S: string);
function Pad(S: string; Len: integer): string;
function ConvertitChaine(nombre: string; var valeur: double): boolean;
function FormatGTS(nombre: double): string;
function FormatTime(nombre: double): string;
function GetFloat(Nombre: String): double;
function FloatToStrPoint(valeur: double): string;
function StrToFloatWin(nombre: string): double;
function EncodeDuree(duree: longint): TdateTime;
function DureeEcoulee(InstantDebut: TdateTime): double;
function CaracToChiffre(carac: char): integer;
procedure ConvertitPrefixe(var nombre: string);
procedure VerifKeyGetFloat(var key: char);
Function UnicodeVersRW3(s : string) : string;

function DateTimeToFloat(nombre: string): double;
function valeur125(valeur: double): double;

var
   appDataDir, mesDocsDir: string;
   VitesseCom:         integer = 0;

implementation

procedure TrimComplet(var s: string);
var
   longueur, posCourant: integer;
begin
   longueur := Length(s);
   posCourant := 1;
   while (posCourant <= longueur) do
      if Ord(s[posCourant]) <= 32 then
      begin
         Delete(s, posCourant, 1);
         Dec(longueur);
      end
      else
         Inc(posCourant);
end;

function StrToFloatWin(nombre: string): double;
var
   posSeparator: integer;
begin
   trimComplet(nombre);
   if decimalSeparator <> ',' then begin
      posSeparator := pos(',', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := decimalSeparator;
   end
   else if decimalSeparator <> '.' then begin
      posSeparator := pos('.', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := decimalSeparator;
   end;
   ConvertitPrefixe(nombre);
   try
      StrToFloatWin := strToFloat(nombre);
   except
      StrToFloatWin := sansSignif;
   end;
end;

function FloatToStrPoint(valeur: double): string;
var
   nombre: string;
   posSeparator: integer;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 2);
   if decimalSeparator <> '.' then
   begin
      posSeparator := pos(decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   Result := nombre;
end;

function ConvertitChaine(nombre: string; var valeur: double): boolean;
begin
   if (upcase(nombre[1]) = 'E') then
      nombre := '1' + nombre
   else if (nombre[1] = '.') or (nombre[1] = ',') then
      nombre := '0' + nombre;
   convertitPrefixe(nombre);
   convertitChaine := True;
   try
      valeur := StrToFloatWin(nombre);
   except
      convertitChaine := False;
   end;
end;

function FormatGeneral(Nombre: double; Nchiffres: integer): string;
var
   Nexp: integer;
begin
   if Nombre = sansSignif then
   begin
      FormatGeneral := ' ';
      exit;
   end;
   if abs(Nombre) < 1e-10 then
      Nexp := 2
   else if abs(Nombre) < 1e+10 then
      Nexp := 1
   else
      Nexp := 2;
   FormatGeneral := FloatToStrF(nombre, ffGeneral, Nchiffres, Nexp);
end;

function FormatGTS(Nombre: double): string;
begin
   Result := FormatGeneral(Nombre, PrecisionGTS);
end;

function FormatTime(Nombre: double): string;
begin
   FormatTime := FormatGeneral(Nombre, PrecisionTime);
end;

procedure afficheErreurStr(texte: string);
var
   SauveCursor: Tcursor;
begin
   SauveCursor := Screen.cursor;
   Screen.cursor := crDefault;
   MessageDlg(texte, mtError, [mbOK], 0);
   Screen.cursor := SauveCursor;
end;

procedure ConvertitPrefixe(var nombre: string);
var
   u: coefUnite;
   c: char;
begin
   c := nombre[length(nombre)];
   if charinset(c,caracPrefixe) then begin
      u := zero;
      repeat
         Inc(u)
      until (c = prefixeUnite[u]);
      Delete(nombre, length(nombre), 1);
      nombre := nombre + expUnite[u];
   end;
end;

function ToucheValidation(key: word): boolean;
begin
   ToucheValidation := key in [vk_tab, vk_left, vk_right, vk_down, vk_up, vk_return];
end;

function Pad(S: string; Len: integer): string;
   {-Return a string right-padded to length len with ' '}
var
   i,Slen: integer;
begin
   Slen := length(S);
   if SLen >= Len
      then result := copy(S,1,Len)
      else begin
         result := S;
         for i := Slen+1 to (len-Slen) do
             result := result+' ';
      end;
end;

function EncodeDuree(duree: longint): TdateTime;
var
   h, m, s, ms: word;
begin
   h  := duree div 3600;
   duree := duree - h * 3600;
   m  := duree div 60;
   duree := duree - m * 60;
   s  := duree;
   ms := 0;
   EncodeDuree := EncodeTime(h, m, s, ms);
end;

function DureeEcoulee(InstantDebut: TdateTime): double;
var
   h, m, s, ms: word;
begin
   decodeTime(now - instantDebut, h, m, s, ms);
   DureeEcoulee := h * 3600.0 + m * 60.0 + s * 1.0 + ms * 0.001;
end;

Function CaracToChiffre(carac : char) : integer;
var i : integer;
begin
      if charInSet(carac,chiffre)
         then result := ord(carac)-ord('0')
         else begin
            result := 0;
            for i := 0 to 9 do
                if carac=ChiffreExp[i] then begin
                   result := i;
                   break;
                end;
         end
end;

function WordToInt(V: word): integer; { de -512  +512 }
begin
   if V = 65535 then
      Result := 0
   else if V < 32768 then
      Result := V div 64  { 0  512 }
   else
      Result := V div 64 - 1024; { -512  -1 }
end;

function IntToWord(V: integer): word;
begin
   if V = 0 then
      Result := 65535
   else if V < 0 then
      Result := (V + 1024) * 64 { 32768  65472 }
   else
      Result := V * 64; { 0  32704 }
end;

function PosN(const C: string; S: string; const K: integer): integer;
var
   P: integer;
begin
   Result := 0;
   if K > 0 then
      Delete(S, 1, K);
   P := Pos(C, S);
   if P > 0 then
      Result := K + P;
end;

function DateTimeToFloat(nombre: string): double;
var
   i, Njour: integer;
begin
   Result := 0;
   trimComplet(nombre);
   i := pos(':', nombre);
   if i > 0 then
   begin
      i := pos('j', nombre);
      Njour := 0;
      if i > 0 then begin
         if i > 1 then begin
            try
               Njour := StrToInt(copy(nombre, 1, pred(i)));
            except
            end;
         end; { i>1 }
         Delete(nombre, 1, i);
      end { i>0 }
      else begin
         i := posN(':', nombre, 2);
         if i = 0 then
            nombre := '0:' + nombre;
      end;
      try
         Result := (StrToTime(nombre) + Njour) * 60 * 60 * 24;
      except
      end;
   end {i>0}
   else begin
      i := pos('j', nombre);
      if i > 0 then begin
         if i > 1 then begin
            try
               Result := StrToInt(copy(nombre, 1, pred(i))) * 60 * 24 * 60;
            except
            end;
         end;
         Delete(nombre, 1, i);
      end;
      i := pos('h', nombre);
      if i > 0 then begin
         if i > 1 then begin
            try
               Result := Result + StrToInt(copy(nombre, 1, pred(i))) * 60 * 60;
            except
            end;
         end;
         Delete(nombre, 1, i);
      end;
      i := pos('min', nombre);
      if i > 0 then
      begin
         if i > 1 then
         begin
            try
               Result := Result + StrToFloatWin(copy(nombre, 1, pred(i))) * 60;
            except
            end;
         end;
         Delete(nombre, 1, i + 2);
      end;
      i := pos('m', nombre);
      if i > 0 then
      begin
         if i > 1 then
         begin
            try
               Result := Result + StrToFloatWin(copy(nombre, 1, pred(i))) * 1e-3;
            except
            end;
         end;
         Delete(nombre, 1, i);
      end;
      i := pos('', nombre);
      if i > 0 then
      begin
         if i > 1 then
         begin
            try
               Result := Result + StrToFloatWin(copy(nombre, 1, pred(i))) * 1e-6;
            except
            end;
         end;
         Delete(nombre, 1, i);
      end;
      i := pos('s', nombre);
      if i > 0 then
         Delete(nombre, i, 1);
      if nombre <> '' then
      begin
         try
            Result := Result + strToFloatWin(nombre);
         except
         end;
      end;
      if Result = 0 then
         Result := 0.1;
   end;
end;

function GetFloat(Nombre: String): double;
const
   MaxPile = 10;
   CaracCte: TsyscharSet = [piMin, piMaj, 'P', 'I', 'p', 'i'];
type
   IndicePile = 1..MaxPile;
var
   Pile: array[IndicePile] of double;
   IndicePileCourant: 0..MaxPile;
   CaracCourant: char;
   PointeurExp: integer;

   procedure suivant;
   {Lit le prochain caractre et l'assigne  caracCourant}
   {Le caracCourant est toujours extrait avant appel d'un analyseur}
   begin
      Inc(pointeurExp);
      if pointeurExp <= length(Nombre) then
         caracCourant := Nombre[pointeurExp]
      else
         caracCourant := #0;
   end;

   procedure InitFonctor;
   begin
      pointeurExp := 0;
      indicePileCourant := 0;
      suivant;
   end;{ InitFonctor }

{Les procdures LireXXX extraient un XXX de la chaine Nombre  partir du
 pointeur courant }

   function LireNombre: double;
   var
      PointeurChiffre: integer;
      Valeur: double;
      NombreLoc: String;

      procedure lireEntier;
      begin
         while charinset(caracCourant,chiffre) do
            suivant;
      end;

   begin
      PointeurChiffre := PointeurExp;{pointe le premier chiffre du nombre}
      lireEntier;
      if charinset(caracCourant,['.', ',']) {C'est un nombre dcimal} then
      begin
         suivant;{on saute le .}
         lireEntier;
      end;
      if (upcase(caracCourant) = 'E') {puissance de 10} then
      begin
         suivant;{on saute le E}
         if (caracCourant = '+') or (caracCourant = '-') then
            suivant;
         lireEntier;
      end
      else if charinset(caracCourant,caracPrefixe) then
         suivant {coeff unit};
      NombreLoc := copy(nombre, pointeurChiffre, pointeurExp - PointeurChiffre);
      if not ConvertitChaine(nombreLoc, valeur) then
         raise EGetFloatError.Create('Erreur nombre');
      LireNombre := valeur;
   end; { lireNombre }

   function LireIdEnt: String;
   var
      PointeurIdent: integer;
   begin
      PointeurIdent := pointeurExp;
      while charinset(caracCourant,CaracCte) do
         suivant;
      if (pointeurExp - pointeurIdent) > longNom then
         raise EGetFloatError.Create('Identificateur trop long (>8)');
      LireIdent := copy(nombre, pointeurIdent, pointeurExp - pointeurIdent);
   end;{LireIdEnt}

   procedure Depile(var P: double);
   begin
      if indicePileCourant = 0 then
         raise EGetFloatError.Create('Erreur interne')
      else
      begin
         P := Pile[indicePileCourant];
         Dec(indicePileCourant);
      end;
   end;

   procedure Empile(P: double);
   begin
      if indicePileCourant = MaxPile then
         raise EGetFloatError.Create('Trop complexe')
      else
      begin
         Inc(indicePileCourant);
         Pile[indicePileCourant] := P;
      end;
   end;

   function CalcOperateur(C: char; PG, PD: double): double;
   begin
      case C of
         '+': calcOperateur := PG + PD;
         '-': calcOperateur := PG - PD;
         '/': calcOperateur := PG / PD;
         '*': calcOperateur := PG * PD;
         else
            CalcOperateur := 0;
      end;
   end;

   procedure AnalyseExpression; forward;

   procedure E;
   {E=(.Expression.)}
   begin
      if caracCourant = '(' then
      begin
         suivant;
         AnalyseExpression;
         case caracCourant of
            ')': suivant;
            #0: ; { fin => on ajoute ) manquante }
            else
               raise EGetFloatError.Create('Erreur )');
         end;{case}
      end
      else
         raise EGetFloatError.Create('Erreur (');
   end;{E}

   procedure AnalyseElement;
   {Element = E/nombre}
   var
      U: String;
   begin
      if charinset(caracCourant,[piMin, piMaj, 'P', 'p']) then
      begin
         U := LireIdent;
         U := AnsiUpperCase(U);
         if (U = piMin) or (U = 'PI') or (U = piMaj) then
            Empile(pi)
         else
            raise EGetFloatError.Create('Erreur nombre');
      end {Then}
      else if charinset(caracCourant,Chiffre + ['-', '+', '.']) then
         Empile(LireNombre)
      else
         E;
   end;{analyseElement}

   procedure AnalyseTerme;
   {terme = facteur.[* ou /].element}
   var
      C: char;
      T1, T2: double;
   begin
      AnalyseElement;
      while (caracCourant = '*') or
            (caracCourant = '/') do begin
         C := caracCourant;
         suivant;
         AnalyseElement;
         depile(T2);
         depile(T1);
         Empile(CalcOperateur(C, T1, T2));
      end; {while}
   end; { AnalyseTerme }

   procedure AnalyseExpression;
   {Expression = [+ ou - ou rien].Terme.[+ ou -].terme}
   var
      C: char;
      T1, T2: double;
   begin
      if (caracCourant = '+') or (caracCourant = '-') then begin
         C := caracCourant;
         suivant;
      end
      else
         C := '+';
      AnalyseTerme;
      if C = '-' then begin
         depile(T1);
         Empile(-T1);
      end;
      while (caracCourant = '+') or (caracCourant = '-') do
      begin
         C := caracCourant;
         suivant;
         AnalyseTerme;
         depile(T2);
         depile(T1);
         Empile(CalcOperateur(C, T1, T2));
      end; {while}
   end;{AnalyseExpression}

var
   posVirgule: integer;
begin {getFloat}
   trimComplet(Nombre);
   if nombre = '' then begin
      Result := sansSignif;
      exit;
   end;
   posVirgule := pos(',', nombre);
   while posVirgule > 0 do begin
      Nombre[posVirgule] := '.';
      posVirgule := pos(',', nombre);
   end;
   InitFonctor;
   AnalyseExpression;
   if pred(pointeurExp) <> length(nombre) then
      raise EGetFloatError.Create('Erreur nombre');
   Result := Pile[1];
end;{getFloat}

function valeur125(valeur: double): double;
var
   mantisse, exposant, coeff: double;
begin
   exposant := log(valeur);
   coeff := Int(exposant);
   if (exposant < 0) and (coeff <> exposant) then
      coeff := coeff - 1;
   coeff := exp(coeff * ln10);
   mantisse := Int(valeur / coeff);
   if mantisse > 2 then
      if mantisse < 6 then
         mantisse := 5
      else
         mantisse := 10;
   Result := mantisse * coeff;
end;

procedure GetCommi;
var
   istr: string;
   isize, i: dword;
begin
   setlength(istr, 4000);
   isize := QueryDosDevice(nil, @istr[1], 4000);
   for i := 1 to isize do
      if istr[i] = #0 then
         istr[i] := #10;
end;

procedure VerifKeyGetFloat(var key: char);
begin
   if charinset(key,[',', '.']) then
      key := decimalSeparator
   else if not charinset(key,CharGetFloat) then
      key := #0;
end;

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then
   begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

Function UnicodeVersRW3(s : string) : string;
var i : integer;
    carac : char;
    caracR : char;
begin
     result := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if pos(carac,grecque)>0
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gamma: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      delta: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambda: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := '';
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigma: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phi: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omega: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      else caracR := '?';
                 end
            else caracR := carac;
            result := result+caracR;
     end;
end;

initialization
   mesDocsDir := GetFolder(CSIDL_Personal)+'Regressi';
   if not DirectoryExists(MesDocsDir) then
      createDir(MesDocsDir);
   mesDocsDir := MesDocsDir + '\';
   appDataDir := GetFolder(CSIDL_AppData)+'Regressi';
   if not DirectoryExists(appDataDir) then
       createDir(appDataDir);
   appDataDir := appDataDir+'\';
end.

