unit GTSCONST;

interface

uses Windows, Classes, Graphics, Forms, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs, Grids, Controls,
  constGts, gtsmain, gtsutil, maths, aidegts2;

type
  TConstanteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;                       
    HelpBtn: TBitBtn;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    NewPageCB: TRadioGroup;
    GroupBox2: TGroupBox;
    ConstGrid: TStringGrid;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
  public
  end;

var
  ConstanteDlg: TConstanteDlg;

implementation

{$R *.DFM}

procedure TConstanteDlg.OKBtnClick(Sender: TObject);
var strValeur : string;
    i : integer;
    valeur : double;
begin with GtsMainForm,ConstGrid do begin
     for i := 1 to 3 do begin
        nomConstante[i] := cells[0,i];
        uniteConstante[i] := cells[1,i];
        StrValeur := cells[2,i];
        TrimComplet(strValeur);
        if StrValeur<>'' then begin
           valeur := StrToFloatWin(strValeur);
           if valeur=sansSignif then begin
               afficheErreur(erNombre);
               col := 2;
               row := i;
               ConstGrid.setFocus;
               self.modalResult := mrNone;
           end;
        end;
     end;
     commentaire := editComm.text;
end end;

procedure TConstanteDlg.FormActivate(Sender: TObject);
var i : integer;
begin with GtsMainForm do begin
     editComm.text := commentaire;
     for i := 1 to 3 do with constGrid do begin
        cells[0,i] := nomConstante[i];
        cells[1,i] := uniteConstante[i];
     end;
     if ajoutColPermis then begin
        if NewPageCB.items.count<3 then
           NewPageCB.items.add('Nouvelle colonne');
     end
     else begin
        if NewPageCB.items.count>2 then
           NewPageCB.items.delete(2);
     end;
end end;

procedure TConstanteDlg.FormCreate(Sender: TObject);
var i : integer;
begin with ConstGrid do begin
      cells[0,0] := 'Nom';
      cells[1,0] := 'Unit';
      cells[2,0] := 'Valeur';
      for i := 1 to 3 do
          cells[2,i] := '';
end end;

procedure TConstanteDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(HELP_Index)
end;

procedure TConstanteDlg.CancelBtnClick(Sender: TObject);
var i : integer;
begin with GtsMainForm,ConstGrid do
   for i := 1 to 3 do begin
        nomConstante[i] := cells[0,i];
        uniteConstante[i] := cells[1,i];
   end;
end;

end.
