unit Modedlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, Spin, ExtCtrls, sysutils,
  gtsdef, graphe, gtsmain, constgts, aidegts2;

type
  TmodeAcqDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    ModeRG: TRadioGroup;
    AbscisseRG: TRadioGroup;
    TraceGB: TGroupBox;
    TraceLigneCB: TCheckBox;
    TracePointsCB: TCheckBox;
    Label3: TLabel;
    DimPointSE: TSpinEdit;
    LabelMegaHz: TLabel;
    HelpBtn: TBitBtn;
    TopGB: TGroupBox;
    TopCB: TCheckBox;
    TopSE: TSpinEdit;
    Label1: TLabel;
    AnalyseurRG: TRadioGroup;
    GroupBox1: TGroupBox;
    GrilleCB: TCheckBox;
    LoupeAutoCB: TCheckBox;
    AxeCB: TCheckBox;
    RapideHelpBtn: TBitBtn;
    SauveNumCB: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RapideHelpBtnClick(Sender: TObject);
  private
    NumVoieAbs : array[0..voieMax] of indiceVoie;
    oldModeAcq : TmodeAcq;
    oldActive : array[indiceVoie] of boolean;
    Procedure setAbscisseRG;
  public
    modif : boolean;
  end;

var
  modeAcqDlg: TmodeAcqDlg;

implementation

uses clavier;

{$R *.DFM}

procedure TmodeAcqDlg.OKBtnClick(Sender: TObject);
var voie : indiceVoie;
begin with grapheGts do begin
     Modif := modeAcq<>TmodeAcq(modeRG.itemIndex);
     gtsMainForm.DeltatTop := TopSe.value;
     gtsMainForm.TopPermis := TopCB.checked;
     ModeAcq := TmodeAcq(modeRG.itemIndex);
     gtsMainForm.SauveNum := sauveNumCB.checked;
     case modeAcq of
         AcqMagnum,AcqUnMega : VoieAbscisse := VoieT;
         AcqClavier : VoieAbscisse := VoieClavier;
         AcqSortieAna : VoieAbscisse := VoieSA;
         else VoieAbscisse := NumVoieAbs[AbscisseRG.itemIndex];
     end;
     modif := modif or (voieOrphy[VoieAbscisse].active=false);
     voieOrphy[voieAbscisse].active := true;
     if TraceLigneCB.checked
        then include(trace,trLigne)
        else exclude(trace,trLigne);
     if TracePointsCB.checked
        then include(trace,trPoint)
        else exclude(trace,trPoint);
     Quadrillage := GrilleCB.checked;
     avecUnAxe := AxeCB.checked;
     analyseurLogique := AnalyseurRG.itemIndex=1;
     dimPoint := dimPointSE.value;
     if modif and (modeAcq=AcqClavier) then begin
         ClavierDlg := TClavierDlg.create(self);
         ClavierDlg.showModal;
         ClavierDlg.free;
     end;
     if (modeAcq=AcqMagnum) and
        (oldModeAcq<>AcqMagnum) then begin
            for voie := succ(voieT) to voieMax do begin
                oldActive[voie] := voieOrphy[voie].active;
                voieOrphy[voie].active := false;
            end;
            voieOrphy[voieMagnum].active := true;
            voieOrphy[voieT].active := true;
     end;
     LoupeAuto := loupeAutoCB.Checked;
     if (oldModeAcq=AcqMagnum) and
        (ModeAcq<>AcqMagnum) then begin
            for voie := succ(voieT) to voieMax do
                voieOrphy[voie].active := oldActive[voie];
            voieOrphy[voieMagnum].active := false;
     end;
end end;

procedure TmodeAcqDlg.RapideHelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_ModeAcquisition)
end;

procedure TmodeAcqDlg.FormActivate(Sender: TObject);
begin with grapheGts do begin
     modeRG.itemIndex := ord(modeAcq);
     TraceLigneCB.checked := TrLigne in trace;
     TracePointsCB.checked := TrPoint in trace;
     GrilleCB.checked := Quadrillage;
     loupeAutoCB.Checked := LoupeAuto;
     AnalyseurRG.itemIndex := ord(analyseurLogique);
     Modif := false;
     oldModeAcq := modeAcq;
     SetAbscisseRG;
     AxeCB.checked := avecUnAxe;
     TopSE.Value := gtsMainForm.DeltatTop;
     TopCB.checked := gtsMainForm.TopPermis;     
     DimPointSE.value := dimPoint;
     sauveNumCB.checked := gtsMainForm.SauveNum;
     if (ModeRG.items.count=6) and
        not GtsMainForm.UnMegaPermis then
           ModeRG.items.delete(5);
end end;

Procedure TmodeAcqDlg.setAbscisseRG;
var voie : indiceVoie;

Procedure setNum;
begin
     numVoieAbs[pred(abscisseRG.items.count)] := voie;
     if (modeRG.itemIndex=ord(grapheGts.modeAcq)) and
        (voie=grapheGTS.voieAbscisse) then
        AbscisseRG.itemIndex := pred(abscisseRG.items.count);
end;

var texte : string;
    AcqCourant : TmodeAcq;
begin
     TopGB.Visible := ModeRG.ItemIndex = ord(AcqTemps);
     AbscisseRG.items.clear;
     if ModeRG.itemIndex = ord(acqMagnum) then exit;
     AbscisseRG.visible :=
          (modeRG.itemIndex<>ord(acqClavier)) and
          (modeRG.itemIndex<>ord(acqUnMega)) and
          (modeRG.itemIndex<>ord(acqSortieAna));
     AcqCourant := TModeAcq(ModeRG.itemIndex);
     RapideHelpBtn.visible := modeRG.itemIndex=ord(acqUnMega);
     LabelMegaHz.visible := modeRG.itemIndex=ord(acqUnMega);
     for voie := voieT to voieMax do case voie of
         voieClavier : ;
         voieF : if (AcqCourant=AcqPoint) then begin
             AbscisseRG.items.Add(trFrequence);
             setNum
         end;
         voieT : if (AcqCourant=AcqTemps) then begin
              AbscisseRG.items.Add(trTemps);
              if modeRG.itemIndex<>ord(grapheGts.modeAcq) then
                 AbscisseRG.itemIndex := pred(abscisseRG.items.count);
              setNum
         end;
         voieSA : ;
         else with grapheGTS.voieOrphy[voie] do if active then begin
            if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<15
                   then texte := nom+' : '+signif
                   else texte := nom+' : '+copy(signif,1,12-length(nom))+'...';
            AbscisseRG.items.Add(texte);
            if (modeRG.itemIndex<>ord(grapheGts.modeAcq)) and
               (ModeRG.itemIndex=ord(AcqPoint)) and
               (AbscisseRG.itemIndex=-1) then
                  AbscisseRG.itemIndex := pred(abscisseRG.items.count);
            setNum;
         end;
      end;
end;

procedure TmodeAcqDlg.ModeRGClick(Sender: TObject);
begin
      setAbscisseRG
end;

procedure TmodeAcqDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext( HELP_ModeAcquisition)
end;

procedure TmodeAcqDlg.FormCreate(Sender: TObject);
var voie : indiceVoie;
begin
     for voie := VoieMin to VoieMax do
         oldActive[voie] := false;
     oldActive[voieT] := true;
     oldActive[voieA] := true;
end;

end.



