unit MagnumDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Spin, ooMisc, ComCtrls,
  gtsUtil, aidegts2;

type
  TMagnumCfg = class(TForm)
    LabelTaille: TLabel;
    TailleTraitEdit: TEdit;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Label1: TLabel;
    NomMagnumEdit: TEdit;
    ModeRG: TRadioGroup;
    UniteRG: TRadioGroup;
    ArretGB: TGroupBox;
    NbreSE: TSpinEdit;
    Label2: TLabel;
    HelpBtn: TBitBtn;
    EfrontCB: TComboBox;
    Timer: TTimer;
    GroupBox1: TGroupBox;
    Compteur: TLabel;
    Label3: TLabel;
    ErreurUpBtn: TSpeedButton;
    Label4: TLabel;
    Label5: TLabel;
    ErreurDnBtn: TSpeedButton;
    Memo1: TMemo;
    binairebtn: TSpeedButton;
    Label6: TLabel;
    ChuteRG: TRadioGroup;
    PageControl1: TPageControl;
    ChuteTS: TTabSheet;
    OscillTS: TTabSheet;
    NegatifCB: TCheckBox;
    PasEntierCB: TCheckBox;
    MontantCB: TCheckBox;
    SynchroCB: TCheckBox;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure EFseChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure NomMagnumEditChange(Sender: TObject);
    procedure InitPosition;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TimerTimer(Sender: TObject);
    procedure SynchroCBClick(Sender: TObject);
  private
    oldValeur : word;
  public
  end;

var
  MagnumCfg: TMagnumCfg;

implementation

uses graphe, GTSdef, GTSMAIN, SYNCHRO;

{$R *.DFM}

procedure TMagnumCfg.OKBtnClick(Sender: TObject);
begin with magnum do begin
    traitMagnumE := GetFloat(TailleTraitEdit.text);
    modeAngulaire := boolean(ModeRG.itemIndex);
    modeRadian := boolean(UniteRG.itemIndex);
    nom := NomMagnumEdit.text;
    chute := chuteRG.itemIndex=1;
    negatif := negatifCB.checked;
    pasEntier := pasEntierCB.checked;
    OscilMin := NbreSE.value;
    EFi := EFrontCB.itemIndex;
    Montant := montantCB.checked;
    Synchro := synchroCB.checked;
end end;

procedure TMagnumCfg.SynchroCBClick(Sender: TObject);
begin
    MontantCB.visible := SynchroCB.checked
end;

procedure TMagnumCfg.FormActivate(Sender: TObject);
begin with magnum do begin
    TailleTraitEdit.text := formatGts(traitMagnumE);
    ModeRG.itemIndex := ord(modeAngulaire);
    UniteRG.itemIndex := ord(modeRadian);
    NomMagnumEdit.text := Nom;
    NbreSE.value := OscilMin;
    chuteRG.itemIndex := ord(chute);
    negatifCB.checked := negatif;
    timer.Enabled := true;
    ErreurUpBtn.down := false;
    ErreurDnBtn.down := false;
    montantCB.checked := montant;
    synchroCB.checked := synchro;
    MontantCB.visible := synchro;
    efrontCB.Clear;
    if isGTI2
       then begin
          eFrontCB.items.add('EF0 prise G');
          eFrontCB.items.add('EF1 prise H');
          eFrontCB.items.add('EF2 prise I');
          eFrontCB.items.add('EF3 prise J');
          Memo1.lines[2] := 'Un bouton rouge : EF OK ; erreur sur EB';
       end
       else begin
          eFrontCB.items.add('EF0 prise A');
          eFrontCB.items.add('EF1 prise B');
          Memo1.lines[2] := 'Un bouton rouge : EF OK ; erreur sur EB5 (prise E)';
       end;
    EFrontCB.itemIndex := EFi;
    EfrontCB.Enabled := not isGTI2;
    initPosition;
end end;

procedure TMagnumCfg.ModeRGClick(Sender: TObject);
begin
     UniteRG.visible := ModeRG.itemIndex = 1;
     LabelTaille.visible := (ModeRG.itemIndex=1) or (chuteRG.itemIndex=1);
     TailleTraitEdit.visible := LabelTaille.visible;
     case chuteRG.itemIndex of
          0 : PageControl1.ActivePage := OscillTS;
          1 : PageControl1.ActivePage := ChuteTS;
     end;
     ArretGB.visible := (chuteRG.itemIndex=0);
     NegatifCB.caption := NomMagnumEdit.text+' ngatif';
end;

procedure TMagnumCfg.EFseChange(Sender: TObject);
begin
    magnum.EFi := EFrontCB.itemIndex;
    if isGTI2 then Magnum.EBi := 1+2*Magnum.EFi;
    initPosition;
end;

procedure TMagnumCfg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_AcquisitionFou)
end;

procedure TMagnumCfg.NomMagnumEditChange(Sender: TObject);
begin
     NegatifCB.caption := NomMagnumEdit.text+' ngatif';
end;

procedure TMagnumCfg.InitPosition;
begin
     gtsMainForm.ecritOrphy(magnum.codeCodeurInc); // activation
     gtsMainForm.ecritOrphy('WRPOSITION'); // RZ
     oldValeur := 30000;
end;

procedure TMagnumCfg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    timer.Enabled := false;
    gtsMainForm.ecritOrphy(magnum.stopMagnum);
end;

procedure TMagnumCfg.TimerTimer(Sender: TObject);
var valeurW : word;
begin
     valeurW := gtsMainForm.getWord('WLPOSITION');
     ErreurUpBtn.down := ErreurUpBtn.down or (valeurW>oldValeur);
     ErreurDnBtn.down := ErreurDnBtn.down or (valeurW<oldValeur);
     Label3.caption := intToStr(integer(valeurW)-30000);
     oldValeur := valeurW;
     valeurW := gtsMainForm.getByte('WEBIT '+intToStr(magnum.EBi));
     binaireBtn.Down := valeurW=0;
end;

end.

