unit PWMU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls, math, graphe, Buttons;

type
  TPWMDlg = class(TForm)
    Panel1: TPanel;
    DutySE: TSpinEdit;
    Label1: TLabel;
    FrequenceEdit: TEdit;
    FrequenceBtn: TSpinButton;
    Label2: TLabel;
    SortieRG: TRadioGroup;
    OnOffBtn: TSpeedButton;
    procedure FrequenceBtnDownClick(Sender: TObject);
    procedure FrequenceBtnUpClick(Sender: TObject);
    procedure DutySEChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SortieRGClick(Sender: TObject);
    procedure OnOffBtnClick(Sender: TObject);
  private
    procedure Desactiver;
    procedure Activer;
    procedure FrequenceChange(up : boolean);
  public
  end;

var
  PWMDlg: TPWMDlg;

implementation

uses GTSMAIN;

{$R *.DFM}

procedure TPWMDlg.FrequenceBtnDownClick(Sender: TObject);
begin
     FrequenceChange(false)
end;

procedure TPWMDlg.FrequenceBtnUpClick(Sender: TObject);
begin
     FrequenceChange(true)
end;

procedure TPWMDlg.FrequenceChange(up : boolean);

function freq125(f : integer) : integer;
var exposant,mantisse,coeff : integer;
begin
     exposant := floor(log10(f));
     coeff := round(power(10,exposant));
     mantisse := f div coeff;
     if mantisse>2
        then if mantisse<6
             then mantisse := 5
             else mantisse := 10;
     result := mantisse*coeff;
end;

begin with sortiePWM do begin
     if up
        then frequence := freq125(frequence*2)
        else frequence := freq125(frequence div 2);
     if OnOffBtn.Down then activer;
     FrequenceEdit.text := IntToStr(frequence);
end end;

procedure TPWMDlg.DutySEChange(Sender: TObject);
begin
     sortiePWM.Duty100 :=  DutySE.value;
     if OnOffBtn.Down then activer;
end;

procedure TPWMDlg.FormActivate(Sender: TObject);
begin with sortiePWM do begin
     DutySE.value := sortiePWM.Duty100;
     FrequenceEdit.text := IntToStr(frequence);
     sortieRG.ItemIndex := ord(PWMi)-ord('0');
     OnOffBtn.Down := false;
end end;

procedure TPWMDlg.Activer;
begin
    GTSmainForm.ecritOrphy(sortiePWM.codePWM);
    OnOffBtn.hint := 'Sortie PWM'+sortiePWM.PWMi+' active';
end;

procedure TPWMDlg.Desactiver;
begin
    GTSmainForm.ecritOrphy('WPWM 0 0');
    GTSmainForm.ecritOrphy('WPWM 1 0');    
    OnOffBtn.hint := 'Sorties PWM inactives';
end;

procedure TPWMDlg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Desactiver
end;

procedure TPWMDlg.SortieRGClick(Sender: TObject);
begin
    sortiePWM.PWMi := AnsiChar(ord('0')+sortieRG.ItemIndex);
    if OnOffBtn.Down then activer
end;

procedure TPWMDlg.OnOffBtnClick(Sender: TObject);
begin
    if OnOffBtn.Down then activer else desactiver
end;

end.
