unit Sadlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, spin, ExtCtrls, sysutils, Grids, Dialogs, 
  maths, gtsutil, uniteker, gtsdef, graphe,
  gtsmain, constgts, gbf_syntaxe, aidegts2;

type
  TSortieAnaDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Panel1: TPanel;
    SortieRG: TRadioGroup;
    DebutGB: TGroupBox;
    DebutSAScroll: TScrollBar;
    EditDebutSA: TEdit;
    FinGB: TGroupBox;
    FinSAScroll: TScrollBar;
    EditFinSA: TEdit;
    GroupBox1: TGroupBox;
    EditNomSA: TEdit;
    HelpBtn: TBitBtn;
    GroupBox2: TGroupBox;
    DeltatEdit: TEdit;
    DeltatSBtn: TSpinButton;
    ExpressionLabel: TLabel;
    ExpressionEdit: TEdit;
    EtalonCB: TCheckBox;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    NrampeSE: TSpinEdit;
    rampeSE: TSpinEdit;
    ContinuCB: TCheckBox;
    AideBtn: TSpeedButton;
    procedure DebutSAScrollChange(Sender: TObject);
    procedure FinSAScrollChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SortieRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure DeltatSBtnDownClick(Sender: TObject);
    procedure DeltatSBtnUpClick(Sender: TObject);
    procedure ExpressionEditExit(Sender: TObject);
    procedure EtalonCBClick(Sender: TObject);
    procedure NrampeSEChange(Sender: TObject);
    procedure rampeSEChange(Sender: TObject);
    procedure ContinuCBClick(Sender: TObject);
    procedure AideBtnClick(Sender: TObject);
  private
    activation : boolean;
    procedure MajDeltat;
  public
  end;

var
  SortieAnaDlg: TSortieAnaDlg;

implementation

{$R *.DFM}

procedure TSortieAnaDlg.DebutSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     DebutSortie[rampeSE.value] := DebutSAScroll.position;
     if (rampeSE.value>1) and continuCB.Checked then
          FinSortie[rampeSE.value-1] := DebutSortie[rampeSE.value];
     EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
     GtsMainForm.EcritOrphy('WDAC '+SAi+' '+IntToStr(DebutSAScroll.position));
end end;

procedure TSortieAnaDlg.FinSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     FinSortie[rampeSE.value] := FinSAScroll.position;
     if (rampeSE.value<rampeSE.MaxValue) and continuCB.Checked then
          DebutSortie[rampeSE.value+1] := FinSortie[rampeSE.value];
     EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
     GtsMainForm.EcritOrphy('WDAC '+SAi+' '+IntToStr(DebutSAScroll.position));
end end;

procedure TSortieAnaDlg.OKBtnClick(Sender: TObject);
begin
     with sortieAnalogique do begin
        Active := true;
        if EtalonCB.checked and (expressionEdit.text<>'')
            then expression := expressionEdit.text
            else expression := '';
        Nom := EditNomSA.text;
        NbreRampes := NrampeSE.value;
        Sai := ansichar(ord('0')+sortieRG.itemIndex);
//        capteurNonLin := expression<>'';
        calcVecteur;
     end;
end;

procedure TSortieAnaDlg.FormActivate(Sender: TObject);
begin
     activation := true;
     with sortieAnalogique do begin
        FinSAScroll.position := FinSortie[1];
        EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
        DebutSAScroll.position := DebutSortie[1];
        EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
        EditNomSA.text := nom;
        NrampeSE.value := NbreRampes;
        rampeSE.value := 1;
        rampeSE.maxValue := NbreRampes;        
        GtsMainForm.EcritOrphy('WDAC '+SAi+' '+IntToStr(DebutSortie[1]));
        SortieRG.itemIndex := ord(SAi)-ord('0');
        EtalonCB.checked := expression<>'';
        ExpressionEdit.text := expression;
        ExpressionEdit.Visible := EtalonCB.checked;
        ExpressionLabel.Visible := EtalonCB.checked;
        MajDeltat;
     end;
     activation := false;
end;

procedure TSortieAnaDlg.SortieRGClick(Sender: TObject);
begin
    if not activation then with sortieAnalogique do begin
       Sai := ansichar(ord('0')+SortieRG.itemIndex);
       EditFinSA.text := FormatUnite(ValeurReal(FinSAScroll.position));
       EditDebutSA.text := FormatUnite(ValeurReal(DebutSAScroll.position));
    end;
end;

procedure TSortieAnaDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(HELP_SortieAnalogique)
end;

procedure TSortieAnaDlg.DeltatSBtnDownClick(Sender: TObject);
begin with sortieAnalogique do
     if deltatSA>100 then dec(deltatSA,100);
     MajDeltat;
end;

procedure TSortieAnaDlg.DeltatSBtnUpClick(Sender: TObject);
begin with sortieAnalogique do
     if deltatSA<10000 then inc(deltatSA,100);
     MajDeltat;
end;

procedure TSortieAnaDlg.MajDeltat;
begin
     DeltatEdit.text := FloatToStrF(sortieAnalogique.deltatSA/1000,ffFixed,4,2)+' s';
end;

procedure TSortieAnaDlg.ExpressionEditExit(Sender: TObject);
begin
    sortieAnalogique.expression := expressionEdit.text;
end;

procedure TSortieAnaDlg.EtalonCBClick(Sender: TObject);
begin
        ExpressionEdit.Visible := EtalonCB.checked;
        ExpressionLabel.Visible := EtalonCB.checked;
end;

procedure TSortieAnaDlg.NrampeSEChange(Sender: TObject);
begin
  rampeSE.Visible := nRampeSE.value>1;
  rampeSE.maxValue := nRampeSE.value;
  if rampeSE.value>rampeSE.maxValue then rampeSE.value := rampeSE.maxValue;
  sortieAnalogique.NbreRampes := NrampeSE.value;
end;

procedure TSortieAnaDlg.rampeSEChange(Sender: TObject);
begin with sortieAnalogique do begin
  if (RampeSE.value>1) and continuCB.checked
      then debutSortie[RampeSE.value] := finSortie[RampeSE.value-1];
  debutSAscroll.Position := debutSortie[RampeSE.value];
  finSAscroll.Position := finSortie[RampeSE.value];
end end;

procedure TSortieAnaDlg.AideBtnClick(Sender: TObject);
begin
  syntaxeDlg := TsyntaxeDlg.create(self);
  syntaxeDlg.showModal;
  syntaxeDlg.free;
end;

procedure TSortieAnaDlg.ContinuCBClick(Sender: TObject);
var i : integer;
begin with sortieAnalogique do begin
     if continuCB.Checked then
        for i := 2 to NrampeSE.value do
            DebutSortie[i] := FinSortie[i-1];
end end;

end.
