unit Synchro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, sysutils, ComCtrls, Spin,
  maths, gtsutil, gtsdef, gtsmain, graphe, constgts, aidegts2;

type
  TSynchroDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    SynchroRG: TRadioGroup;
    Notebook: TPageControl;
    FrontTS: TTabSheet;
    SeuilTS: TTabSheet;
    RelaxeTS: TTabSheet;
    ClavierTS: TTabSheet;
    NerfTS: TTabSheet;
    EFRG: TRadioGroup;
    SensFrontRG: TRadioGroup;
    MonocoupFCB: TCheckBox;
    SensSeuilRG: TRadioGroup;
    GroupBox1: TGroupBox;
    LabelSeuil: TLabel;
    RazSeuilBtn: TSpeedButton;
    SeuilScroll: TScrollBar;
    MonocoupSCB: TCheckBox;
    Memo2: TMemo;
    Memo1: TMemo;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    NbreSE: TSpinEdit;
    LargeurSE: TSpinEdit;
    DistanceSE: TSpinEdit;
    LargeurEdit: TEdit;
    DistanceEdit: TEdit;
    DebutEdit: TEdit;
    DebutSE: TSpinEdit;
    FinGB: TGroupBox;
    FinSAScroll: TScrollBar;
    EditFinSA: TEdit;
    DebutGB: TGroupBox;
    DebutSAScroll: TScrollBar;
    EditDebutSA: TEdit;
    SortieRG: TRadioGroup;
    AideMemo: TMemo;
    versionMemo: TMemo;
    Memo3: TMemo;
    PagePreAcq: TPageControl;
    AidePreAcq: TTabSheet;
    ReglePreAcq: TTabSheet;
    PreAcqGB: TGroupBox;
    PreAcqLabel: TLabel;
    PreAcqScroll: TTrackBar;
    Label3: TLabel;
    Label5: TLabel;
    BougeTS: TTabSheet;
    GroupBox3: TGroupBox;
    LabelBouge: TLabel;
    BougeScroll: TScrollBar;
    BougeRG: TRadioGroup;
    Memo4: TMemo;
    VoieSynchroRG: TRadioGroup;
    Base32RG: TRadioGroup;
    Memo5: TMemo;
    SondorTS: TTabSheet;
    SodarTS: TTabSheet;
    Memo6: TMemo;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SynchroRGClick(Sender: TObject);
    procedure SeuilScrollChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure RazSeuilBtnClick(Sender: TObject);
    procedure NbreSEChange(Sender: TObject);
    procedure LargeurSEChange(Sender: TObject);
    procedure DistanceSEChange(Sender: TObject);
    procedure DebutSEChange(Sender: TObject);
    procedure FinSAScrollChange(Sender: TObject);
    procedure DebutSAScrollChange(Sender: TObject);
    procedure SortieRGClick(Sender: TObject);
    procedure PreAcqScrollChange(Sender: TObject);
    procedure BougeScrollChange(Sender: TObject);
    procedure Base32RGClick(Sender: TObject);
    procedure VoieSynchroRGClick(Sender: TObject);
  private
    activation : boolean;
    NumVoieAbs : array[0..voieMax] of indiceVoie;
    Procedure MajSeuil;
  public
  end;

var
  SynchroDlg: TSynchroDlg;

implementation

{$R *.DFM}

procedure TSynchroDlg.OKBtnClick(Sender: TObject);
begin with grapheGts do begin
     modeSynchro := TmodeSynchro(synchroRG.itemIndex);
     case modeSynchro of
          s_seuil : begin
              montant := boolean(sensSeuilRG.itemIndex);
              monocoup := MonocoupSCB.checked;
              seuilSynchro := SeuilScroll.position;
              baseDeTemps.PreAcq100 := preAcqScroll.position;
              if isGTI2 then voieSynchro := NumVoieAbs[VoieSynchroRG.itemIndex];
          end;
          s_front : begin
              frontSynchro := ansichar(ord('0')+EFRG.itemIndex);
              montant := boolean(sensFrontRG.itemIndex);
              monocoup := MonocoupFCB.checked;
              baseDeTemps.PreAcq100 := preAcqScroll.position;
          end;
          s_clavier : ;
          s_nerf : with sortieAnalogique do begin
              Sai := ansichar(ord('0')+sortieRG.itemIndex);
              debutSortie[1] := debutSAscroll.position;
              finSortie[1] := finSAscroll.position;
          end;
          s_bouge : begin
              deltaBouge := BougeScroll.position;
              voieBouge := NumVoieAbs[BougeRG.itemIndex];
          end;
     end;
end end;

procedure TSynchroDlg.FormActivate(Sender: TObject);

procedure SetBouge;
var voie : indiceVoie;
    texte : string;
begin
     BougeRG.Items.Clear;
     VoieSynchroRG.Items.Clear;
     for voie := voieA to voieAnaMax do
         with grapheGts.voieOrphy[voie] do if active then begin
            if length(signif)<length(nom)
               then texte := nom
               else if (length(nom)+length(signif))<16
                   then texte := nom+'/'+signif
                   else texte := signif;
            BougeRG.items.Add(texte);
            VoieSynchroRG.Items.Add(texte);            
            numVoieAbs[pred(bougeRG.items.count)] := voie;
            if (voie=grapheGts.voieBouge) then
               BougeRG.itemIndex := pred(bougeRG.items.count);
            if (voie=grapheGts.voieSynchro) then
               VoieSynchroRG.itemIndex := pred(VoieSynchroRG.items.count);
      end;
      if bougeRG.itemIndex=-1 then begin
          BougeRG.ItemIndex := 0;
          grapheGts.voieBouge := NumVoieAbs[0];
      end;
      if VoieSynchroRG.itemIndex=-1 then begin
          VoieSynchroRG.ItemIndex := 0;
          grapheGts.voieSynchro := NumVoieAbs[0];
      end;
      BougeScroll.Position := grapheGts.DeltaBouge;
end;

var dtms : double;
begin with grapheGts do begin
     activation := true;
     Base32RG.Visible := Gene32Permis;
     if Base32RG.Visible
        then Base32RG.itemIndex := ord(SortieAnalogique.Base32Micro)
        else Base32RG.itemIndex := 0;
     if isGTI2
        then begin
             SeuilScroll.max := 4000;
             SeuilScroll.min := 96;
             SeuilScroll.largeChange := 128;
        end
        else begin
             SeuilScroll.max := 250;
             SeuilScroll.min := 6;
             SeuilScroll.largeChange := 32;
        end;
     synchroRG.itemIndex := ord(modeSynchro);
     sensSeuilRG.itemIndex := ord(montant);
     SeuilScroll.Position := SeuilSynchro;
     preAcqScroll.position := baseDeTemps.PreAcq100;
     preAcqLabel.caption := IntToStr(PreAcqScroll.position)+'%';
     PagePreAcq.Visible := modeSynchro in [s_seuil,s_front];
     if baseDeTemps.preAcqPermis
        then PagePreAcq.activePage := reglePreAcq
        else PagePreAcq.activePage := aidePreAcq;
     if (modeSynchro=s_seuil) and
        not GTSmainForm.synchroMonocoupPermis then monocoup := false;
     MonocoupSCB.checked := monocoup;
     MonocoupFCB.checked := monocoup;
     MonocoupSCB.enabled := GTSmainForm.synchroMonocoupPermis;
     VersionMemo.visible := not GTSmainForm.synchroMonocoupPermis and not isGTI2;
     synchroRG.enabled := modeAcq<>AcqUnMega;
     VoieSynchroRG.visible := isGTI2;
     AideMemo.visible := not isGTI2;
     sensFrontRG.itemIndex := ord(montant);
     EFRG.itemIndex := ord(frontSynchro)-ord('0');
     Notebook.activePageIndex := SynchroRG.itemIndex;
     with sortieAnalogique do begin
        dtms := DeltatWgene[Base32Micro]*1000;
        NbreSE.value := nbrePulse;
        largeurSE.value := largeurPulse;
        LargeurEdit.text := FloatToStrF(LargeurSE.value*dtms,ffFixed,4,1);
        distanceSE.value := DistancePulse;
        DistanceEdit.text := FloatToStrF(DistanceSE.value*dtms,ffFixed,4,1);
        debutSE.value := DebutPulse;
        debutSAscroll.position := debutSortie[1];
        EditDebutSA.text := FormatUnite(ValeurVolt(DebutSAScroll.position));
        DebutEdit.text := FloatToStrF(DebutSE.value*dtms,ffFixed,4,1);
        finSAscroll.position := finSortie[1];
        EditFinSA.text := FormatUnite(ValeurVolt(FinSAScroll.position));
        SortieRG.itemIndex := ord(SAi)-ord('0');
     end;
     activation := false;
     setBouge;
     majSeuil;
end end;

procedure TSynchroDlg.SynchroRGClick(Sender: TObject);
begin
     Notebook.ActivePageIndex := SynchroRG.itemIndex;
     if SynchroRG.itemIndex=ord(s_seuil) then MajSeuil;
     PagePreAcq.Visible := SynchroRG.itemIndex<2;
     if baseDeTemps.preAcqPermis
        then PagePreAcq.activePage := reglePreAcq
        else PagePreAcq.activePage := aidePreAcq;
end;

procedure TSynchroDlg.VoieSynchroRGClick(Sender: TObject);
begin
    if activation then exit;
    if isGTI2 then grapheGTS.voieSynchro := NumVoieAbs[VoieSynchroRG.itemIndex];
end;

procedure TSynchroDlg.SeuilScrollChange(Sender: TObject);
begin
     MajSeuil
end;

procedure TSynchroDlg.MajSeuil;
begin with grapheGTS do begin
     if activation then exit;
     SeuilSynchro := SeuilScroll.position;
     LabelSeuil.caption := voieOrphy[voieSynchro].formatUnite(seuilSynchroReal)
end end;

procedure TSynchroDlg.HelpBtnClick(Sender: TObject);
begin
     if SynchroRG.itemIndex<4
        then Application.HelpContext(HELP_Synchronisation)
        else Application.HelpContext(HELP_AcquisitionFou)
end;

procedure TSynchroDlg.RazSeuilBtnClick(Sender: TObject);
begin
     if isGTI2
        then SeuilScroll.Position := 2048
        else SeuilScroll.Position := 128
end;

procedure TSynchroDlg.NbreSEChange(Sender: TObject);
begin
    sortieAnalogique.NbrePulse := NbreSE.value
end;

procedure TSynchroDlg.LargeurSEChange(Sender: TObject);
begin
       sortieAnalogique.LargeurPulse := LargeurSE.value;
       LargeurEdit.text := FloatToStrF(LargeurSE.value*DeltatWgene[sortieAnalogique.Base32Micro]*1000,ffFixed,4,1);
       distanceSE.minValue := largeurSE.value+1;
end;

procedure TSynchroDlg.DistanceSEChange(Sender: TObject);
begin
       sortieAnalogique.DistancePulse := DistanceSE.value;
       DistanceEdit.text := FloatToStrF(DistanceSE.value*DeltatWgene[sortieAnalogique.Base32Micro]*1000,ffFixed,4,1);
end;

procedure TSynchroDlg.DebutSEChange(Sender: TObject);
begin
       sortieAnalogique.DebutPulse := DebutSE.value;
       DebutEdit.text := FloatToStrF(DebutSE.value*DeltatWgene[sortieAnalogique.Base32Micro]*1000,ffFixed,4,1);
end;

procedure TSynchroDlg.FinSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     if DebutSAScroll.position>FinSAScroll.position-minSeuil then
        FinSAScroll.position := DebutSAScroll.position+minSeuil;
     EditFinSA.text := FormatUnite(ValeurVolt(FinSAScroll.position));
     GtsMainForm.EcritOrphy('WDAC '+SAi+' '+IntToStr(DebutSAScroll.position));
end end;

procedure TSynchroDlg.DebutSAScrollChange(Sender: TObject);
begin with sortieAnalogique do begin
     if DebutSAScroll.position>FinSAScroll.position-minSeuil then
        DebutSAScroll.position := FinSAScroll.position-minSeuil;
     EditDebutSA.text := FormatUnite(ValeurVolt(DebutSAScroll.position));
     GtsMainForm.EcritOrphy('WDAC '+SAi+' '+IntToStr(DebutSAScroll.position));
end end;

procedure TSynchroDlg.SortieRGClick(Sender: TObject);
begin
    if not activation then with sortieAnalogique do begin
       Sai := ansichar(ord('0')+SortieRG.itemIndex);
       EditFinSA.text := FormatUnite(ValeurVolt(FinSAScroll.position));
       EditDebutSA.text := FormatUnite(ValeurVolt(DebutSAScroll.position));
    end;
end;

procedure TSynchroDlg.PreAcqScrollChange(Sender: TObject);
begin
     PreAcqLabel.caption := IntToStr(PreAcqScroll.position)+'%'
end;

procedure TSynchroDlg.BougeScrollChange(Sender: TObject);
begin
     LabelBouge.caption := intToStr(BougeScroll.position)
end;

procedure TSynchroDlg.Base32RGClick(Sender: TObject);
var dtms : double;
begin with SortieAnalogique do begin
  Base32Micro := Base32RG.itemIndex>0;
  dtms := DeltatWgene[Base32Micro]*1000;
  LargeurEdit.text := FloatToStrF(LargeurSE.value*dtms,ffFixed,4,1);
  DistanceEdit.text := FloatToStrF(DistanceSE.value*dtms,ffFixed,4,1);
  DebutEdit.text := FloatToStrF(DebutSE.value*dtms,ffFixed,4,1);
end end;

end.
