unit Buretdlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, spin, sysutils,
  uniteker, gtsutil, gtsdef, graphe, ComCtrls;

type
  TBuretteDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Label5: TLabel;
    PasImpulsionEdit: TEdit;
    FreqImpulsionSE: TSpinEdit;
    LabelMax: TLabel;
    MaxiEdit: TEdit;
    Label9: TLabel;
    Bevel1: TBevel;
    deltaV0Label: TLabel;
    DeltaVedit: TEdit;
    AttenteLabel: TLabel;
    NlectureMaxSE: TSpinEdit;
    FluctuationLabel: TLabel;
    FluctuationUD: TUpDown;
    EtatReposCB: TCheckBox;
    ModeRG: TRadioGroup;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure PasImpulsionEditExit(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FluctuationUDChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure ModeRGClick(Sender: TObject);
  private
  public
  end;

var
  BuretteDlg: TBuretteDlg;

implementation

{$R *.DFM}

procedure TBuretteDlg.FormActivate(Sender: TObject);
begin with burette do begin
       FreqImpulsionSE.value := round(1/(2*dureePulse));
       MaxiEdit.text := FormatGTS(maxi);
       PasImpulsionEdit.text := FormatGTS(Vpulse);
       DeltaVedit.text := FormatGTS(deltaV0);
       NlectureMaxSE.value := NbreLectureMax;
       modeRG.itemIndex := ord(mode);
       etatReposCB.Checked := etatReposBas;
       FluctuationUD.position := round(fluctuationRelative*100);
       FluctuationLabel.caption := 'Fluctuation '+
              IntToStr(FluctuationUD.position)+' %'
end end;

procedure TBuretteDlg.OKBtnClick(Sender: TObject);
begin with burette do begin
    dureePulse := 1/(2*FreqImpulsionSE.value);
    Vpulse := strToFloatWin(PasImpulsionEdit.text);
    deltaV0 := strToFloatWin(deltaVEdit.text);
    maxi := abs(StrToFloatWin(MaxiEdit.text));
    NbreLectureMax := NlectureMaxSE.value;
    fluctuationRelative := FluctuationUD.position/100;
    mode := TmodeBurette(modeRG.ItemIndex);
    etatReposBas := etatReposCB.Checked;
end end;

procedure TBuretteDlg.PasImpulsionEditExit(Sender: TObject);
begin
    burette.Vpulse := strToFloatWin(PasImpulsionEdit.text);
    if burette.Vpulse<0.001 then burette.Vpulse := 0.005;
end;

procedure TBuretteDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(12)
end;

procedure TBuretteDlg.FluctuationUDChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  FluctuationLabel.caption := 'Fluctuation '+
            IntToStr(FluctuationUD.position)+' %'
end;

procedure TBuretteDlg.ModeRGClick(Sender: TObject);
begin
  case ModeRG.ItemIndex of
       0 : begin
          AttenteLabel.caption := '';
          NlectureMaxSE.Hint := '';
          deltaV0label.caption := 'Incrment initial (mL)';
       end;
       1 : begin
          AttenteLabel.caption := 'Attente maxi (s)';
          NlectureMaxSE.Hint := 'Attente entre fin de l''ajout et la  mesure';
          deltaV0label.caption := 'Incrment initial (mL)';
       end;
       2 : begin
           AttenteLabel.caption := 'Intervalle (s)';
           NlectureMaxSE.Hint := 'Attente aprs ajout, avant mesure et ajout suivant';
           deltaV0label.caption := 'Incrment (mL)';
       end;
  end;
  NlectureMaxSE.Visible := ModeRG.ItemIndex>0;
  FluctuationLabel.Visible := ModeRG.ItemIndex=1;
  FluctuationUD.Visible := ModeRG.ItemIndex=1;
end;

end.


