unit buretrs232dlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, spin, sysutils,
  adPort, gtsdef, jmmutil, inifiles, ComCtrls;

type
  TBuretteRS232Dlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    NomEdit: TEdit;
    Label4: TLabel;
    UniteEdit: TEdit;
    Label1: TLabel;
    VolumeMaxSE: TSpinEdit;
    Label5: TLabel;
    VitesseRelativeEdit: TEdit;
    VolumeRG: TRadioGroup;
    VitesseMinSE: TSpinEdit;
    VitesseMaxSE: TSpinEdit;
    CheckBox1: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
  public
  end;

var
  BuretteRS232Dlg: TBuretteRS232Dlg;

implementation

{$R *.DFM}

procedure TBuretteRS232Dlg.FormActivate(Sender: TObject);
begin
with buretteRS232 do begin
       VitesseMaxSE.value := vitesseMaxi;
       VitesseMinSE.value := vitesseMini;
       VitesseRelativeEdit.text := FloatToStrF(dphdtRelatif,ffFixed,2,1);
       volumeRG.ItemIndex := ord(volumeMaxi);
       VolumeMaxSE.value := round(ValMaxi);
       NomEdit.text := symboleGrandeur;
       UniteEdit.text := uniteGrandeur;
end end;

procedure TBuretteRS232Dlg.OKBtnClick(Sender: TObject);
begin
with buretteRS232 do begin
    Baud := 4800;
    Parite := pNone;
    DataBits := 7;
    if isUniversal then StopBits := 1 else StopBits := 2; 
    symboleGrandeur := NomEdit.text;
    uniteGrandeur := UniteEdit.text;
    isUniversal := universalCB.checked;
    try
    vitesseMaxi := VitesseMaxSE.value;
    vitesseMini := VitesseMinSE.value;
    dphdtRelatif := StrToFloatWin(VitesseRelativeEdit.text);
    volumeMaxi := TvolumeMaxi(volumeRG.ItemIndex);
    except
    end;
    ValMaxi := VolumeMaxSE.value;
end end;

procedure TBuretteRS232Dlg.FormDestroy(Sender: TObject);
var fichier : TMemIniFile;
begin
    try
    fichier := TmemIniFile.create(nomFichierCapteurs);
    buretteRS232.ecritIni(fichier);
    fichier.UpdateFile;
    fichier.free;
    except
    end;
end;

procedure TBuretteRS232Dlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(12)
end;

end.



