unit Capcfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, Tabs,
  Buttons, ExtCtrls, sysutils, ComCtrls, Spin,
  gtsdef, gtsutil, aideGTS2, constGTS;

type
  TCapteurCfgDlg = class(TForm)
    ButtonPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Notebook: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    EtalonnageCB: TCheckBox;
    AmpliCB: TCheckBox;
    GrandeurGB: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditNom: TEdit;
    EditUnite: TEdit;
    EditSignif: TEdit;
    AffichageGB: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    EditMini: TEdit;
    EditMaxi: TEdit;
    GroupBox1: TGroupBox;
    val0Edit: TEdit;
    PenteEdit: TEdit;
    Val0Label: TLabel;
    PenteLabel: TLabel;
    Label8: TLabel;
    NumeroCB: TComboBox;
    NonLinearCB: TCheckBox;
    ExpressionLabel: TLabel;
    ExpressionEdit: TEdit;
    EditTitre: TLabeledEdit;
    EditAide: TLabeledEdit;
    procedure FormActivate(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure NonLinearCBClick(Sender: TObject);
  private
  public
    CapteurCourant : TCapteur;
  end;

var
  CapteurCfgDlg: TCapteurCfgDlg;

implementation

{$R *.DFM}

procedure TCapteurCfgDlg.FormActivate(Sender: TObject);
begin with capteurCourant do begin
     EditSignif.text := signifC;
     EditTitre.text := titreC;
     EditAide.text := aideC;
     EditNom.text := nomC;
     EditUnite.text := nomUniteC;
     ExpressionEdit.text := expressionC;
     EtalonnageCB.checked := avecPotarC;
     ampliCB.checked := avecAmpliC;
     val0Edit.text := FormatGts(offsetC);
     penteEdit.text := FormatGts(unVoltC);
     penteLabel.caption := DeltaMaj+nomC+'/'+DeltaMaj+'V'+
         ' ('+nomUniteC+'/V)';
     EditMini.text := FormatGTS(miniAff);
     EditMaxi.text := FormatGTS(maxiAff);
     numeroCB.itemIndex := numeroC;
     NonLinearCB.checked := not linearC;
     NonLinearCBClick(nil);
end end;

procedure TCapteurCfgDlg.EditNomChange(Sender: TObject);
begin
     PenteLabel.caption := DeltaMaj+EditNom.text+'/'+DeltaMaj+'V'+
        ' ('+EditUnite.text+'/V)';
     AffichageGB.caption := trAffichage+EditUnite.text+')';
end;

procedure TCapteurCfgDlg.OKBtnClick(Sender: TObject);
begin with capteurCourant do begin
     signifc := EditSignif.text;
     titrec := EditTitre.text;
     aidec := EditAide.text;
     nomC := EditNom.text;
     nomUniteC := EditUnite.text;
     avecPotarC := EtalonnageCB.checked;
     avecAmpliC := ampliCB.checked;
     OffsetC := GetFloat(val0Edit.text);
     UnVoltC := GetFloat(penteEdit.text);
     numeroC := numeroCB.itemIndex;
     ExpressionC := ExpressionEdit.text;
     LinearC := not NonLinearCB.checked;
     try
     miniAff := GetFloat(EditMini.text);
     except
     end;
     try
     maxiAff := GetFloat(EditMaxi.text);
     except
     end;
end end;

procedure TCapteurCfgDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Capteurs)
end;

procedure TCapteurCfgDlg.NonLinearCBClick(Sender: TObject);
begin
     expressionLabel.visible := NonLinearCB.checked;
     expressionEdit.visible := NonLinearCB.checked;
     val0Edit.visible := not NonLinearCB.checked;
     penteEdit.visible := not NonLinearCB.checked;
     val0Label.visible := not NonLinearCB.checked;
     penteLabel.visible := not NonLinearCB.checked;
end;

end.

