unit gp305;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, ComCtrls, parser10;

type
  TGP305Form = class(TForm)
    Memo1: TMemo;
    FreqRG: TRadioGroup;
    signalRG: TRadioGroup;
    FreqTB: TTrackBar;
    FreqLabel: TLabel;
    PanelArbitraire: TPanel;
    ExpressionEdit: TLabeledEdit;
    intervalTB: TTrackBar;
    Timer: TTimer;
    PeriodeLabel: TLabel;
    OnOffCB: TCheckBox;
    procedure FreqTBChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure intervalTBChange(Sender: TObject);
    procedure OnoffBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    frequence : double;
    t : integer;
    ParserI : Tparser;
    IndiceParser : PParserFloat;
  public
  end;

var
  GP305Form: TGP305Form;

implementation

uses GtsUtil, GTSMAIN;

const nombre = 256;

{$R *.dfm}

procedure TGP305Form.FreqTBChange(Sender: TObject);
var ordre : shortString;
begin
    frequence := 5+495*freqTB.position/256;
    ordre := 'SA0='+intToStr(freqTB.position);
    if freqTB.position<100 then ordre := ordre+' ';
    if freqTB.position<10 then ordre := ordre+' ';
    ordre := ordre+' ; f=';
    case freqRG.itemIndex of
         0 : begin
             frequence := frequence/100;
             ordre := ordre+FloatToStrF(frequence,ffFixed,precisionGTS,1)+' ';
         end;
         1 : ordre := ordre+FloatToStrF(frequence,ffFixed,precisionGTS,1)+' ';
         2 : begin
            frequence := frequence*100;
            ordre := ordre+FloatToStrF(frequence/1000,ffFixed,precisionGTS,1)+' k';
         end;
    end;
    freqLabel.caption := ordre+'Hz';
    GTSmainForm.EcritOrphy('WDAC 0 '+IntToStr(freqTB.Position));
end;

procedure TGP305Form.FormCreate(Sender: TObject);
begin
     ParserI := Tparser.create(nil);
     IndiceParser := ParserI.SetVariable('t',0);
     ParserI.expression := 't*255';
     ExpressionEdit.text := ParserI.expression;
end;

procedure TGP305Form.TimerTimer(Sender: TObject);
var valeurR : integer;
begin
    inc(t);
    if t>nombre then t := 0;
    IndiceParser^ := t/nombre;
    valeurR := round(ParserI.Value);
    if valeurR>255 then valeurR := 255;
    if valeurR<0 then valeurR := 0;
    FreqTB.position := valeurR;
end;

procedure TGP305Form.intervalTBChange(Sender: TObject);
begin
    timer.interval := intervalTB.position*55;
    periodeLabel.caption := 'Priode '+IntToStr(round(timer.interval*256/1000))+' s';
end;

procedure TGP305Form.OnoffBtnClick(Sender: TObject);
var ordre : integer;
    tr : string;
begin
  timer.Enabled := OnOffCB.checked;
  tr := ExpressionEdit.text;
  trimComplet(tr);
  ParserI.expression := tr;
  ordre := 16; // marche bit 4
  case freqrg.ItemIndex of
       0 : ordre := ordre+1;
       1 : ordre := ordre+1+2;
       2 : ordre := ordre+2;
  end;
  case signalrg.ItemIndex of
       0 : ordre := ordre+4;
       1 : ordre := ordre+8+4;
       2 : ordre := ordre+8;
  end;
  GTSmainForm.EcritOrphy('WSBLOC '+IntToStr(ordre));
end;

procedure TGP305Form.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   timer.Enabled := false;
end;

end.
