unit gti2_dynamique;
{    This C DLL header file first (automatic) conversion generated by:     }
{    HeadConv 4.0 (c) 2000 by Bob Swart (aka Dr.Bob - www.drbob42.com)     }
{      Final Delphi-Jedi (Darth) command-line units edition                }
{    Generated Date: 02/02/2006                                            }

interface

uses Windows,SysUtils;

//****************************************
// Structure de Communication
//**************************************               

const
  NbreMaxGBF = 16000;
  MaxDataGTI = 256;
  MaxDataRS232 = 512;
  MaxDataGet = 252; // ??

type
  DATA_GTI = record
    lDataLen1: LongInt;
    lDataLen2: LongInt;
    lDataLen3: LongInt;
    lDataLen4: LongInt;
    bBufferIn1: Array[0..MaxDataGTI-1] of LongInt;
    bBufferIn2: Array[0..MaxDataGTI-1] of LongInt;
    bBufferIn3: Array[0..MaxDataGTI-1] of LongInt;
    bBufferIn4: Array[0..MaxDataGTI-1] of LongInt;
  end {_DATA_GTI};

  DATA_GENERATEUR = record
    NbreData: LongInt;
    BaseDeTemps: byte;
    Reload: LongInt;
    BufferOut: Array[0..NbreMaxGBF-1] of LongInt; //( -2147483648  2147483647 )
  end {_DATA_GENERATEUR};

  ACQUISITION_VOIE = record
    On: UCHAR;
    Calibre: UCHAR;
    Differentiel: UCHAR;
  end {_ACQUISITION_VOIE};

  ACQUISITION_TRIG = record
    TrigOn: UCHAR;
    PreTrigOn: UCHAR;
    FrontMontant: UCHAR;
    Valeur: LongInt;
  end {_ACQUISITION_TRIG};

  ACQUISITION_CONFIG = record
    BaseDeTemps: UCHAR;
    Reload: UCHAR;
    UnSurN: LongInt;
  end {_ACQUISITION_CONFIG};

  DATA_ACQUISITION = record
    Calibrage: UCHAR;
    Voie: Array[0..4-1] of ACQUISITION_VOIE;
    Config: ACQUISITION_CONFIG;
    Trig: ACQUISITION_TRIG;
  end {_DATA_ACQUISITION};

  TDATA_RS232 = record
  case boolean of
        true : (
           Buffer: Array[0..MaxDataRS232-1] of byte;
                );
        false : (
           BufferC: Array[0..MaxDataRS232-1] of AnsiChar;
               );
  end;

T_SetPortClose = function(hHandle: THandle): LongInt;cdecl;
T_SetPortOpen = function(strDeviceName: WideString): THandle;cdecl;
T_GetVersion = function(hHandle: THandle;strVersion: Pchar): LongInt;cdecl;
T_LanceTHREAD = function(hHandle: THandle): LongInt;cdecl;
T_StopTHREAD = function : LongInt;cdecl;
T_IsRunTHREAD  = function : LongInt;cdecl;
T_EmptyBuffer = function : LongInt;cdecl;
T_SendH8 = procedure(var pBuffer: Tdata_RS232;LenBuffer: LongInt);cdecl;
T_GetH8 = function(var pBuffer: Tdata_RS232;
                   LenBuffer: LongInt;UNICODE: BYTE): LongInt;cdecl;
T_GetLenH8 = function : LongInt;cdecl;
// T_StopAcquiLENTE = function : LongInt;cdecl;
T_LanceGenerateur = function(hHandle: THandle;
                             Loop: Uchar;
                             var Ptransfer: DATA_GENERATEUR): LongInt;cdecl;
T_StopGenerateur = function(hHandle: THandle): LongInt;cdecl;
T_ChangeVitesse = function(hHandle: THandle;Vitesse : byte): longInt; cdecl;

var

_SetPortClose : T_SetPortClose;
_SetPortOpen : T_SetPortOpen;
_GetVersion : T_GetVersion;
_LanceTHREAD : T_LanceTHREAD;
_StopTHREAD : T_StopTHREAD;
_IsRunTHREAD : T_IsRunTHREAD;
_EmptyBuffer : T_EmptyBuffer;
_SendH8 : T_SendH8;
_GetH8 : T_GetH8;
_GetLenH8 : T_GetLenH8;                         
// _StopAcquiLENTE : T_StopAcquiLENTE;
_LanceGenerateur : T_LanceGenerateur;
_StopGenerateur : T_StopGenerateur;
_ChangeVitesse : T_ChangeVitesse;

GTI2Permis : boolean;

implementation

var
  Handle: THandle;
  fichierDLL : string;

initialization                          
  fichierDLL := ExtractFilePath((paramStr(0)))+'GtiCommX.DLL';
  GTI2permis    := FileExists(fichierDLL);
  if gti2Permis then begin                      
     Handle := LoadLibrary('GTICOMMX.DLL');
     GTI2Permis := Handle <> 0;
     if gti2Permis then begin
     @_SetPortClose := GetProcAddress(Handle,'_SetPortClose');
     @_SetPortOpen := GetProcAddress(Handle,'_SetPortOpen');
     @_GetVersion := GetProcAddress(Handle,'_GetVersion');
     @_LanceTHREAD := GetProcAddress(Handle,'_LanceTHREAD');
     @_StopTHREAD := GetProcAddress(Handle,'_StopTHREAD');
     @_IsRunTHREAD := GetProcAddress(Handle,'_IsRunTHREAD');
     @_EmptyBuffer := GetProcAddress(Handle,'_EmptyBuffer');
     @_SendH8 := GetProcAddress(Handle,'_SendH8');
     @_GetH8 := GetProcAddress(Handle,'_GetH8');
     @_GetLenH8 := GetProcAddress(Handle,'_GetLenH8');
//     @_StopAcquiLENTE := GetProcAddress(Handle,'_StopAcquiLENTE');
     @_LanceGenerateur := GetProcAddress(Handle,'_LanceGenerateur');
     @_StopGenerateur := GetProcAddress(Handle,'_StopGenerateur');
     @_ChangeVitesse := GetProcAddress(Handle,'_ChangeVitesse');     
     end;
  end;

finalization
  if Handle <> 0 then FreeLibrary(Handle);
  
end.


