unit lumicolorU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, graphe, constgts, ComCtrls,
  maths, gtsutil, gtsdef, gtsmain, aidegts2;

type
  TlumicolorDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Timer: TTimer;
    OKbtn: TSpeedButton;
    GaugeInter1: TProgressBar;
    MemoPhoto: TMemo;
    TensionLabel: TLabel;
    AbsLabel: TLabel;
    dinRG: TRadioGroup;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
    procedure dinRGClick(Sender: TObject);
  private
  public
    voieCourante : Tvoie;
  end;

var
  lumicolorDlg: TlumicolorDlg;

implementation

{$R *.DFM}

procedure TlumicolorDlg.TimerTimer(Sender: TObject);
var zi : integer;
begin
     zi := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
     GaugeInter1.position := zi;
     tensionLabel.caption := 'V='+tension.formatUnite(voieCourante.ValeurVolt(zi));
     voieCourante.valeurAff := voieCourante.valeurReal(zi);
     absLabel.caption := 'A='+voieCourante.AffVoltmetre;
end;

procedure TlumicolorDlg.dinRGClick(Sender: TObject);
begin
    case dinRG.itemIndex of
         0 : voieCourante.numOrphy := 0;
         1 : voieCourante.numOrphy := 4;
         2 : voieCourante.numOrphy := 6;
         3 : voieCourante.numOrphy := 2;
    end;
end;

procedure TlumicolorDlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
     timer.interval := MajTimerMilliSec;
     GaugeInter1.position := 0;
     timer.enabled := true;
     dinRG.visible := not isLumicolorDB15;
     if isLumicolor then begin
          GaugeInter1.Max := 9*HardMaxi div 20; // 4,5 V = 90/20
          if voieCourante.numOrphy=0 then dinRG.itemIndex := 0;
          if voieCourante.numOrphy=4  then dinRG.itemIndex := 1;
          if voieCourante.numOrphy=6 then dinRG.itemIndex := 2;
          if voieCourante.numOrphy=2 then dinRG.itemIndex := 3;
          if dinRG.itemIndex=-1 then begin
             dinRG.itemIndex := 0;
             voieCourante.numOrphy := 0;
          end;
     end;
     if isLumicolorDB15 then
          GaugeInter1.Max := HardMaxi div 5; // 2 V = 10/5
end end;

procedure TlumicolorDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TlumicolorDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TlumicolorDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Etalonnage)
end;

procedure TlumicolorDlg.OKbtnClick(Sender: TObject);
var valeurCan : double;
    valMax : double;
begin with voieCourante do begin
     try
     valeurCan := ValeurVolt(GaugeInter1.position);
     tensionRef := valeurCan;
     valMax := 1;
     if isLumicolor then valMax := 4.5;
     if isLumicolorDB15 then valMax := 2;
     if (valeurCan>=0) and (valeurCan<=valMax)
        then begin
           modalResult := mrOK;
           tensionRef := valeurCan
        end
        else begin
           afficheErreur(erPhotocolor);
           modalResult := mrNone;
        end;
     except
        modalResult := mrNone;
     end;
end end;

end.
