unit optPro;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, sysUtils, ComCtrls, Dialogs, FileCtrl, CheckLst, Spin,
  constGTS, gtsdef,  gtsutil, maths, aidegts2;

type
  TOptionsDlg = class(TForm)
    Panel1: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Label6: TLabel;
    VitesseComRG: TRadioGroup;
    RepertGTS2Aff: TEdit;
    RepertGTS2BTN: TSpeedButton;
    OpenDialog: TOpenDialog;
    Label4: TLabel;
    RepertRegressiAff: TEdit;
    RegressiBtn: TSpeedButton;
    RecoCB: TCheckBox;
    DerniereConfigCB: TCheckBox;
    RazRepDataBtn: TSpeedButton;
    SauveNumCB: TCheckBox;
    ConnectRG: TRadioGroup;
    VoiesUtilesCB: TCheckListBox;
    ToutModuleBtn: TBitBtn;
    AucunBtn: TBitBtn;
    DragCB: TCheckBox;
    Label5: TLabel;
    CardiaqueSE: TSpinEdit;
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RepertGTS2BTNClick(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure RazRepDataBtnClick(Sender: TObject);
    procedure ToutModuleBtnClick(Sender: TObject);
    procedure AucunBtnClick(Sender: TObject);
  private
  public
  end;

var
  OptionsDlg: TOptionsDlg;

implementation

uses Gtsmain, GTSDDE, graphe;

{$R *.DFM}

procedure TOptionsDlg.OKBtnClick(Sender: TObject);
var i : TvoieUtile;
begin with GtsMainForm do begin
    CfgGTSPath := repertGTS2aff.text;
    RepertoireRegressi := repertRegressiAff.text;
    DragPermis := dragCB.checked;
    vitesseCom := VitesseComRG.itemIndex;
    voiesUtiles := [];
    for I := low(TvoieUtile) to high(TvoieUtile) do
        if voiesUtilesCB.checked[ord(i)] then include(voiesUtiles,i);
    recoPermis := recoCB.checked;
    SauverConfig := DerniereConfigCB.checked;
    SauveNum := sauveNumCB.checked;
    connectiqueGTI2 := TconnectiqueGTI2(connectRG.itemIndex);
    NbreMoyCardiaque := cardiaqueSE.value;
    // InterpSinc := sincCB.checked;
end end;

procedure TOptionsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Index)
end;

procedure TOptionsDlg.AucunBtnClick(Sender: TObject);
var i : integer;
begin
     for i := 0 to pred(VoiesUtilesCB.items.Count) do
           VoiesUtilesCB.checked[I] := false;
end;

procedure TOptionsDlg.FormActivate(Sender: TObject);
var i : TvoieUtile;
begin with gtsMainForm do begin
    RepertGts2Aff.text := CfgGtsPath;
    RepertRegressiAff.text := RepertoireRegressi;
    VitesseComRG.itemIndex := vitesseCom;
    for I := low(TvoieUtile) to high(TvoieUtile) do
        voiesUtilesCB.checked[ord(i)] := i in voiesUtiles;
    recoCB.checked := recoPermis;
    DerniereConfigCB.checked := SauverConfig;
    sauveNumCB.checked := SauveNum;
    connectRG.itemIndex := ord(connectiqueGTI2);
    dragCB.checked := DragPermis;
    cardiaqueSE.MaxValue := MaxMoyCardiaque;
    cardiaqueSE.MinValue := MaxMoyCardiaque div 10;
    cardiaqueSE.value := NbreMoyCardiaque;
//    sincCB.checked := InterpSinc;
end end;

procedure TOptionsDlg.ToutModuleBtnClick(Sender: TObject);
var i : integer;
begin
     for i := 0 to pred(VoiesUtilesCB.items.Count) do
           VoiesUtilesCB.checked[I] := true;
end;

procedure TOptionsDlg.RepertGTS2BTNClick(Sender: TObject);
var repertoire : string;
begin
   repertoire := GtsMainForm.CfgGTSPath;
   if SelectDirectory('Rpertoire *.GT2','',repertoire) then
        RepertGTS2Aff.text := repertoire
end;

procedure TOptionsDlg.RazRepDataBtnClick(Sender: TObject);
begin
     RepertRegressiAff.Text := '';
end;

procedure TOptionsDlg.RegressiBtnClick(Sender: TObject);
var Dir : String;
begin
   dir := RepertoireRegressi;
   if selectDirectory(Dir,[sdAllowCreate, sdPerformCreate, sdPrompt],0)
       then RepertRegressiAff.text := Dir
       else RepertRegressiAff.text := '';
   RepertoireRegressi := Dir;
   FormDDE.MajRegressi;
end;

end.
