unit photocolorU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Sysutils, graphe, constgts, ComCtrls,
  maths, gtsutil, gtsdef, gtsmain, aidegts2;

type
  TphotocolorDlg = class(TForm)
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Timer: TTimer;
    OKbtn: TSpeedButton;
    GaugeInter1: TProgressBar;
    Memo1: TMemo;
    TensionLabel: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HelpBtnClick(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
  public
    voieCourante : Tvoie;
  end;

var
  photocolorDlg: TphotocolorDlg;

implementation

{$R *.DFM}

procedure TphotocolorDlg.TimerTimer(Sender: TObject);
var zi : integer;
begin
     zi := GtsMainForm.getInt('WEA '+voieCourante.codeVoie);
     GaugeInter1.position := zi;
     tensionLabel.caption := 'V='+tension.formatUnite(voieCourante.ValeurVolt(zi));
end;

procedure TphotocolorDlg.FormActivate(Sender: TObject);
begin with voieCourante do begin
     timer.interval := MajTimerMilliSec;
     GaugeInter1.position := 0;
     timer.enabled := true;
end end;

procedure TphotocolorDlg.FormDeactivate(Sender: TObject);
begin
    timer.enabled := false
end;

procedure TphotocolorDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    timer.enabled := false
end;

procedure TphotocolorDlg.HelpBtnClick(Sender: TObject);
begin
    Application.HelpContext(HELP_Etalonnage)
end;

procedure TphotocolorDlg.OKbtnClick(Sender: TObject);
var valeurCan : double;
begin
     try
     valeurCan := voieCourante.ValeurVolt(GaugeInter1.position);
     voieCourante.tensionRef := valeurCan;
     if (valeurCan>=0) and (valeurCan<=0.2)
        then begin
           modalResult := mrOK;
           voieCourante.tensionRef := valeurCan
        end
        else begin
           afficheErreur(erPhotocolor);
           modalResult := mrNone;
        end;
     except
        modalResult := mrNone;
     end;
end;

procedure TphotocolorDlg.CancelBtnClick(Sender: TObject);
begin
     voieCourante.tensionRef := 0.1
end;

end.
