unit voieCalcCfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, Dialogs, ImgList, ComCtrls,
  gtsUtil, gtsDef, graphe, gtsmain, maths, 
  constgts, gbf_syntaxe, aidegts2;

type
  TvoieCalcDlg = class(TForm)
    OKBtn: TBitBtn;
    GrandeurGB: TGroupBox;
    EditNom: TEdit;
    EditUnite: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    DesactiveBtn: TBitBtn;
    EtalonnageGB: TGroupBox;
    HelpBtn: TBitBtn;
    ImagePoint: TImageList;
    EditSignif: TEdit;
    Label3: TLabel;
    AffichageGB: TGroupBox;
    CouleurCombo: TColorBox;
    LabelAide: TLabel;
    ExpressionEdit: TLabeledEdit;
    EditMini: TLabeledEdit;
    EditMaxi: TLabeledEdit;
    PointCombo: TComboBoxEx;
    Memo1: TMemo;
    AideBtn: TSpeedButton;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure DesactiveBtnClick(Sender: TObject);
    procedure EditNomChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure EditNomKeyPress(Sender: TObject; var Key: Char);
    procedure EditMiniKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMaxiKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditMiniExit(Sender: TObject);
    procedure EditMaxiKeyPress(Sender: TObject; var Key: Char);
    procedure EditMiniKeyPress(Sender: TObject; var Key: Char);
    procedure ExpressionEditExit(Sender: TObject);
    procedure ExpressionEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AideBtnClick(Sender: TObject);
  private
    oldActive : boolean;
  public
    modif : boolean;
  end;

var
  voieCalcDlg: TvoieCalcDlg;

implementation

{$R *.DFM}

procedure TvoieCalcDlg.FormActivate(Sender: TObject);
begin with voieCalculee do begin
          EditNom.text := Nom;
          EditUnite.text := NomUnite;
          EditSignif.text := Signif;
          LabelAide.caption := Aide;
          oldActive := active;
          caption := 'Grandeur calcule';
          CouleurCombo.selected := couleur;
          PointCombo.itemIndex := ord(motif);
          EditMini.text := FormatGTS(mini);
          EditMaxi.text := FormatGTS(maxi);
          ExpressionEdit.text := expression;
          // setNomVoies;
          modif := false;
end end;

procedure TvoieCalcDlg.OKBtnClick(Sender: TObject);
begin
     modif := modif or not oldActive;
     with voieCalculee do begin
          active := expressionEdit.text<>'';
          Nom := EditNom.text;
          NomUnite := EditUnite.text;
          Signif := EditSignif.text;
          maxi := GetFloat(EditMaxi.text);
          if (maxi=sansSignif) then maxi := 10;
          mini := GetFloat(EditMini.text);
          if (mini=sansSignif) then mini := 10;
          setMinMax;
          couleur := CouleurCombo.selected;
          motif := Tmotif(PointCombo.itemIndex);
          expression := expressionEdit.text;
     end;
end;

procedure TvoieCalcDlg.AideBtnClick(Sender: TObject);
begin
  syntaxeDlg := TsyntaxeDlg.create(self);
  syntaxeDlg.showModal;
  syntaxeDlg.free;
end;

procedure TvoieCalcDlg.DesactiveBtnClick(Sender: TObject);
begin
      modif := modif or oldActive;
      voieCalculee.active := false;
end;

procedure TvoieCalcDlg.EditNomChange(Sender: TObject);
begin
     AffichageGB.caption := trAffichage+EditUnite.text+')';
     ExpressionEdit.EditLabel.caption := EditNom.Text+'=';
end;

procedure TvoieCalcDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_VoieCalculee)
end;

procedure TvoieCalcDlg.EditNomKeyPress(Sender: TObject; var Key: Char);
begin
     if not charInSet(key,majuscule+minuscule+toucheEdition) then key := #0
end;

procedure TvoieCalcDlg.EditMiniKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_down then editMaxi.setFocus;
end;

procedure TvoieCalcDlg.EditMaxiKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=vk_up then editMini.setFocus;
end;

procedure TvoieCalcDlg.EditMiniExit(Sender: TObject);
begin with voieCalculee do begin
     try
     mini := GetFloat(EditMini.text);
     maxi := GetFloat(EditMaxi.text);
     except
     end;
end end;

procedure TvoieCalcDlg.EditMaxiKeyPress(Sender: TObject; var Key: Char);
begin
   if key=crCR then EditMiniExit(sender)
end;

procedure TvoieCalcDlg.EditMiniKeyPress(Sender: TObject; var Key: Char);
begin
     if key=crCR then editMiniExit(sender)
end;

procedure TvoieCalcDlg.ExpressionEditExit(Sender: TObject);
begin
    voieCalculee.expression := expressionEdit.text
end;

procedure TvoieCalcDlg.ExpressionEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
    if key=vk_return then expressionEditExit(sender)
end;

end.

